Attribute VB_Name = "modMain"
Option Explicit

' --------------------------------------------
'
' --------------------------------------------
Private Const HWND_BOTTOM              As Long = 1&
Private Const HWND_TOP                 As Long = 0&
Private Const HWND_TOPMOST             As Long = -1&
Private Const HWND_NOTOPMOST           As Long = -2&

Private Const SWP_NOMOVE               As Long = &H2&
Private Const SWP_NOREDRAW             As Long = &H8&
Private Const SWP_NOSIZE               As Long = &H1&
Private Const SWP_SHOWWINDOW           As Long = &H40&

' ---------------------------------------------
' Used to set window On Top
' ---------------------------------------------
Private Declare Function SetWindowPos _
   Lib "user32" _
   (ByVal hWnd As Long, _
    ByVal hWndInsertAfter As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal cx As Long, _
    ByVal cy As Long, _
    ByVal wFlags As Long) As Long

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Sub SetOnTop
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/01/2000 -- 14:02:31
' Inputs       : ByVal xi_frmPassed:Form -
' Outputs      : N/A
' Description  : Set the current form on
'              :     top of all other forms
' Called By    :
' *******************************************************
Public Sub SetOnTop(ByVal xi_frmPassed As Form, _
                    Optional ByVal xi_blnOnTop As Boolean = True)
   Dim p_lngRtn                        As Long
   Dim p_lngFlags                      As Long
   Dim p_lngInsertPos                  As Long
   
   p_lngFlags = SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW
   
   If xi_blnOnTop = True Then
      p_lngRtn = SetWindowPos(xi_frmPassed.hWnd, _
                              HWND_TOPMOST, _
                              0&, 0&, 0&, 0&, _
                              p_lngFlags)
   Else
      p_lngRtn = SetWindowPos(xi_frmPassed.hWnd, _
                              HWND_NOTOPMOST, _
                              0&, 0&, 0&, 0&, _
                              p_lngFlags)
   End If
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Sub CenterForm
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/01/2000 -- 14:02:11
' Inputs       : ByVal xi_frmPassed:Form -
' Outputs      : N/A
' Description  : Center the passed form on screen
'              : (Top is 2/5's of the way down -- looks
'              :  better than pure centering)
' Called By    :
' *******************************************************
Public Sub CenterForm(ByVal xi_frmPassed As Form)
On Error Resume Next                   ' Don't accept an error here
   Dim p_dblTop                        As Double
   Dim p_dblLeft                       As Double
   Dim p_dblWidth                      As Double
   Dim p_dblHeight                     As Double
   Dim p_dblScrWidth                   As Double
   Dim p_dblScrHeight                  As Double
      
   p_dblScrWidth = Screen.Width
   p_dblScrHeight = Screen.Height
   
   p_dblWidth = xi_frmPassed.Width
   p_dblHeight = xi_frmPassed.Height
   
   p_dblLeft = (p_dblScrWidth - p_dblWidth) / 2
   p_dblTop = ((p_dblScrHeight - p_dblHeight) / 5) * 2
   
   xi_frmPassed.Move p_dblLeft, p_dblTop, _
                     p_dblWidth, p_dblHeight

End Sub
