Attribute VB_Name = "modGetOS"
Option Explicit

Private Declare Function GetVersionEx _
   Lib "KERNEL32" Alias "GetVersionExA" _
   (lpVersionInformation As OSVERSIONINFO) As Long
Private Type OSVERSIONINFO
   dwOSVersionInfoSize                 As Long
   dwMajorVersion                      As Long
   dwMinorVersion                      As Long
   dwBuildNumber                       As Long
   dwPlatformId                        As Long
   szCSDVersion                        As String * 128
End Type

Private Enum enmPlatform
   VER_PLATFORM_UNKNOWN = -1&
   VER_PLATFORM_WIN32s = 0&
   VER_PLATFORM_WIN32_NT = 2&
   VER_PLATFORM_WIN32_WINDOWS = 1&
End Enum

Public Function IsWin9x() As Boolean
   Dim p_typVerInfo                    As OSVERSIONINFO
   Dim p_lngMajorVer                   As Long
   Dim p_lngMinorVer                   As Long
   Dim p_intBuildNum                   As Integer
   
   ' ------------------------------------------
   ' Set the length and make API call
   ' ------------------------------------------
   p_typVerInfo.dwOSVersionInfoSize = Len(p_typVerInfo)
   GetVersionEx p_typVerInfo
   
   ' ------------------------------------------
   ' Get the details
   ' ------------------------------------------
   p_lngMajorVer = p_typVerInfo.dwMajorVersion
   p_lngMinorVer = p_typVerInfo.dwMinorVersion
   p_intBuildNum = WordLow(p_typVerInfo.dwBuildNumber)
   
   If p_typVerInfo.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS Then
      IsWin9x = True
   Else
      IsWin9x = False
   End If
   
End Function

Public Function IsNT40_Plus() As Boolean
   Dim p_typVerInfo                    As OSVERSIONINFO
   Dim p_lngMajorVer                   As Long
   Dim p_lngMinorVer                   As Long
   Dim p_intBuildNum                   As Integer
   
   ' ------------------------------------------
   ' Set the length and make API call
   ' ------------------------------------------
   p_typVerInfo.dwOSVersionInfoSize = Len(p_typVerInfo)
   GetVersionEx p_typVerInfo
   
   ' ------------------------------------------
   ' Get the details
   ' ------------------------------------------
   p_lngMajorVer = p_typVerInfo.dwMajorVersion
   p_lngMinorVer = p_typVerInfo.dwMinorVersion
   p_intBuildNum = WordLow(p_typVerInfo.dwBuildNumber)
   
   If p_lngMajorVer >= 4 Then
      IsNT40_Plus = True
   Else
      IsNT40_Plus = False
   End If
   
End Function

Private Function WordLow(ByVal xi_lngInput As Long) As Integer
   
   If (xi_lngInput And &HFFFF&) > &H7FFF Then
      WordLow = (xi_lngInput And &HFFFF&) - &H10000
   Else
      WordLow = xi_lngInput And &HFFFF&
   End If
   
End Function
