VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cNetCalls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' ************************************************************
' Copyright  1995-2001 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the VBPJ site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************

' ---------------------------------------------
' Module    : modNetCommon.BAS
' By        : L.J. Johnson       Date: 09-23-2001
' Comments  : User doesn't have to worry about
'           :     whether they are running NT or Win9x
'           : Class will determine OS, then
'           :     insubstantiate either cNet_NT
'           :     or cNetWin9x.
'           : Both of these classes have identical
'           :     public functions.
'           : NOTE: No error trapping -- all
'           :       errors just percolate up to
'           :       the calling proc from
'           :       either cNet_NT or cNet_Win9x
' ---------------------------------------------
Option Explicit

Private objNetCalls                    As Object
Private m_enmOsType                    As enmValidOSs

' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' +++                          WNet... Functions
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Public Sub AddConnection2(ByVal Password As String, _
                          ByVal UserName As String, _
                          ByVal LocalName As String, _
                          ByVal RemoteName As String, _
                          Optional ByVal Persistent As Boolean = False)
                          
   objNetCalls.AddConnection2 xi_strPassword:=Password, _
                              xi_strUserName:=UserName, _
                              xi_strLocalName:=LocalName, _
                              xi_strRemoteName:=RemoteName, _
                              xi_blnPersistent:=Persistent

End Sub

Public Sub AddConnection3(ByVal Password As String, _
                          ByVal UserName As String, _
                          ByVal LocalName As String, _
                          ByVal RemoteName As String, _
                          ByVal HwndOwner As Long, _
                          Optional ByVal Persistent As Boolean = False)
                          
   objNetCalls.AddConnection3 xi_strPassword:=Password, _
                              xi_strUserName:=UserName, _
                              xi_strLocalName:=LocalName, _
                              xi_strRemoteName:=RemoteName, _
                              xi_lngHwndOwner:=HwndOwner, _
                              xi_blnPersistent:=Persistent
                              
End Sub

Public Sub CancelConnection(ByVal LocalName As String, _
                            ByVal ForceDisconnect As Boolean)

   objNetCalls.CancelConnection xi_strLocalName:=LocalName, _
                                xi_blnForceDisconnect:=ForceDisconnect
                                
End Sub

Public Sub CancelConnection2(ByVal LocalName As String, _
                             ByVal ForceDisconnect As Boolean)

   objNetCalls.CancelConnection2 xi_strLocalName:=LocalName, _
                                 xi_blnForceDisconnect:=ForceDisconnect
                                
End Sub

Public Sub ConnectDialog(ByVal HwndOwner As Long)
   
   objNetCalls.ConnectDialog xi_lngHwnd:=HwndOwner

End Sub

Public Sub DisconnectDialog(ByVal HwndOwner As Long)
   
   objNetCalls.DisconnectDialog xi_lngHwnd:=HwndOwner

End Sub

Public Function GetUniversalName(ByVal LocalPath As String, _
                                 ByVal NameInfoLevel As enmNameInfoLevel) As Variant
   
   GetUniversalName = objNetCalls.GetUniversalName(xi_strLocalPath:=LocalPath, _
                                                   xi_enmNameInfoLevel:=NameInfoLevel)
                                
End Function

Public Function GetUserName(ByVal DeviceName As String) As String
   
   GetUserName = objNetCalls.GetUserName(xi_strDeviceName:=DeviceName)

End Function

Public Function GetResourceName(ByVal DriveLetter As String) As String
   
   GetResourceName = objNetCalls.GetResourceName(xi_strDriveLetter:=DriveLetter)

End Function

Public Function EnumResources(ByVal ResourceType As enmResourceType) As Variant
   EnumResources = objNetCalls.EnumResources(xi_enmResourceType:=ResourceType)
End Function

Public Sub MapDrive(ByVal HwndOwner As Long, _
                    Optional ByVal LocalName As String = "", _
                    Optional ByVal RemoteName As String = "")
   
   objNetCalls.MapDrive xi_lngHwnd:=HwndOwner, _
                        xi_strLocalName:=LocalName, _
                        xi_strRemoteName:=RemoteName

End Sub

Public Sub UnmapDrive(ByVal HwndOwner As Long, _
                      ByVal LocalName As String)
                      
   objNetCalls.UnmapDrive xi_lngHwnd:=HwndOwner, _
                          xi_strLocalName:=LocalName

End Sub

Public Function GetNetInfo() As Variant
                      
   GetNetInfo = objNetCalls.GetNetInfo()

End Function

Public Function GetResInfo(ByVal RemoteName) As Variant
   
   GetResInfo = objNetCalls.GetResInfo(xi_strRemoteName:=RemoteName)

End Function

Public Function GetResParent(ByVal RemoteName As String) As Variant
   
   GetResParent = objNetCalls.GetResParent(xi_strRemoteName:=RemoteName)

End Function

Public Function UseConnection(ByVal HwndOwner As Long, _
                              ByVal RemoteName As String, _
                              ByVal UserID As String, _
                              ByVal PW As String, _
                              Optional ByVal LocalName As String = "") As String
                              
   UseConnection = objNetCalls.UseConnection(xi_lngHwnd:=HwndOwner, _
                                             xi_strRemoteName:=RemoteName, _
                                             xi_strUserID:=UserID, _
                                             xi_strPW:=PW)
                                           
End Function


' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' +++                           NET... Functions
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


Public Function EnumConnections(ByVal ServerName As String, _
                                ByVal Qualifier As String) As Variant
   
   EnumConnections = objNetCalls.EnumConnections(xi_strServerName:=ServerName, _
                                               xi_strQualifier:=Qualifier)

End Function

Public Function EnumFiles(ByVal ServerName As String) As Variant
   
   EnumFiles = objNetCalls.EnumFiles(xi_strServerName:=ServerName)

End Function

Public Function GetServerInfo(ByVal ServerName As String) As Variant
   
   GetServerInfo = objNetCalls.GetServerInfo(xi_strServerName:=ServerName)

End Function

Public Function EnumSessions(ByVal ServerName As String) As Variant
   
   EnumSessions = objNetCalls.EnumSessions(xi_strServerName:=ServerName)

End Function

Public Function EnumShares(ByVal ServerName As String) As Variant
   
   EnumShares = objNetCalls.EnumShares(xi_strServerName:=ServerName)

End Function

Public Function GetSessionInfo(ByVal ServerName As String, _
                               ByVal SessionName As String, _
                               ByVal UserName As String) As Variant
                          
   GetSessionInfo = objNetCalls.GetSessionInfo(xi_strServerName:=ServerName, _
                                               xi_strSessionName:=SessionName, _
                                               xi_strUserName:=UserName)
                              
End Function

Public Function GetNetShareInfo(ByVal ServerName As String, _
                                ByVal ShareName As String) As Variant
   
   GetNetShareInfo = objNetCalls.GetNetShareInfo(xi_strServerName:=ServerName, _
                                                 xi_strShareName:=ShareName)
                               
End Function

Public Sub AddShare(ByVal ServerName As String, _
                    ByVal ShareName As String, _
                    ByVal Path As String, _
                    ByVal Remark As String)
   
   objNetCalls.AddShare xi_strServerName:=ServerName, _
                        xi_strShareName:=ShareName, _
                        xi_strPath:=Path, _
                        xi_strRemark:=Remark

End Sub

Public Sub DeleteShare(ByVal ServerName As String, _
                       ByVal ShareName As String)
   
   objNetCalls.DeleteShare xi_strServerName:=ServerName, _
                           xi_strShareName:=ShareName
                           
End Sub

Public Sub CloseFile(ByVal FilePtr As Long, _
                     ByVal ServerName As String, _
                     ByVal FileName As String)
   
   objNetCalls.CloseFile xi_lngFilePtr:=FilePtr, _
                         xi_strServerName:=ServerName, _
                         xi_strFileName:=FileName

End Sub

Public Sub DeleteSession(ByVal UserName As String, _
                         ByVal ServerName As String, _
                         Optional ByVal MachineName As String = "")
   
   objNetCalls.DeleteSession xi_strUserName:=UserName, _
                             xi_strServerName:=ServerName, _
                             xi_strMachineName:=MachineName

                             
End Sub

Public Sub SetShareInfo(ByVal ServerName As String, _
                        ByVal ShareName As String, _
                        ByVal Remark As String)
                        
   objNetCalls.SetShareInfo xi_strServerName:=ServerName, _
                            xi_strShareName:=ShareName, _
                            xi_strRemark:=Remark
                            
End Sub

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub Class_Initialize
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 13:46:35
' Inputs       : N/A
' Outputs      : N/A
' Description  : Determine if the OS is NT+ or Win9x
'              : Use this info to determine which class
'              :     to insubstantiate (cNet_NT or cNet_Win9x)
' Called By    : *****
' *******************************************************
Private Sub Class_Initialize()
   Dim p_objGetOS                      As cOsVersion
   
   Set p_objGetOS = New cOsVersion
   
   m_enmOsType = p_objGetOS.TypeValidOS
   
   Select Case m_enmOsType
      Case Valid_Win95, _
           Valid_Win98, _
           Valid_WinME
         Set objNetCalls = New cNet_Win9x
      Case Valid_NT_Pre40, _
           Valid_NT40, _
           Valid_W2K, _
           Valid_XP
         Set objNetCalls = New cNet_NT
      Case Else
         ' Raise error -- invalid OS
   End Select
   
End Sub
