Attribute VB_Name = "modNetCommon"
' ************************************************************
' Copyright  1995-2001 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the VBPJ site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************

' ---------------------------------------------
' Module    : modNetCommon.BAS
' By        : L.J. Johnson       Date: 09-23-2001
' Comments  : Public constants, and translation
'           :     functions of API constants into
'           :     text strings
' ---------------------------------------------
Option Explicit

' ---------------------------------------------
' Specific error constants (not exposed from DLL)
' ---------------------------------------------
Public Const ERROR_ALREADY_ASSIGNED          As Long = 85
Public Const ERROR_DEVICE_ALREADY_REMEMBERED As Long = 1202
Public Const ERROR_CANCELLED                 As Long = 1223

' ---------------------------------------------
' Constants
' ---------------------------------------------
Public Const NERR_SUCCESS              As Long = 0&
Public Const NO_ERROR                  As Long = 0&
Public Const MAX_PREFERRED_LENGTH      As Long = -1
Public Const ERROR_MORE_DATA           As Long = 234&
Public Const ERROR_NO_MORE_ITEMS       As Long = 259&
Public Const MAX_RESOURCES             As Long = 256&
Public Const NOT_A_CONTAINER           As Long = -1&

Public Const SHI50F_RDONLY             As Long = &H1&
Public Const SHI50F_FULL               As Long = &H2&
Public Const SHI50F_PERSIST            As Long = &H100&
Public Const SHI50F_SYSTEM             As Long = &H200&

Public Const PARMNUM_ALL               As Integer = 0

Public Const RESOURCE_ENUM_ALL         As Long = &HFFFFFFFF  '&HFFFF&

Public Const CONNECT_UPDATE_PROFILE    As Long = &H1
Public Const CONNECT_UPDATE_RECENT     As Long = &H2
Public Const CONNECT_TEMPORARY         As Long = &H4
Public Const CONNECT_INTERACTIVE       As Long = &H8
Public Const CONNECT_PROMPT            As Long = &H10
Public Const CONNECT_NEED_DRIVE        As Long = &H20
' NT 4.0+ only
Public Const CONNECT_REFCOUNT          As Long = &H40
Public Const CONNECT_REDIRECT          As Long = &H80
Public Const CONNECT_LOCALDRIVE        As Long = &H100
Public Const CONNECT_CURRENT_MEDIA     As Long = &H200
Public Const CONNECT_DEFERRED          As Long = &H400
Public Const CONNECT_RESERVED          As Long = &HFF000000
' End NT 4.0+ only

Public Const CONNDLG_RO_PATH           As Long = &H1  ' Resource path should be read-only.
Public Const CONNDLG_CONN_POINT        As Long = &H2  ' Netware-style movable connection-point enabled.
Public Const CONNDLG_USE_MRU           As Long = &H4  ' Use MRU combobox
Public Const CONNDLG_HIDE_BOX          As Long = &H8  ' Hide persistent connect check box.
Public Const DISC_UPDATE_PROFILE       As Long = &H1  ' Remove persistent connection.
Public Const DISC_NO_FORCE             As Long = &H40 ' Don't force the disconnect if files are still open.
' -----------------------------------------------------------------
' * NOTE:  Set, at most, one of the below flags. If neither flag is
' *        set, then the persistence is set to whatever the user
' *        chose during a previous connection.
' -----------------------------------------------------------------
Public Const CONNDLG_PERSIST           As Long = &H10 ' Force persistent connection.
Public Const CONNDLG_NOT_PERSIST       As Long = &H20 ' Persistent not allowed.

' ---------------------------------------------
' Windows 9x constants
' ---------------------------------------------
Public Const LM20_NNLEN                As Integer = 12   ' // LM 2.0 Net name length
Public Const SHPWLEN                   As Integer = 8    ' // Share password length (bytes)
Public Const CNLEN                     As Integer = 15
Public Const NETINFO_DLL16             As Long = &H1     ' Provider running as 16 bit Winnet Driver */
Public Const NETINFO_DISKRED           As Long = &H4     ' Provider requires disk redirections to connect */
Public Const NETINFO_PRINTERRED        As Long = &H8     ' Provider requires printer redirections to connect */

' ---------------------------------------------
' PUBLIC Enumerations
' ---------------------------------------------
Public Enum enmServerType
   SV_TYPE_WORKSTATION = &H1&
   SV_TYPE_SERVER = &H2&
   SV_TYPE_SQLSERVER = &H4&
   SV_TYPE_DOMAIN_CTRL = &H8&
   SV_TYPE_DOMAIN_BAKCTRL = &H10&
   SV_TYPE_TIME_SOURCE = &H20
   SV_TYPE_AFP = &H40
   SV_TYPE_NOVELL = &H80&
   SV_TYPE_DOMAIN_MEMBER = &H100
   SV_TYPE_PRINTQ_SERVER = &H200
   SV_TYPE_DIALIN_SERVER = &H400
   SV_TYPE_XENIX_SERVER = &H800
   SV_TYPE_SERVER_UNIX = &H800
   SV_TYPE_NT = &H1000&
   SV_TYPE_WFW = &H2000&
   SV_TYPE_SERVER_MFPN = &H4000
   SV_TYPE_SERVER_NT = &H8000&
   SV_TYPE_POTENTIAL_BROWSER = &H10000
   SV_TYPE_BACKUP_BROWSER = &H20000
   SV_TYPE_MASTER_BROWSER = &H40000
   SV_TYPE_DOMAIN_MASTER = &H80000
   SV_TYPE_SERVER_OSF = &H100000
   SV_TYPE_SERVER_VMS = &H200000
   SV_TYPE_WINDOWS = &H400000             ' Windows95 and above */
   SV_TYPE_DFS = &H800000                 ' Root of a DFS tree */
   SV_TYPE_CLUSTER_NT = &H1000000         ' NT Cluster */
   SV_TYPE_DCE = &H10000000               ' IBM DSS (Directory and Security Services) or equivalent */
   SV_TYPE_ALTERNATE_XPORT = &H20000000   ' return list for alternate transport */
   SV_TYPE_LOCAL_LIST_ONLY = &H40000000   ' Return local list only */
   SV_TYPE_DOMAIN_ENUM = &H80000000
   SV_TYPE_ALL = &HFFFF
End Enum

Public Enum enmUserFlags
   SESS_GUEST = 1&
   SESS_NOENCRYPTION = 2&
End Enum

Public Enum enmPermissions
   ACCESS_NONE = &H0
   ACCESS_READ = &H1&
   ACCESS_WRITE = &H2&
   ACCESS_CREATE = &H4&
   ACCESS_EXEC = &H8&
   ACCESS_DELETE = &H10&
   ACCESS_ATRIB = &H20&
   ACCESS_PERM = &H40&
   ACCESS_ALL = ACCESS_READ Or ACCESS_WRITE Or ACCESS_CREATE Or ACCESS_EXEC Or ACCESS_DELETE Or ACCESS_ATRIB Or ACCESS_PERM
End Enum

Public Enum enmShareType
   STYPE_DISKTREE = 0&
   STYPE_PRINTQ = 1&
   STYPE_DEVICE = 2&
   STYPE_IPC = 3&
   STYPE_SPECIAL = &H80000000
End Enum

Public Enum enmScope
   RESOURCE_CONNECTED = &H1&
   RESOURCE_GLOBALNET = &H2&
   RESOURCE_REMEMBERED = &H3&
   RESOURCE_RECENT = &H4&
   RESOURCE_CONTEXT = &H5&
   RESOURCE_UNKNOWN = &HFFFFFFFF
End Enum

Public Enum enmResType
   RESOURCETYPE_ANY = &H0&
   RESOURCETYPE_DISK = &H1&
   RESOURCETYPE_PRINT = &H2&
   RESOURCETYPE_RESERVED = &H8&
   RESOURCETYPE_UNKNOWN = &HFFFFFFFF
End Enum

Public Enum enmResDisplayType
   RESOURCEDISPLAYTYPE_GENERIC = &H0
   RESOURCEDISPLAYTYPE_DOMAIN = &H1
   RESOURCEDISPLAYTYPE_SERVER = &H2
   RESOURCEDISPLAYTYPE_SHARE = &H3
   RESOURCEDISPLAYTYPE_FILE = &H4
   RESOURCEDISPLAYTYPE_GROUP = &H5
   RESOURCEDISPLAYTYPE_UNKNOWN = &HFFFFFFFF
End Enum

Public Enum enmResourceUsage
   RESOURCEUSAGE_ZERO = &H0
   RESOURCEUSAGE_CONNECTABLE = &H1&
   RESOURCEUSAGE_CONTAINER = &H2&
   RESOURCEUSAGE_NOLOCALDEVICE = &H4&
   RESOURCEUSAGE_SIBLING = &H8&
   RESOURCEUSAGE_ATTACHED = &H10&
   RESOURCEUSAGE_RESERVED = &H80000000
   RESOURCEUSAGE_UNKNOWN = &HFFFFFFFF
   RESOURCEUSAGE_ALL = RESOURCEUSAGE_CONNECTABLE Or RESOURCEUSAGE_CONTAINER Or RESOURCEUSAGE_ATTACHED
End Enum

' ---------------------------------------------
' It looks like what actually comes back is the
'     low byte of the high word.
' See Karl Peterson's BitTwiddle example at
'     http://www.mvps.org/vb/code/Twiddle.zip
'     if you want to experiment further
' ---------------------------------------------
Public Enum enmNetTypeOrig
   WNNC_NET_MSNET = &H10000
   WNNC_NET_LANMAN = &H20000
   WNNC_NET_NETWARE = &H30000
   WNNC_NET_VINES = &H40000
   WNNC_NET_10NET = &H50000
   WNNC_NET_LOCUS = &H60000
   WNNC_NET_SUN_PC_NFS = &H70000
   WNNC_NET_LANSTEP = &H80000
   WNNC_NET_9TILES = &H90000
   WNNC_NET_LANTASTIC = &HA0000
   WNNC_NET_AS400 = &HB0000
   WNNC_NET_FTP_NFS = &HC0000
   WNNC_NET_PATHWORKS = &HD0000
   WNNC_NET_LIFENET = &HE0000
   WNNC_NET_POWERLAN = &HF0000
   WNNC_NET_BWNFS = &H100000
   WNNC_NET_COGENT = &H110000
   WNNC_NET_FARALLON = &H120000
   WNNC_NET_APPLETALK = &H130000
   WNNC_NET_INTERGRAPH = &H140000
   WNNC_NET_SYMFONET = &H150000
   WNNC_NET_CLEARCASE = &H160000
   WNNC_NET_FRONTIER = &H170000
   WNNC_NET_BMC = &H180000
   WNNC_NET_DCE = &H190000
   WNNC_NET_DECORB = &H200000
   WNNC_NET_PROTSTOR = &H210000
   WNNC_NET_FJ_REDIR = &H220000
   WNNC_NET_DISTINCT = &H230000
   WNNC_NET_TWINS = &H240000
   WNNC_NET_RDR2SAMPLE = &H250000
End Enum

Public Enum enmNetType
   WNNC_NET_MSNET = 1         '&H10000
   WNNC_NET_LANMAN = 2        '&H20000
   WNNC_NET_NETWARE = 3       '&H30000
   WNNC_NET_VINES = 4         '&H40000
   WNNC_NET_10NET = 5         '&H50000
   WNNC_NET_LOCUS = 6         '&H60000
   WNNC_NET_SUN_PC_NFS = 7    '&H70000
   WNNC_NET_LANSTEP = 8       '&H80000
   WNNC_NET_9TILES = 9        '&H90000
   WNNC_NET_LANTASTIC = 10    '&HA0000
   WNNC_NET_AS400 = 11        '&HB0000
   WNNC_NET_FTP_NFS = 12      '&HC0000
   WNNC_NET_PATHWORKS = 13    '&HD0000
   WNNC_NET_LIFENET = 14      '&HE0000
   WNNC_NET_POWERLAN = 15     '&HF0000
   WNNC_NET_BWNFS = 16        '&H100000
   WNNC_NET_COGENT = 17       '&H110000
   WNNC_NET_FARALLON = 18     '&H120000
   WNNC_NET_APPLETALK = 19    '&H130000
   WNNC_NET_INTERGRAPH = 20   '&H140000
   WNNC_NET_SYMFONET = 21     '&H150000
   WNNC_NET_CLEARCASE = 22    '&H160000
   WNNC_NET_FRONTIER = 23     '&H170000
   WNNC_NET_BMC = 24          '&H180000
   WNNC_NET_DCE = 25          '&H190000
   WNNC_NET_DECORB = 32       '&H200000
   WNNC_NET_PROTSTOR = 33     '&H210000
   WNNC_NET_FJ_REDIR = 34     '&H220000
   WNNC_NET_DISTINCT = 35     '&H230000
   WNNC_NET_TWINS = 36        '&H240000
   WNNC_NET_RDR2SAMPLE = 37   '&H250000
End Enum

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function PrepareServerName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 10/13/2001 -- 19:19:01
' Inputs       : ByVal xi_strServerName:String -
' Outputs      : String --
' Description  : Trim the passed name, and pre-pend two
'              :     backslashes if not present
' Called By    : *****
' *******************************************************
Public Function PrepareServerName(ByVal xi_strServerName As String) As String

   xi_strServerName = Trim$(xi_strServerName)
   
   If Len(Trim$(xi_strServerName)) = 0 Then
      PrepareServerName = vbNullString
   Else
      If Left$(xi_strServerName, 2) <> "\\" Then
         PrepareServerName = "\\" & xi_strServerName
      Else
         PrepareServerName = xi_strServerName
      End If
   End If
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TransDisplayType
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:21:10
' Inputs       : ByVal xi_enmPassed:enmResDisplayType -
' Outputs      : String --
' Description  : Translate the Resource Display Type
'              :     constants into text strings
' Called By    : *****
' *******************************************************
Public Function TransDisplayType(ByVal xi_enmPassed As enmResDisplayType) As String

   Select Case xi_enmPassed
      Case enmResDisplayType.RESOURCEDISPLAYTYPE_DOMAIN
         TransDisplayType = "Domain"
      Case enmResDisplayType.RESOURCEDISPLAYTYPE_SERVER
         TransDisplayType = "Server"
      Case enmResDisplayType.RESOURCEDISPLAYTYPE_SHARE
         TransDisplayType = "Share"
      Case enmResDisplayType.RESOURCEDISPLAYTYPE_GENERIC
         TransDisplayType = "Generic"
      Case enmResDisplayType.RESOURCEDISPLAYTYPE_UNKNOWN
         TransDisplayType = "UNKNOWN"
      Case Else
         TransDisplayType = "Unknown Display Type"
   End Select

End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TransScope
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:25:36
' Inputs       : ByVal xi_enmPassed:enmScope -
' Outputs      : String --
' Description  : Translate the Scope constants into
'              :     text strings
' Called By    : *****
' *******************************************************
Public Function TransScope(ByVal xi_enmPassed As enmScope) As String

   Select Case xi_enmPassed
      Case enmScope.RESOURCE_CONNECTED
         TransScope = "Recently connected"
      Case enmScope.RESOURCE_GLOBALNET
         TransScope = "All"
      Case enmScope.RESOURCE_REMEMBERED
         TransScope = "Persistent"
      Case enmScope.RESOURCE_RECENT
         TransScope = "Recent"
      Case enmScope.RESOURCE_CONTEXT
         TransScope = "In network context of user"
      Case enmScope.RESOURCE_UNKNOWN
         TransScope = "UNKNOWN"
      Case Else
         TransScope = "Unknown Scope"
   End Select

End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TransResType
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:26:25
' Inputs       : ByVal xi_enmPassed:enmResType -
' Outputs      : String --
' Description  : Translate the Resource Type
'              :     constants into text strings
' Called By    : *****
' *******************************************************
Public Function TransResType(ByVal xi_enmPassed As enmResType) As String

   Select Case xi_enmPassed
      Case enmResType.RESOURCETYPE_DISK
         TransResType = "Disk resource"
      Case enmResType.RESOURCETYPE_PRINT
         TransResType = "Print resource"
      Case enmResType.RESOURCETYPE_UNKNOWN
         TransResType = "UNKNOWN Resource"
      Case enmResType.RESOURCETYPE_RESERVED
         TransResType = "Reserved Resource"
      Case enmResType.RESOURCETYPE_ANY
         TransResType = "Type: Any"
      Case Else
         TransResType = "UNKNOWN"
   End Select
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TransShareType
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:26:53
' Inputs       : ByVal xi_enmConnType:enmShareType -
' Outputs      : String --
' Description  : Translate the Share Type constants
'              :     into text strings
' Called By    : *****
' *******************************************************
Public Function TransShareType(ByVal xi_enmConnType As enmShareType) As String

   Select Case xi_enmConnType
      Case enmShareType.STYPE_DEVICE
         TransShareType = "Communication device"
      Case enmShareType.STYPE_DISKTREE
         TransShareType = "Disk drive"
      Case enmShareType.STYPE_PRINTQ
         TransShareType = "Print Queue"
      Case enmShareType.STYPE_IPC
         TransShareType = "Interprocess communication"
      Case enmShareType.STYPE_SPECIAL
         TransShareType = "Special share reserved for interprocess communication"
      Case Else
         TransShareType = "UNKNOWN"
   End Select
      
End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TransServerType
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:27:34
' Inputs       : ByVal xi_enmServerType:enmServerType -
' Outputs      : String --
' Description  : Translate the Server Type constants
'              :     into text strings
' Called By    : *****
' *******************************************************
Public Function TransServerType(ByVal xi_enmServerType As enmServerType) As String
   Dim p_strTmp                        As String
   
   If xi_enmServerType And enmServerType.SV_TYPE_WORKSTATION Then
      p_strTmp = AddString(p_strTmp, "A LAN Manager workstation")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_SERVER Then
      p_strTmp = AddString(p_strTmp, "A LAN Manager server")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_SQLSERVER Then
      p_strTmp = AddString(p_strTmp, "Any server running with Microsoft SQL Server")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_DOMAIN_CTRL Then
      p_strTmp = AddString(p_strTmp, "Primary domain controller")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_DOMAIN_BAKCTRL Then
      p_strTmp = AddString(p_strTmp, "Backup domain controller")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_TIME_SOURCE Then
      p_strTmp = AddString(p_strTmp, "Server running the Timesource service")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_AFP Then
      p_strTmp = AddString(p_strTmp, "Apple File Protocol server")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_NOVELL Then
      p_strTmp = AddString(p_strTmp, "Novell server")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_DOMAIN_MEMBER Then
      p_strTmp = AddString(p_strTmp, "LAN Manager 2.x domain member")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_LOCAL_LIST_ONLY Then
      p_strTmp = AddString(p_strTmp, "Servers maintained by the browser")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_PRINTQ_SERVER Then
      p_strTmp = AddString(p_strTmp, "Server sharing print queue")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_DIALIN_SERVER Then
      p_strTmp = AddString(p_strTmp, "Server running dial-in service")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_XENIX_SERVER Then
      p_strTmp = AddString(p_strTmp, "Xenix server")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_SERVER_MFPN Then
      p_strTmp = AddString(p_strTmp, "Microsoft File and Print for NetWare")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_NT Then
      p_strTmp = AddString(p_strTmp, "Windows NT/Windows 2000 workstation or server")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_WFW Then
      p_strTmp = AddString(p_strTmp, "Server running Windows for Workgroups")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_SERVER_NT Then
      p_strTmp = AddString(p_strTmp, "Windows NT/Windows 2000 server that is not a domain controller")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_POTENTIAL_BROWSER Then
      p_strTmp = AddString(p_strTmp, "Server that can run the browser service")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_BACKUP_BROWSER Then
      p_strTmp = AddString(p_strTmp, "Server running a browser service as backup")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_MASTER_BROWSER Then
      p_strTmp = AddString(p_strTmp, "Server running the master browser service")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_DOMAIN_MASTER Then
      p_strTmp = AddString(p_strTmp, "Server running the domain master browser")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_DOMAIN_ENUM Then
      p_strTmp = AddString(p_strTmp, "Primary domain")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_WINDOWS Then
      p_strTmp = AddString(p_strTmp, "Windows 95 Or later")
   End If
   
   If xi_enmServerType And enmServerType.SV_TYPE_CLUSTER_NT Then
      p_strTmp = AddString(p_strTmp, "Server clusters available in the domain")
   End If
   
   If Len(Trim$(p_strTmp)) = 0 Then
      p_strTmp = AddString(p_strTmp, "Unknown")
   End If
   
   TransServerType = p_strTmp
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TransPermissions
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:28:10
' Inputs       : ByVal xi_lngPerm:enmPermissions -
' Outputs      : String --
' Description  : Translate the Permissions constants
'              :     into text strings
' Called By    : *****
' *******************************************************
Public Function TransPermissions(ByVal xi_lngPerm As enmPermissions) As String
   Dim p_strTmp                        As String
   
   If xi_lngPerm = -1 Then
      TransPermissions = "UNKNOWN"
      Exit Function
   End If
   
   If xi_lngPerm And enmPermissions.ACCESS_READ Then
      p_strTmp = AddString(p_strTmp, "Read/Execute.")
   End If
   
   If xi_lngPerm And enmPermissions.ACCESS_WRITE Then
      p_strTmp = AddString(p_strTmp, "Write.")
   End If

   If xi_lngPerm And enmPermissions.ACCESS_CREATE Then
      p_strTmp = AddString(p_strTmp, "Create")
   End If
   
   If xi_lngPerm And enmPermissions.ACCESS_EXEC Then
      p_strTmp = AddString(p_strTmp, "Execute")
   End If
   
   If xi_lngPerm And enmPermissions.ACCESS_DELETE Then
      p_strTmp = AddString(p_strTmp, "Delete")
   End If
   
   If xi_lngPerm And enmPermissions.ACCESS_ATRIB Then
      p_strTmp = AddString(p_strTmp, "Modify Attributes.")
   End If
 
   If xi_lngPerm And enmPermissions.ACCESS_PERM Then
      p_strTmp = AddString(p_strTmp, "Modify Permissions")
   End If
   
   'If xi_lngPerm And enmPermissions.ACCESS_ALL Then
   '   p_strTmp = AddString(p_strTmp, "Permission to read, write, create, execute, and delete resources, and to modify their attributes and permissions.")
   'End If
   
   If Len(Trim$(p_strTmp)) = 0 Then
      p_strTmp = AddString(p_strTmp, "NONE")
   End If
   
   TransPermissions = p_strTmp
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TransUserFlags
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:28:46
' Inputs       : ByVal xi_enmFlag:enmUserFlags -
' Outputs      : String --
' Description  : Translate the User Flags constants
'              :     into text strings
' Called By    : *****
' *******************************************************
Public Function TransUserFlags(ByVal xi_enmFlag As enmUserFlags) As String
   
   Select Case xi_enmFlag
      Case enmUserFlags.SESS_GUEST
         TransUserFlags = "The user specified by the sesi502_username member established the session using a guest account."
      Case enmUserFlags.SESS_NOENCRYPTION
         TransUserFlags = "The user specified by the sesi502_username member established the session without using password encryption."
      Case Else
         TransUserFlags = "No Flags"
   End Select
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TransResourceUsage
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:29:14
' Inputs       : ByVal xi_enmFlag:enmResourceUsage -
' Outputs      : String --
' Description  : Translate the Resource Usage
'              :     constants into text strings
' Called By    : *****
' *******************************************************
Public Function TransResourceUsage(ByVal xi_enmFlag As enmResourceUsage) As String
   Dim p_strTmp                        As String
   
   If xi_enmFlag = enmResourceUsage.RESOURCEUSAGE_UNKNOWN Then
      TransResourceUsage = "UNKNOWN"
      Exit Function
   End If
   
   If xi_enmFlag And enmResourceUsage.RESOURCEUSAGE_CONNECTABLE Then
      p_strTmp = AddString(p_strTmp, "Connectable")
   End If
   
   If xi_enmFlag And enmResourceUsage.RESOURCEUSAGE_CONTAINER Then
      p_strTmp = AddString(p_strTmp, "Container")
   End If
   
   If xi_enmFlag And enmResourceUsage.RESOURCEUSAGE_NOLOCALDEVICE Then
      p_strTmp = AddString(p_strTmp, "No Local Device")
   End If
   
   If xi_enmFlag And enmResourceUsage.RESOURCEUSAGE_SIBLING Then
      p_strTmp = AddString(p_strTmp, "Sibling")
   End If
   
   If xi_enmFlag And enmResourceUsage.RESOURCEUSAGE_ATTACHED Then
      p_strTmp = AddString(p_strTmp, "Attached")
   End If
   
   If xi_enmFlag And enmResourceUsage.RESOURCEUSAGE_RESERVED Then
      p_strTmp = AddString(p_strTmp, "Reserved")
   End If
   
   'If xi_enmFlag And enmResourceUsage.RESOURCEUSAGE_ALL Then
   '   p_strTmp = AddString(p_strTmp, "All")
   'End If
   
   If Len(Trim$(p_strTmp)) = 0 Then
      p_strTmp = AddString(p_strTmp, "Unknown")
   End If
   
   TransResourceUsage = p_strTmp
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TransNetInfoStatus
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:29:43
' Inputs       : ByVal xi_enmFlag:enmNetInfoStatus -
' Outputs      : String --
' Description  : Translate the Net Information Status
'              :     constants into text strings
' Called By    : *****
' *******************************************************
Public Function TransNetInfoStatus(ByVal xi_enmFlag As enmNetInfoStatus) As String

   Select Case xi_enmFlag
      Case enmNetInfoStatus.NO_ERROR2
         TransNetInfoStatus = "No Error"
      Case enmNetInfoStatus.ERROR_NO_NETWORK
         TransNetInfoStatus = "No Network"
      Case enmNetInfoStatus.ERROR_BUSY
         TransNetInfoStatus = "Network Busy"
      Case Else
         TransNetInfoStatus = "No Flags"
   End Select
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function TransNetType
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:30:14
' Inputs       : ByVal xi_enmFlag:enmNetType -
' Outputs      : String --
' Description  : Translate the Network Type constants
'              :     into text strings
' Called By    : *****
' *******************************************************
Public Function TransNetType(ByVal xi_enmFlag As enmNetType) As String

   Select Case xi_enmFlag
      Case enmNetType.WNNC_NET_MSNET
         TransNetType = "Microsoft Net"
      Case enmNetType.WNNC_NET_LANMAN
         TransNetType = "LAN Manager"
      Case enmNetType.WNNC_NET_NETWARE
         TransNetType = "Netware"
      Case enmNetType.WNNC_NET_VINES
         TransNetType = "Vines"
      Case enmNetType.WNNC_NET_10NET
         TransNetType = "10-Net"
      Case enmNetType.WNNC_NET_LOCUS
         TransNetType = "Locus"
      Case enmNetType.WNNC_NET_SUN_PC_NFS
         TransNetType = "PC NFS"
      Case enmNetType.WNNC_NET_LANSTEP
         TransNetType = "Lan Step"
      Case enmNetType.WNNC_NET_9TILES
         TransNetType = "9 Tiles"
      Case enmNetType.WNNC_NET_LANTASTIC
         TransNetType = "Lantastic"
      Case enmNetType.WNNC_NET_AS400
         TransNetType = "AS 400"
      Case enmNetType.WNNC_NET_FTP_NFS
         TransNetType = "NFS"
      Case enmNetType.WNNC_NET_PATHWORKS
         TransNetType = "Pathworks"
      Case enmNetType.WNNC_NET_LIFENET
         TransNetType = "LifeNet"
      Case enmNetType.WNNC_NET_POWERLAN
         TransNetType = "PowerLan"
      Case enmNetType.WNNC_NET_BWNFS
         TransNetType = "BW NFS"
      Case enmNetType.WNNC_NET_COGENT
         TransNetType = "Cogent"
      Case enmNetType.WNNC_NET_FARALLON
         TransNetType = "Farallon"
      Case enmNetType.WNNC_NET_APPLETALK
         TransNetType = "AppleTalk"
      Case enmNetType.WNNC_NET_INTERGRAPH
         TransNetType = "InterGraph"
      Case enmNetType.WNNC_NET_SYMFONET
         TransNetType = "SymfoNet"
      Case enmNetType.WNNC_NET_CLEARCASE
         TransNetType = "CleanCase"
      Case enmNetType.WNNC_NET_FRONTIER
         TransNetType = "Frontier"
      Case enmNetType.WNNC_NET_BMC
         TransNetType = "BMC"
      Case enmNetType.WNNC_NET_DCE
         TransNetType = "DCE"
      Case enmNetType.WNNC_NET_DECORB
         TransNetType = "DEC Orb"
      Case enmNetType.WNNC_NET_PROTSTOR
         TransNetType = "ProtStor"
      Case enmNetType.WNNC_NET_FJ_REDIR
         TransNetType = "FJ Redir"
      Case enmNetType.WNNC_NET_DISTINCT
         TransNetType = "Distinct"
      Case enmNetType.WNNC_NET_TWINS
         TransNetType = "Twins"
      Case Else
         TransNetType = "UNKNOWN"
   End Select
   
End Function

' *******************************************************
' Routine Name : (PRIVATE in MODULE) Function AddString
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 10:30:45
' Inputs       : ByVal xi_strPrior:String -
'              : ByVal xi_strNew:String -
' Outputs      : String --
' Description  : Concatenate a series of flags into a
'              :     single string separated by "|"
' Called By    : All public functions in this module
' *******************************************************
Private Function AddString(ByVal xi_strPrior As String, _
                           ByVal xi_strNew As String) As String
                           
   If Len(Trim$(xi_strPrior)) > 0 Then
      xi_strPrior = xi_strPrior & "|"
   End If
   
   AddString = xi_strPrior & xi_strNew

End Function
