VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cNet_NT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ************************************************************
' Copyright  1995-2001 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the VBPJ site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************

' ---------------------------------------------
' Module    : modNetCommon.BAS
' By        : L.J. Johnson       Date: 09-23-2001
' Comments  : All calls for NT+ systems for
'           :     the network calls
'           : Abstracted by cNetCalls.cls
' ---------------------------------------------
Option Explicit

' ---------------------------------------------
' Module-level vars
' ---------------------------------------------
Private m_blnNT40_Plus                 As Boolean
Private Const ERR_WRONG_CALL_LEVEL     As Long = 124&
Private Const CNST_NOT_AVAILABLE       As String = "N/A calling Win9x"
Private Const CNST_CANNOT_CALL_WIN9X   As String = "Cannot call a Win9x machine with this function"

Private Type WKSTA_INFO_102
   wki100_platform_id                  As Long
   pwki100_computername                As Long
   pwki100_langroup                    As Long
   wki100_ver_major                    As Long
   wki100_ver_minor                    As Long
   pwki102_lanroot                     As Long
   wki102_logged_on_users              As Long
End Type

Private Const PLATFORM_ID_DOS          As Long = 300
Private Const PLATFORM_ID_OS2          As Long = 400
Private Const PLATFORM_ID_NT           As Long = 500
Private Const PLATFORM_ID_OSF          As Long = 600
Private Const PLATFORM_ID_VMS          As Long = 700

Private Declare Function NetWkstaGetInfo _
   Lib "netapi32" _
   (ByVal ServerName As String, _
    ByVal level As Long, _
    lpBuf As Any) As Long

' ---------------------------------------------
' Net... FUNCTIONs
' ---------------------------------------------
' Used in EnumShares
Private Declare Function NetShareEnum _
   Lib "netapi32.dll" _
   (ServerName As Byte, _
    ByVal level As Long, _
    Buffer As Long, _
    ByVal PreMaxLen As Long, _
    EntriesRead As Long, _
    TotalEntries As Long, _
    Resume_Handle As Long) As Long
' Must check if a Win9x machine first!
' Used in GetNetShareInfo
Private Declare Function NetShareGetInfo _
   Lib "netapi32" _
   (ServerName As Byte, _
    Netname As Byte, _
    ByVal level As Long, _
    Buffer As Long) As Long
' Must check if a Win9x machine first!
' Used in SetShareInfo
Private Declare Function NetShareSetInfo _
   Lib "netapi32" _
   (ServerName As Byte, _
    Netname As Byte, _
    ByVal level As Long, _
    Buffer As Long, _
    ByVal parm_err As Long) As Long
' Must check if a Win9x machine first!
' Used in AddShare
Private Declare Function NetShareAdd _
   Lib "netapi32.dll" _
   (ByRef ServerName As Byte, _
    ByVal level As Long, _
    ByVal Buffer As Any, _
    ByVal parm_err As Long) As Long
' Must check if a Win9x machine first!
' Used in DeleteShare
Private Declare Function NetShareDel _
   Lib "netapi32.dll" _
   (ServerName As Byte, _
    Netname As Byte, _
    ByVal Reserved As Long) As Long
' Must check if a Win9x machine first!
' Used in EnumConnections
Private Declare Function NetConnectionEnum _
   Lib "netapi32" _
   (ServerName As Byte, _
    Qualifier As Byte, _
    ByVal level As Long, _
    BufferPtr As Long, _
    ByVal PrefMaxLen As Long, _
    EntriesRead As Long, _
    TotalEntries As Long, _
    Resume_Handle As Long) As Long
' Must check if a Win9x machine first!
' Used in EnumFiles
Private Declare Function NetFileEnum _
   Lib "netapi32" _
   (ServerName As Byte, _
    BasePath As Byte, _
    UserName As Byte, _
    ByVal level As Long, _
    BufferPtr As Long, _
    ByVal PrefMaxLen As Long, _
    EntriesRead As Long, _
    TotalLenEntries As Long, _
    ResumeHwnd As Long) As Long
' Must check if a Win9x machine first!
' Used in GetServerInfo
Private Declare Function NetServerGetInfo _
   Lib "netapi32" _
   (sServerName As Byte, _
    ByVal lLevel As Long, _
    vBuffer As Long) As Long
' Must check if a Win9x machine first!
' Used in EnumSessions
Private Declare Function NetSessionEnum _
   Lib "netapi32" _
   (ServerName As Byte, _
    UncClientName As Byte, _
    UserName As Byte, _
    ByVal level As Long, _
    BufferPtr As Long, _
    ByVal PrefMaxLen As Long, _
    EntriesRead As Long, _
    TotalEntries As Long, _
    Resume_Handle As Long) As Long
' Must check if a Win9x machine first!
' Used in GetSessionInfo
Private Declare Function NetSessionGetInfo _
   Lib "netapi32" _
   (ServerName As Byte, _
    UncClientName As Byte, _
    UserName As Byte, _
    ByVal level As Long, _
    BufferPtr As Long) As Long
' Must check if a Win9x machine first!
' Used in CloseFile
'NetFileClose2 (FileClose is NT only, FileClose2 is Win9x only)
Private Declare Function NetFileClose _
   Lib "netapi32" (ServerName As Byte, _
                   ByVal PtrFile As Long) As Long
' Must check if a Win9x machine first!
' Used in DeleteSession
Private Declare Function NetSessionDel _
   Lib "netapi32.dll" _
   (ServerName As Byte, _
    UncClientName As Byte, _
    UserName As Byte) As Long

' Used in many methods
Private Declare Function NetApiBufferFree _
   Lib "netapi32" _
   (ByVal Buffer As Long) As Long

' ---------------------------------------------
' Types for NT+
' ---------------------------------------------
Private Type SESSION_INFO_502
  sesi502_cname                        As Long
  sesi502_username                     As Long
  sesi502_num_opens                    As Long
  sesi502_time                         As Long
  sesi502_idle_time                    As Long
  sesi502_user_flags                   As Long
  sesi502_cltype_name                  As Long
  sesi502_transport                    As Long
End Type

Private Type SESSION_INFO_2
  sesi2_cname                          As Long
  sesi2_username                       As Long
  sesi2_num_opens                      As Long
  sesi2_time                           As Long
  sesi2_idle_time                      As Long
  sesi2_user_flags                     As Long
  sesi2_cltype_name                    As Long
End Type

Private Type SHARE_INFO_2
   shi2_netname                        As Long
   shi2_type                           As Long
   shi2_remark                         As Long
   shi2_permissions                    As Long
   shi2_max_uses                       As Long
   shi2_current_uses                   As Long
   shi2_path                           As Long
   shi2_passwd                         As Long
End Type
Private Type SHARE_INFO_1
   shi1_netname                        As Long
   shi1_type                           As Long
   shi1_remark                         As Long
End Type

Private Type SERVER_INFO_101
   sv101_platform_id                   As Long
   sv101_name                          As Long
   sv101_ver_major                     As Long
   sv101_ver_minor                     As Long
   sv101_type                          As Long
   sv101_comment                       As Long
End Type

Private Type CONNECTION_INFO_1
   coni1_id                            As Long
   coni1_type                          As Long
   coni1_num_opens                     As Long
   coni1_num_users                     As Long
   coni1_time                          As Long
   coni1_username                      As Long
   coni1_netname                       As Long
End Type

Private Type FILE_INFO_3
   fi3_id                              As Long
   fi3_permissions                     As Long
   fi3_num_locks                       As Long
   fi3_pathname                        As Long
   fi3_username                        As Long
End Type

' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' +++                          WNet... FUNCTIONs
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB AddConnection2
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:32:53
' Inputs       : ByVal xi_strPassword:String    - Password (can be blank)
'              : ByVal xi_strUserName:String    - UserID (can be blank)
'              : ByVal xi_strLocalName:String   - The local name of resource
'              : ByVal xi_strRemoteName:String  - The remote name of resource
'              : Optional ByVal xi_blnPersistent:Boolean = False - Do you make this a persistent connection?
' Outputs      : N/A
' Description  : Makes a connection to a network resource.
'              : The FUNCTION can redirect a local device
'              :     to the network resource.
' Called By    : cNetCalls.AddConnection2
' *******************************************************
Public Sub AddConnection2(ByVal xi_strPassword As String, _
                          ByVal xi_strUserName As String, _
                          ByVal xi_strLocalName As String, _
                          ByVal xi_strRemoteName As String, _
                          Optional ByVal xi_blnPersistent As Boolean = False)
   Const cnstProcName                  As String = "AddConnection2"
   
   modWNetCalls.AddConnection2 xi_strPassword:=xi_strPassword, _
                               xi_strUserName:=xi_strUserName, _
                               xi_strLocalName:=xi_strLocalName, _
                               xi_strRemoteName:=xi_strRemoteName, _
                               xi_blnIsWin9x:=False, _
                               xi_blnPersistent:=xi_blnPersistent
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB AddConnection3
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:35:26
' Inputs       : ByVal xi_strPassword:String    - Password (can be blank)
'              : ByVal xi_strUserName:String    - UserID (can be blank)
'              : ByVal xi_strLocalName:String   - The local name of resource
'              : ByVal xi_strRemoteName:String  - The remote name of resource
'              : ByVal xi_lngHwndOwner:Long     - Window which will own the dialog
'              : Optional ByVal xi_blnPersistent:Boolean = False - Do you make this a persistent connection?
' Outputs      : N/A
' Description  : Makes a connection to a network resource. The
'              :     FUNCTION can redirect a local device to
'              :     the network resource.
'              : The main difference is that WNetAddConnection3
'              :     has an additional parameter, a handle to a
'              :     window that the provider of network resources
'              :     can use as an owner window for dialog boxes.
' Called By    : cNetCalls.AddConnection3
' *******************************************************
Public Sub AddConnection3(ByVal xi_strPassword As String, _
                          ByVal xi_strUserName As String, _
                          ByVal xi_strLocalName As String, _
                          ByVal xi_strRemoteName As String, _
                          ByVal xi_lngHwndOwner As Long, _
                          Optional ByVal xi_blnPersistent As Boolean = False)
   Const cnstProcName                  As String = "AddConnection3"
   
   modWNetCalls.AddConnection3 xi_strPassword:=xi_strPassword, _
                               xi_strUserName:=xi_strUserName, _
                               xi_strLocalName:=xi_strLocalName, _
                               xi_strRemoteName:=xi_strRemoteName, _
                               xi_lngHwndOwner:=xi_lngHwndOwner, _
                               xi_blnIsWin9x:=False, _
                               xi_blnPersistent:=xi_blnPersistent
                               
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB CancelConnection
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:40:54
' Inputs       : ByVal xi_strLocalName:String        - Either a mapped drive or the remote name
'              : ByVal xi_blnForceDisconnect:Boolean - Whether or not to force the disconnection if there are open files
' Outputs      : N/A
' Description  : Cancels an existing network connection.
'              : The WNetCancelConnection FUNCTION is provided
'              :     for compatibility with 16-bit versions of
'              :     Windows.
'              : Win32-based applications should call the
'              :     WNetCancelConnection2 FUNCTION
' Called By    : cNetCalls.CancelConnection
' *******************************************************
Public Sub CancelConnection(ByVal xi_strLocalName As String, _
                            ByVal xi_blnForceDisconnect As Boolean)
   Const cnstProcName                  As String = "CancelConnection"
   
   modWNetCalls.CancelConnection xi_strLocalName:=xi_strLocalName, _
                                 xi_blnForceDisconnect:=xi_blnForceDisconnect, _
                                 xi_blnIsWin9x:=False
                                 
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB CancelConnection2
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:43:09
' Inputs       : ByVal xi_strLocalName:String        - Either a mapped drive or the remote name
'              : ByVal xi_blnForceDisconnect:Boolean - Whether or not to force the disconnection if there are open files
' Outputs      : N/A
' Description  : Cancels an existing network connection.
'              : You can also call the FUNCTION to remove
'              :     remembered network connections that
'              :     are not currently connected.
' Called By    : cNetCalls.CancelConnection2
' *******************************************************
Public Sub CancelConnection2(ByVal xi_strLocalName As String, _
                             ByVal xi_blnForceDisconnect As Boolean)
   Const cnstProcName                  As String = "CancelConnection2"
   
   modWNetCalls.CancelConnection2 xi_strLocalName:=xi_strLocalName, _
                                  xi_blnForceDisconnect:=xi_blnForceDisconnect, _
                                  xi_blnIsWin9x:=False
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB ConnectDialog
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:47:24
' Inputs       : ByVal xi_lngHwnd:Long - Handle to a form which acts as parent for dialog
' Outputs      : N/A
' Description  : Starts a general browsing dialog box for
'              :     connecting to network resources.
'              : The FUNCTION requires a handle to the
'              :     owner window for the dialog box.
' Called By    : cNetCalls.ConnectDialog
' *******************************************************
Public Sub ConnectDialog(ByVal xi_lngHwnd As Long)
   Const cnstProcName                  As String = "ConnectDialog"
   
   modWNetCalls.ConnectDialog xi_lngHwnd:=xi_lngHwnd, _
                              xi_blnIsWin9x:=False
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB DisconnectDialog
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:50:19
' Inputs       : ByVal xi_lngHwnd:Long - Handle to a form which acts as parent for dialog
' Outputs      : N/A
' Description  : Starts a general browsing dialog box for
'              :     disconnecting from network resources.
'              : The FUNCTION requires a handle to the
'              :     owner window for the dialog box.
' Called By    : cNetCalls
' *******************************************************
Public Sub DisconnectDialog(ByVal xi_lngHwnd As Long)
   Const cnstProcName                  As String = "DisconnectDialog"
   
   modWNetCalls.DisconnectDialog xi_lngHwnd:=xi_lngHwnd, _
                                 xi_blnIsWin9x:=False
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetUniversalName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:51:41
' Inputs       : ByVal xi_strLocalPath:String - Pointer to a constant null-terminated string that is a drive-based path for a network resource.
'              :                                For example, if drive H has been mapped to a network drive
'              :                                share, and the network resource of interest is a file named
'              :                                SAMPLE.DOC in the directory \WIN32\EXAMPLES on that share,
'              :                                the drive-based path is H:\WIN32\EXAMPLES\SAMPLE.DOC.
'              : ByVal xi_enmNameInfoLevel:enmNameInfoLevel - Either UNIVERSAL_NAME_INFO_LEVEL or REMOTE_NAME_INFO_LEVEL
' Outputs      : Variant:
' Description  : Takes a drive-based path for a network resource
'              :     and returns an information structure that
'              :     contains a more universal form of the name.
' Called By    : cNetCalls.GetUniversalName
' *******************************************************
Public Function GetUniversalName(ByVal xi_strLocalPath As String, _
                                 ByVal xi_enmNameInfoLevel As enmNameInfoLevel) As Variant
   Const cnstProcName                  As String = "GetUniversalName"

   GetUniversalName = modWNetCalls.GetUniversalName(xi_strLocalPath:=xi_strLocalPath, _
                                                    xi_enmNameInfoLevel:=xi_enmNameInfoLevel, _
                                                    xi_blnIsWin95:=False, _
                                                    xi_blnIsWin9x:=False)
                                 
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetUserName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:53:32
' Inputs       : ByVal xi_strDeviceName:String - Can be a drive letter or blank
' Outputs      : String --
' Description  : Retrieves the current default user name, or
'              :     the user name used to establish a
'              :     network connection.
'              : If this the xi_strDeviceName is NULL, the
'              :     system returns the name of the
'              :     current user for the process
' Called By    : cNetCalls.GetUserName
' *******************************************************
Public Function GetUserName(ByVal xi_strDeviceName As String) As String
   Const cnstProcName                  As String = "GetUserName"
   
   GetUserName = modWNetCalls.GetUserName(xi_strDeviceName:=xi_strDeviceName, _
                                          xi_blnIsWin9x:=False)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetResourceName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:57:08
' Inputs       : ByVal xi_strDriveLetter:String - A valid drive letter
' Outputs      : String --
' Description  : Retrieves the name of the network resource
'              :     associated with a local device.
' Called By    : cNetCalls.GetResourceName
' *******************************************************
Public Function GetResourceName(ByVal xi_strDriveLetter As String) As String
   Const cnstProcName                  As String = "GetResourceName"
   
   GetResourceName = modWNetCalls.GetResourceName(xi_strDriveLetter:=xi_strDriveLetter, _
                                                  xi_blnIsWin9x:=False)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumResources
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:58:35
' Inputs       : ByVal xi_enmResourceType:enmResourceType - Type of resource to filter for
' Outputs      : Variant --
' Description  : Enumerates the network resources or
'              :     existing connections.
' Called By    : cNetCalls.EnumResources
' *******************************************************
Public Function EnumResources(ByVal xi_enmResourceType As enmResourceType) As Variant
   Const cnstProcName                  As String = "EnumResources"
   
   EnumResources = modWNetCalls.EnumResources(xi_enmResourceType:=xi_enmResourceType, _
                                              xi_blnIsWin9x:=False)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB MapDrive
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:14:43
' Inputs       : ByVal xi_lngHwnd:Long                       - Handle to a form to act a parent for dialog
'              : Optional ByVal xi_strLocalName:String = ""  - Local name of resource (i.e., "H:")
'              : Optional ByVal xi_strRemoteName:String = "" - Remote name of resource (i.e., "\\MyServer\MyShare")
' Outputs      : N/A
' Description  : Brings up a general browsing dialog for
'              :     connecting to network resources.
'              : The FUNCTION requires a CONNECTDLGSTRUCT
'              :     to establish the dialog box parameters.
' Called By    : cNetCalls.MapDrive
' *******************************************************
Public Sub MapDrive(ByVal xi_lngHwnd As Long, _
                    Optional ByVal xi_strLocalName As String = "", _
                    Optional ByVal xi_strRemoteName As String = "")
   Const cnstProcName                  As String = "MapDrive"
   
   ' ------------------------------------------
   ' Check for NT version below 4.0
   ' ------------------------------------------
   If m_blnNT40_Plus = False Then
      Err.Raise Number:=enmCustErrors.Error_Wrong_Version + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="You must be running NT 4.0+ (or Win9x) in order to run this FUNCTION."
   End If
   
   modWNetCalls.MapDrive xi_lngHwnd:=xi_lngHwnd, _
                         xi_blnIsWin9x:=False, _
                         xi_strLocalName:=xi_strLocalName, _
                         xi_strRemoteName:=xi_strRemoteName

End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB UnmapDrive
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:16:29
' Inputs       : ByVal xi_lngHwnd:Long        - Handle to a form to act a parent for dialog
'              : ByVal xi_strLocalName:String - Local name of mapped drive (i.e., "H:")
' Outputs      : N/A
' Description  : Attempts to disconnect a network resource.
'              : If the underlying network returns ERROR_OPEN_FILES,
'              :     the FUNCTION prompts the user for confirmation.
'              : If there is any error, the FUNCTION informs
'              :     the user.
'              : The FUNCTION requires a DISCDLGSTRUCT to specify
'              :     the parameters for the disconnect attempt.
' Called By    : cNetCalls.UnmapDrive
' *******************************************************
Public Sub UnmapDrive(ByVal xi_lngHwnd As Long, _
                      ByVal xi_strLocalName As String)
   Const cnstProcName                  As String = "UnmapDrive"
   
   ' ------------------------------------------
   ' Check for NT version below 4.0
   ' ------------------------------------------
   If m_blnNT40_Plus = False Then
      Err.Raise Number:=enmCustErrors.Error_Wrong_Version + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="You must be running NT 4.0+ (or Win9x) in order to run this FUNCTION."
   End If
   
   modWNetCalls.UnmapDrive xi_lngHwnd:=xi_lngHwnd, _
                           xi_strLocalName:=xi_strLocalName, _
                           xi_blnIsWin9x:=False
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetNetInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:19:40
' Inputs       : N/A
' Outputs      : Variant:
' Description  : Obtains the provider name for a specific
'              :     type of network.
' Called By    : cNetCalls.GetNetInfo
' *******************************************************
Public Function GetNetInfo() As Variant
   Const cnstProcName                  As String = "GetNetInfo"
   
   ' ------------------------------------------
   ' Check for NT version below 4.0
   ' ------------------------------------------
   If m_blnNT40_Plus = False Then
      Err.Raise Number:=enmCustErrors.Error_Wrong_Version + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="You must be running NT 4.0+ (or Win9x) in order to run this FUNCTION."
   End If
   
   GetNetInfo = modWNetCalls.GetNetInfo(xi_blnIsWin9x:=False)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetResInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:20:54
' Inputs       : ByVal xi_strRemoteName:String - The Remote Name (i.e., "\\MyServer\MyShare")
' Outputs      : N/A
' Description  : When provided with a remote path to a network
'              :     resource, the WNetGetResourceInformation
'              :     FUNCTION identifies the network provider
'              :     that owns the resource and obtains
'              :     information about the type of the resource.
'              : The FUNCTION is typically used in conjunction
'              :     with the WNetGetResourceParent FUNCTION
'              :     to parse and interpret a network path
'              :     typed in by a user.
' Called By    : cNetCalls.GetResInfo
' *******************************************************
Public Function GetResInfo(ByVal xi_strRemoteName As String) As Variant
   Const cnstProcName                  As String = "GetResInfo"
   
   ' ------------------------------------------
   ' Check for NT version below 4.0
   ' ------------------------------------------
   If m_blnNT40_Plus = False Then
      Err.Raise Number:=enmCustErrors.Error_Wrong_Version + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="You must be running NT 4.0+ (or Win9x) in order to run this FUNCTION."
   End If
   
   GetResInfo = modWNetCalls.GetResInfo(xi_strRemoteName:=xi_strRemoteName, _
                                        xi_blnIsWin9x:=False)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB GetResParent
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:23:36
' Inputs       : ByVal xi_strRemoteName:String - The Remote Name (i.e., "\\MyServer\MyShare")
' Outputs      : Variant:
' Description  : The WNetGetResourceParent FUNCTION returns
'              :     the parent of a network resource in
'              :     the network browse hierarchy.
'              : Browsing begins at the location of the
'              :     specified network resource.
'              : Call the WNetGetResourceInformation and
'              :     WNetGetResourceParent FUNCTIONs to
'              :     move up the network hierarchy.
'              : Call the WNetOpenEnum FUNCTION to move
'              :     down the hierarchy.
' Called By    : cNetCalls.GetResParent
' *******************************************************
Public Function GetResParent(ByVal xi_strRemoteName As String) As Variant
   Const cnstProcName                  As String = "GetResParent"

   ' ------------------------------------------
   ' Check for NT version below 4.0
   ' ------------------------------------------
   If m_blnNT40_Plus = False Then
      Err.Raise Number:=enmCustErrors.Error_Wrong_Version + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="You must be running NT 4.0+ (or Win9x) in order to run this FUNCTION."
   End If
   
   GetResParent = modWNetCalls.GetResParent(xi_strRemoteName:=xi_strRemoteName, _
                                            xi_blnIsWin9x:=False)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION UseConnection
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:26:23
' Inputs       : ByVal xi_lngHwnd:Long         - Handle for window that will be parent for any dialogs
' Inputs       : ByVal xi_strRemoteName:String - The Remote Name (i.e., "\\MyServer\MyShare")
'              : ByVal xi_strUserID:String     - UserID
'              : ByVal xi_strPW:String         - Password for this userID
'              : Optional ByVal xi_strLocalName:String = "" - The Local Name (i.e., "H:")
' Outputs      : String --
' Description  : The WNetUseConnection FUNCTION makes a
'              :     connection to a network resource.
'              : The FUNCTION can redirect a local device
'              :     to a network resource.
'              : The WNetUseConnection FUNCTION is similar to the
'              :     WNetAddConnection3 FUNCTION. The main difference
'              :     is that WNetUseConnection can automatically
'              :     select an unused local device to redirect
'              :     to the network resource.
' Called By    : cNetCalls.UseConnection
' *******************************************************
Public Function UseConnection(ByVal xi_lngHwnd As Long, _
                              ByVal xi_strRemoteName As String, _
                              ByVal xi_strUserID As String, _
                              ByVal xi_strPW As String, _
                              Optional ByVal xi_strLocalName As String = "") As String
   Const cnstProcName                  As String = "UseConnection"

   ' ------------------------------------------
   ' Check for NT version below 4.0
   ' ------------------------------------------
   If m_blnNT40_Plus = False Then
      Err.Raise Number:=enmCustErrors.Error_Wrong_Version + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="You must be running NT 4.0+ (or Win9x) in order to run this FUNCTION."
   End If
   
   UseConnection = modWNetCalls.UseConnection(xi_lngHwnd:=xi_lngHwnd, _
                                              xi_strRemoteName:=xi_strRemoteName, _
                                              xi_strUserID:=xi_strUserID, _
                                              xi_strPW:=xi_strPW, _
                                              xi_blnIsWin9x:=False, _
                                              xi_strLocalName:=xi_strLocalName)

End Function


' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' +++                           NET... FUNCTIONs
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumConnections
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:32:15
' Inputs       : ByVal xi_strServerName:String - Name of server (can be blank)
'              : ByVal xi_strQualifier:String  - A share name or computer name
' Outputs      : Variant:
' Description  : Lists all connections made to a shared resource
'              :     on the server or all connections
'              :     established from a particular computer.
' Security     : Admin or server, print, or comm operator group
'              :     membership is required to successfully
'              :     execute the NetConnectionEnum FUNCTION.
' Called By    : cNetCalls.EnumConnections
' *******************************************************
Public Function EnumConnections(ByVal xi_strServerName As String, _
                                ByVal xi_strQualifier As String) As Variant
   Dim p_lngRtn                        As Long
   Dim p_lngPtrBuffer                  As Long
   Dim p_lngEntriesRead                As Long
   Dim p_lngTotalEntries               As Long
   Dim p_lngResumeHwnd                 As Long
   Dim p_lngLoop                       As Long
   Dim p_vntRtn                        As Variant
   Dim p_abytServerName()              As Byte
   Dim p_abytQualifier()               As Byte
   Dim p_strUserName                   As String
   Dim p_strNetName                    As String
   Dim p_atypConnInfo_1()              As CONNECTION_INFO_1
   Const cnstProcName                  As String = "EnumConnections"

   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   p_abytServerName = xi_strServerName & vbNullChar
   p_abytQualifier = xi_strQualifier & vbNullChar
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetConnectionEnum(ServerName:=p_abytServerName(0), _
                                Qualifier:=p_abytQualifier(0), _
                                level:=1, _
                                BufferPtr:=p_lngPtrBuffer, _
                                PrefMaxLen:=4096&, _
                                EntriesRead:=p_lngEntriesRead, _
                                TotalEntries:=p_lngTotalEntries, _
                                Resume_Handle:=p_lngResumeHwnd)
                           
   If p_lngRtn <> NERR_SUCCESS Then
      GoTo Err_Handler
   End If
   
   ' ------------------------------------------
   ' Exit if no entries found
   ' ------------------------------------------
   If p_lngEntriesRead < 1 Then
      GoTo Clean_Up
   End If
   
   ' ------------------------------------------
   ' Redim the type array to hold this info
   ' ------------------------------------------
   ReDim p_atypConnInfo_1(0 To p_lngEntriesRead - 1) As CONNECTION_INFO_1

   ' ------------------------------------------
   ' Copy the pointer to the buffer into the
   '     type array
   ' ------------------------------------------
   CopyMem p_atypConnInfo_1(0), _
           ByVal p_lngPtrBuffer, _
           Len(p_atypConnInfo_1(0)) * p_lngEntriesRead

   ' ------------------------------------------
   ' Fill-in the info needed to call the
   '     Add() method
   ' ------------------------------------------
   ReDim p_vntRtn(0 To 7, 0 To (p_lngEntriesRead - 1)) As Variant
   
   For p_lngLoop = 0 To p_lngEntriesRead - 1
      With p_atypConnInfo_1(p_lngLoop)
         p_strUserName = PointerToStringW(.coni1_username)
         p_strNetName = PointerToStringW(.coni1_netname)
      
         ' ---------------------------------------
         ' If not a user (remote connection), then
         '     give the net name
         ' ---------------------------------------
         If Len(p_strUserName) = 0 Then
            p_strUserName = p_strNetName
         End If
      
         p_vntRtn(enmNetConnections.UserName, p_lngLoop) = p_strUserName
         p_vntRtn(enmNetConnections.Netname, p_lngLoop) = xi_strQualifier
         
         p_vntRtn(enmNetConnections.ConnectID, p_lngLoop) = .coni1_id
         p_vntRtn(enmNetConnections.ConnectTime, p_lngLoop) = .coni1_time
         p_vntRtn(enmNetConnections.ConnectNumOpens, p_lngLoop) = .coni1_num_opens
         p_vntRtn(enmNetConnections.ConnectNumUses, p_lngLoop) = .coni1_num_users
         p_vntRtn(enmNetConnections.ConnectType, p_lngLoop) = .coni1_type
         p_vntRtn(enmNetConnections.ConnectTypeText, p_lngLoop) = TransShareType(.coni1_type)
         
      End With
      
      EnumConnections = p_vntRtn
      
   Next p_lngLoop
   
Clean_Up:
   ' ------------------------------------------
   ' Clean-up the buffer
   ' ------------------------------------------
   If p_lngPtrBuffer <> 0 Then
      NetApiBufferFree p_lngPtrBuffer
   End If
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetConnectionEnum, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumFiles
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:39:28
' Inputs       : ByVal xi_strServerName:String - Server name (can be blank)
' Outputs      : Variant
' Description  : Returns information about all open files on a server
' Security     : Only members of the Administrators or Account Operators
'              :     local group can successfully execute the
'              :     NetFileEnum FUNCTION.
' Called By    : cNetCalls.EnumFiles
' *******************************************************
Public Function EnumFiles(ByVal xi_strServerName As String) As Variant
   Dim p_lngRtn                        As Long
   Dim p_vntRtn                        As Variant
   Dim p_abytServerName()              As Byte
   Dim p_abytBasePath()                As Byte
   Dim p_abytUserName()                As Byte
   Dim p_lngPtrBuffer                  As Long
   Dim p_lngEntriesRead                As Long
   Dim p_lngTotalEntries               As Long
   Dim p_lngResumeHwnd                 As Long
   Dim p_lngLoop                       As Long
   Dim p_atypFileInfo_3()              As FILE_INFO_3
   Const cnstProcName                  As String = "EnumFiles"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   p_abytServerName = xi_strServerName & vbNullChar
   
   ' ------------------------------------------
   ' If this parameter is NULL, all open resources
   '     are enumerated.
   ' If this parameter is not NULL, the function
   '     enumerates only resources that have
   '     basepath as a prefix.
   ' (A prefix is the path component up to a backslash.)
   ' ------------------------------------------
   p_abytBasePath = vbNullChar
   
   ' ------------------------------------------
   ' If this parameter is specified, username
   '     serves as a qualifier for the enumeration.
   ' The files returned are limited to those that
   '     have user names matching the qualifier.
   ' If this parameter is NULL, no user-name
   '     qualifier is used.
   ' ------------------------------------------
   p_abytUserName = vbNullChar
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetFileEnum(ServerName:=p_abytServerName(0), _
                          BasePath:=p_abytBasePath(0), _
                          UserName:=p_abytUserName(0), _
                          level:=3, _
                          BufferPtr:=p_lngPtrBuffer, _
                          PrefMaxLen:=4096, _
                          EntriesRead:=p_lngEntriesRead, _
                          TotalLenEntries:=p_lngTotalEntries, _
                          ResumeHwnd:=p_lngResumeHwnd)
   If p_lngRtn <> NERR_SUCCESS Then
      GoTo Err_Handler
   End If
   
   ' ------------------------------------------
   ' Exit if no entries found
   ' ------------------------------------------
   If p_lngEntriesRead < 1 Then
      GoTo Clean_Up
   End If
   
   ' ------------------------------------------
   ' Redim the type array to hold this info
   ' ------------------------------------------
   ReDim p_atypFileInfo_3(0 To p_lngEntriesRead - 1) As FILE_INFO_3
         
   ' ------------------------------------------
   ' Copy the pointer to the buffer into the
   '     type array
   ' ------------------------------------------
   CopyMem p_atypFileInfo_3(0), _
           ByVal p_lngPtrBuffer, _
           Len(p_atypFileInfo_3(0)) * p_lngEntriesRead

   ' ------------------------------------------
   ' Fill-in the info needed to call the
   '     Add() method
   ' NOTE: We will always have +1 open pipe,
   '       since in making this call we create
   '       a pipe, "\PIPE\srvsvc"
   ' ------------------------------------------
   ReDim p_vntRtn(0 To 6, 0 To (p_lngEntriesRead - 1)) As Variant
   
   For p_lngLoop = 0 To p_lngEntriesRead - 1
      With p_atypFileInfo_3(p_lngLoop)
         p_vntRtn(enmFileEnum.PathName, p_lngLoop) = PointerToStringW(.fi3_pathname)
         p_vntRtn(enmFileEnum.UserName, p_lngLoop) = PointerToStringW(.fi3_username)
         p_vntRtn(enmFileEnum.ShareName, p_lngLoop) = vbNullString ' Available on 9x
         p_vntRtn(enmFileEnum.ID, p_lngLoop) = .fi3_id
         p_vntRtn(enmFileEnum.NumLocks, p_lngLoop) = .fi3_num_locks
         p_vntRtn(enmFileEnum.Permissions, p_lngLoop) = .fi3_permissions
         p_vntRtn(enmFileEnum.PermissionsText, p_lngLoop) = TransPermissions(.fi3_permissions)
      End With
      
   Next p_lngLoop
   
   EnumFiles = p_vntRtn
      
   ' ------------------------------------------
   ' Clean-up the buffer
   ' ------------------------------------------
Clean_Up:
   If p_lngPtrBuffer <> 0 Then
      NetApiBufferFree p_lngPtrBuffer
   End If
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetFileEnum, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetServerInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:42:10
' Inputs       : ByVal xi_strServerName:String - Name of server (can be blank)
' Outputs      : Variant:
' Description  : Retrieves current configuration
'              :     information for the specified server.
' Security     : Only the Administrators or Accounts
'              :     Operators local group, or those
'              :     with Communication, Print, or
'              :     Server operator group membership
'              :     can successfully execute the
'              :     NetServerGetInfo FUNCTION at level 102.
'              : No special group membership is required for
'              :     level 100 or level 101 calls.
' Called By    : cNetCalls.GetServerInfo
' *******************************************************
Public Function GetServerInfo(ByVal xi_strServerName As String) As Variant
   Dim p_abytServerName()              As Byte
   Dim p_vntRtn                        As Variant
   Dim p_strServerName                 As String
   Dim p_lngRtn                        As Long
   Dim p_lngSrvInfoRtn                 As Long
   Dim p_typServerInfo_101             As SERVER_INFO_101
   Const cnstProcName                  As String = "GetServerInfo"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   p_abytServerName = Trim$(xi_strServerName) & vbNullChar
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetServerGetInfo(sServerName:=p_abytServerName(0), _
                               lLevel:=101, _
                               vBuffer:=p_lngSrvInfoRtn)
   
   If p_lngRtn = NERR_SUCCESS Then
      CopyMem p_typServerInfo_101, _
              ByVal p_lngSrvInfoRtn, _
              Len(p_typServerInfo_101)
            
      ReDim p_vntRtn(0 To 6) As Variant
      
      With p_typServerInfo_101
         p_strServerName = PointerToStringW(.sv101_name)
         If Len(p_strServerName) = 0 Then
            p_strServerName = xi_strServerName
         End If
         If Len(p_strServerName) = 0 Then
            p_strServerName = "[Local]"
         End If
      
         p_vntRtn(enmServerInfo.ServerName) = p_strServerName
         p_vntRtn(enmServerInfo.Comment) = PointerToStringW(.sv101_comment)
         p_vntRtn(enmServerInfo.ID) = .sv101_platform_id
         p_vntRtn(enmServerInfo.MajorVer) = .sv101_ver_major
         p_vntRtn(enmServerInfo.MinorVer) = .sv101_ver_minor
         p_vntRtn(enmServerInfo.ServerType) = .sv101_type
         p_vntRtn(enmServerInfo.ServerTypeText) = TransServerType(.sv101_type)
         
      End With
   
      GetServerInfo = p_vntRtn
      
   Else
      GoTo Err_Handler
   End If
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetServerGetInfo, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumSessions
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:50:54
' Inputs       : ByVal xi_strServerName:String - Server Name (can be blank
' Outputs      : Variant:
' Description  : Provides information about sessions established
'              :     on a server
' Security     : Only members of the Administrators or Account
'              :     Operators local group can successfully
'              :     execute the NetSessionEnum FUNCTION at
'              :     level 1 or level 2.
'              : No special group membership is required
'              :     for level 0 or level 10 calls.
' Called By    : cNetCalls.EnumSessions
' *******************************************************
Public Function EnumSessions(ByVal xi_strServerName As String) As Variant
   Dim p_lngRtn                        As Long
   Dim p_lngPtrBuffer                  As Long
   Dim p_lngEntriesRead                As Long
   Dim p_lngTotalEntries               As Long
   Dim p_lngResumeHwnd                 As Long
   Dim p_lngLoop                       As Long
   Dim p_vntRnt                        As Variant
   Dim p_abytServerName()              As Byte
   Dim p_abytUncClientName()           As Byte
   Dim p_abytUserName()                As Byte
   Dim a_typSessionInfo_502()          As SESSION_INFO_502
   Const cnstProcName                  As String = "EnumSessions"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = Trim$(xi_strServerName)
   xi_strServerName = PrepareServerName(xi_strServerName)
   
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   p_abytServerName = xi_strServerName & vbNullChar
   p_abytUncClientName = vbNullChar
   p_abytUserName = vbNullChar
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetSessionEnum(ServerName:=p_abytServerName(0), _
                             UncClientName:=p_abytUncClientName(0), _
                             UserName:=p_abytUserName(0), _
                             level:=502, _
                             BufferPtr:=p_lngPtrBuffer, _
                             PrefMaxLen:=4096, _
                             EntriesRead:=p_lngEntriesRead, _
                             TotalEntries:=p_lngTotalEntries, _
                             Resume_Handle:=p_lngResumeHwnd)
   
   If (p_lngRtn = NERR_SUCCESS) And (p_lngEntriesRead = 0) Then
      ' Not an error
      GoTo Clean_Up
   ElseIf (p_lngRtn = NERR_SUCCESS) And (p_lngEntriesRead > 0) Then
      ' ------------------------------------------
      ' Redim the type array to hold this info
      ' ------------------------------------------
      ReDim a_typSessionInfo_502(0 To p_lngEntriesRead - 1) As SESSION_INFO_502
            
      ' ------------------------------------------
      ' Copy the pointer to the buffer into the
      '     type array
      ' ------------------------------------------
      CopyMem a_typSessionInfo_502(0), _
              ByVal p_lngPtrBuffer, _
              Len(a_typSessionInfo_502(0)) * p_lngEntriesRead
   
      ' ------------------------------------------
      ' ------------------------------------------
      ReDim p_vntRtn(0 To 9, 0 To (p_lngEntriesRead - 1)) As Variant
   
      For p_lngLoop = 0 To p_lngEntriesRead - 1
         With a_typSessionInfo_502(p_lngLoop)
            p_vntRtn(enmEnumSessions.ClientForSession, p_lngLoop) = PointerToStringW(.sesi502_cltype_name)
            p_vntRtn(enmEnumSessions.UserName, p_lngLoop) = PointerToStringW(.sesi502_username)
            p_vntRtn(enmEnumSessions.ComputerForSession, p_lngLoop) = PointerToStringW(.sesi502_cname)
            p_vntRtn(enmEnumSessions.Transport, p_lngLoop) = PointerToStringW(.sesi502_transport)
                        
            p_vntRtn(enmEnumSessions.IdleTime, p_lngLoop) = .sesi502_idle_time
            p_vntRtn(enmEnumSessions.NumOpens, p_lngLoop) = .sesi502_num_opens
            p_vntRtn(enmEnumSessions.NumConnections, p_lngLoop) = 0        ' Available on Win9x
            p_vntRtn(enmEnumSessions.TimeOpen, p_lngLoop) = .sesi502_time
            p_vntRtn(enmEnumSessions.UserFlags, p_lngLoop) = .sesi502_user_flags
            p_vntRtn(enmEnumSessions.UserFlagsText, p_lngLoop) = TransUserFlags(.sesi502_user_flags)
         End With
      
         EnumSessions = p_vntRtn
         
      Next p_lngLoop
      
   Else
      GoTo Err_Handler
   End If

Clean_Up:
   ' ------------------------------------------
   ' Clean-up the buffer
   ' ------------------------------------------
   If p_lngPtrBuffer <> 0 Then
      NetApiBufferFree p_lngPtrBuffer
   End If
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetSessionEnum, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumShares
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:56:25
' Inputs       : ByVal xi_strServerName:String - Server name (can be blank)
' Outputs      : Variant:
' Description  : Retrieves information about each shared
'              :     resource on a server.
' Security     : Windows NT: Administrator or Communication,
'              :     Print, or Server operator group membership
'              :     is required to successfully execute the
'              :     NetShareEnum FUNCTION at levels 2 and 502.
'              : No special group membership is required for
'              :     level 0 or level 1 calls.
'              : For W2K+, see MSDN
' Called By    : cNetCalls.EnumShares
' *******************************************************
Public Function EnumShares(ByVal xi_strServerName As String) As Variant
   Dim p_abytServerName()              As Byte
   Dim p_vntRtn                        As Variant
   Dim p_lngRtn                        As Long
   Dim p_lngPtrBuffer                  As Long
   Dim p_lngEntriesRead                As Long
   Dim p_lngTotalEntries               As Long
   Dim p_lngResumeHwnd                 As Long
   Dim p_lngLoop                       As Long
   Dim p_blnIsLevel2                   As Boolean
   Dim p_atypShareInfo_1()             As SHARE_INFO_1
   Dim p_atypShareInfo_2()             As SHARE_INFO_2
   Const cnstProcName                  As String = "EnumShares"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   p_abytServerName = xi_strServerName & vbNullChar
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_blnIsLevel2 = False
   p_lngRtn = NetShareEnum(ServerName:=p_abytServerName(0), _
                           level:=2, _
                           Buffer:=p_lngPtrBuffer, _
                           PreMaxLen:=4096&, _
                           EntriesRead:=p_lngEntriesRead, _
                           TotalEntries:=p_lngTotalEntries, _
                           Resume_Handle:=p_lngResumeHwnd)
   
   If p_lngRtn = NERR_SUCCESS Then
      p_blnIsLevel2 = True
   
   Else
      p_lngRtn = NetShareEnum(ServerName:=p_abytServerName(0), _
                              level:=1, _
                              Buffer:=p_lngPtrBuffer, _
                              PreMaxLen:=4096&, _
                              EntriesRead:=p_lngEntriesRead, _
                              TotalEntries:=p_lngTotalEntries, _
                              Resume_Handle:=p_lngResumeHwnd)
                              
      If p_lngRtn <> NERR_SUCCESS Then
         GoTo Err_Handler
      End If
   End If
   
   ' ------------------------------------------
   ' Exit if no entries found
   ' ------------------------------------------
   If p_lngEntriesRead < 1 Then
      GoTo Clean_Up
   End If
   
   ' ------------------------------------------
   ' Fill-in the info needed to call the
   '     Add() method
   ' ------------------------------------------
   ReDim p_vntRtn(0 To 9, 0 To (p_lngEntriesRead - 1)) As Variant
   
   For p_lngLoop = 0 To p_lngEntriesRead - 1
      
      If p_blnIsLevel2 = True Then
         ' ---------------------------------------
         ' Redim the type array to hold this info
         ' ---------------------------------------
         ReDim p_atypShareInfo_2(0 To p_lngEntriesRead - 1) As SHARE_INFO_2
      
         ' ---------------------------------------
         ' Copy the pointer to the buffer into the
         '     type array
         ' ---------------------------------------
         CopyMem p_atypShareInfo_2(0), _
                 ByVal p_lngPtrBuffer, _
                 Len(p_atypShareInfo_2(0)) * p_lngEntriesRead
   
      
         With p_atypShareInfo_2(p_lngLoop)
            p_vntRtn(enmShareEnum.Netname, p_lngLoop) = PointerToStringW(.shi2_netname)
            p_vntRtn(enmShareEnum.Remark, p_lngLoop) = PointerToStringW(.shi2_remark)
            p_vntRtn(enmShareEnum.Path, p_lngLoop) = PointerToStringW(.shi2_path)
            p_vntRtn(enmShareEnum.Password, p_lngLoop) = PointerToStringW(.shi2_passwd)
            
            p_vntRtn(enmShareEnum.MaxUses, p_lngLoop) = .shi2_max_uses
            p_vntRtn(enmShareEnum.CurrUses, p_lngLoop) = .shi2_current_uses
            p_vntRtn(enmShareEnum.ShareType, p_lngLoop) = .shi2_type
            p_vntRtn(enmShareEnum.ShareTypeText, p_lngLoop) = TransShareType(.shi2_type)
            ' NOTE: Only the share-level security, not the user-level
            '       security
            p_vntRtn(enmShareEnum.Permissions, p_lngLoop) = .shi2_permissions
            p_vntRtn(enmShareEnum.PermissionsText, p_lngLoop) = TransPermissions(.shi2_permissions)
         End With
         
         EnumShares = p_vntRtn
         
      ElseIf p_blnIsLevel2 = False Then
         ' ---------------------------------------
         ' Redim the type array to hold this info
         ' ---------------------------------------
         ReDim p_atypShareInfo_1(0 To p_lngEntriesRead - 1) As SHARE_INFO_1
   
         ' ---------------------------------------
         ' Copy the pointer to the buffer into the
         '     type array
         ' ---------------------------------------
         CopyMem p_atypShareInfo_1(0), _
                 ByVal p_lngPtrBuffer, _
                 Len(p_atypShareInfo_1(0)) * p_lngEntriesRead
   
         With p_atypShareInfo_1(p_lngLoop)
            p_vntRtn(enmShareEnum.Netname, p_lngLoop) = PointerToStringW(.shi1_netname)
            p_vntRtn(enmShareEnum.Remark, p_lngLoop) = PointerToStringW(.shi1_remark)
            p_vntRtn(enmShareEnum.Path, p_lngLoop) = CNST_NOT_AVAILABLE
            p_vntRtn(enmShareEnum.Password, p_lngLoop) = vbNullString
            
            p_vntRtn(enmShareEnum.MaxUses, p_lngLoop) = 0
            p_vntRtn(enmShareEnum.CurrUses, p_lngLoop) = 0
            p_vntRtn(enmShareEnum.ShareType, p_lngLoop) = .shi1_type
            p_vntRtn(enmShareEnum.ShareTypeText, p_lngLoop) = TransShareType(.shi1_type)
            ' NOTE: Only the share-level security, not the user-level
            '       security
            p_vntRtn(enmShareEnum.Permissions, p_lngLoop) = -1
            p_vntRtn(enmShareEnum.PermissionsText, p_lngLoop) = TransPermissions(-1)
         End With
         
         EnumShares = p_vntRtn
         
      End If
   
   Next p_lngLoop
   
Clean_Up:
   ' ------------------------------------------
   ' Clean-up the buffer
   ' ------------------------------------------
   If p_lngPtrBuffer <> 0 Then
      NetApiBufferFree p_lngPtrBuffer
   End If
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetShareEnum, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetSessionInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:58:01
' Inputs       : ByVal xi_strServerName:String  - Name of server (can be blank)
'              : ByVal xi_strSessionName:String - Name of session (required)
'              : ByVal xi_strUserName:String    - Name of user of session (required)
' Outputs      : Variant:
' Description  : Retrieves information about a session established
'              :     between a particular server and workstation.
' Security     : Windows NT: Only members of the Administrators or
'              :     Account Operators local group can successfully
'              :     execute the NetSessionGetInfo FUNCTION
'              :     at level 1 or level 2.
'              : No special group membership is required
'              :     for level 0 or level 10 calls.
'              : W2K+: See MSDN
' Called By    : cNetCalls.GetSessionInfo
' *******************************************************
Public Function GetSessionInfo(ByVal xi_strServerName As String, _
                               ByVal xi_strSessionName As String, _
                               ByVal xi_strUserName As String) As Variant
   Dim p_lngRtn                        As Long
   Dim p_lngPtrBuffer                  As Long
   Dim p_vntRtn                        As Variant
   Dim p_abytServerName()              As Byte
   Dim p_abytClientName()              As Byte
   Dim p_abytUserName()                As Byte
   Dim p_typShareInfo_2                As SESSION_INFO_2
   Const cnstProcName                  As String = "GetSessionInfo"

   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   If Len(Trim$(xi_strSessionName)) > 0 Then
      If Left$(xi_strSessionName, 2) <> "\\" Then
         xi_strSessionName = "\\" & xi_strSessionName
      End If
   End If
   
   p_abytServerName = xi_strServerName & vbNullChar
   p_abytClientName = xi_strSessionName & vbNullChar
   p_abytUserName = xi_strUserName & vbNullChar
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetSessionGetInfo(ServerName:=p_abytServerName(0), _
                                UncClientName:=p_abytClientName(0), _
                                UserName:=p_abytUserName(0), _
                                level:=2, _
                                BufferPtr:=p_lngPtrBuffer)

   If p_lngRtn <> NERR_SUCCESS Then
      GoTo Err_Handler
   Else
      CopyMem p_typShareInfo_2, _
              ByVal p_lngPtrBuffer, _
              Len(p_typShareInfo_2)
   
      ReDim p_vntRtn(0 To 8) As Variant
      
      With p_typShareInfo_2
         p_vntRtn(enmSessionInfo.ClientForSession) = PointerToStringW(.sesi2_cltype_name)
         p_vntRtn(enmSessionInfo.UserName) = PointerToStringW(.sesi2_username)
         p_vntRtn(enmSessionInfo.ComputerForSession) = PointerToStringW(.sesi2_cname)
         p_vntRtn(enmSessionInfo.IdleTime) = .sesi2_idle_time
         p_vntRtn(enmSessionInfo.NumOpens) = .sesi2_num_opens
         p_vntRtn(enmSessionInfo.NumConnects) = 0                 ' Available on Win9x
         p_vntRtn(enmSessionInfo.TimeOpen) = .sesi2_time
         p_vntRtn(enmSessionInfo.UserFlags) = .sesi2_user_flags
         p_vntRtn(enmSessionInfo.UserFlagsText) = TransUserFlags(.sesi2_user_flags)
      End With
   
      GetSessionInfo = p_vntRtn
      
   End If

Clean_Up:
   ' ------------------------------------------
   ' Clean-up the buffer
   ' ------------------------------------------
   If p_lngPtrBuffer <> 0 Then
      NetApiBufferFree p_lngPtrBuffer
   End If
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetSessionGetInfo, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetNetShareInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:59:55
' Inputs       : ByVal xi_strServerName:String - The server name (can be blank)
'              : ByVal xi_strShareName:String  - The share name to get info on
' Outputs      : Variant:
' Description  : Retrieves information about a particular
'              :     shared resource on a server.
' Security     : Only members of the Administrators or Account
'              :     Operators local group or those with
'              :     Communication, Print, or Server operator
'              :     group membership can successfully execute
'              :     the NetShareGetInfo FUNCTION at level 2.
'              : No special group membership is required for
'              :     level 0 or level 1 calls.
' Called By    : cNetCalls.GetNetShareInfo
' *******************************************************
Public Function GetNetShareInfo(ByVal xi_strServerName As String, _
                                ByVal xi_strShareName As String) As Variant
   Dim p_lngRtn                        As Long
   Dim p_vntRtn                        As Variant
   Dim p_abytServerName()              As Byte
   Dim p_abytNetName()                 As Byte
   Dim p_lngPtrBuffer                  As Long
   Dim p_typShareInfo_2                As SHARE_INFO_2
   Const cnstProcName                  As String = "GetNetShareInfo"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   p_abytServerName = xi_strServerName & vbNullChar
   p_abytNetName = xi_strShareName & vbNullChar

   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetShareGetInfo(ServerName:=p_abytServerName(0), _
                              Netname:=p_abytNetName(0), _
                              level:=2, _
                              Buffer:=p_lngPtrBuffer)
   
   If p_lngRtn <> NERR_SUCCESS Then
      If p_lngRtn = ERR_WRONG_CALL_LEVEL Then
         Err.Raise Number:=p_lngRtn + cnstErrBase, _
                   Source:=cnstProcName, _
                   Description:=CNST_CANNOT_CALL_WIN9X
      Else
         GoTo Err_Handler
      End If
   Else
      CopyMem pTo:=p_typShareInfo_2, _
              uFrom:=ByVal p_lngPtrBuffer, _
              lSize:=Len(p_typShareInfo_2)
              
      ReDim p_vntRtn(0 To 9) As Variant
      
      With p_typShareInfo_2
         p_vntRtn(enmShareEnum.Netname) = PointerToStringW(.shi2_netname)
         p_vntRtn(enmShareEnum.Remark) = PointerToStringW(.shi2_remark)
         p_vntRtn(enmShareEnum.Path) = PointerToStringW(.shi2_path)
         p_vntRtn(enmShareEnum.Password) = PointerToStringW(.shi2_passwd)
         
         p_vntRtn(enmShareEnum.MaxUses) = .shi2_max_uses
         p_vntRtn(enmShareEnum.CurrUses) = .shi2_current_uses
         p_vntRtn(enmShareEnum.ShareType) = .shi2_type
         p_vntRtn(enmShareEnum.ShareTypeText) = TransShareType(.shi2_type)
         p_vntRtn(enmShareEnum.Permissions) = .shi2_permissions
         p_vntRtn(enmShareEnum.PermissionsText) = TransPermissions(.shi2_permissions)
      End With
      
      GetNetShareInfo = p_vntRtn
      
   End If
   
Clean_Up:
   If p_lngPtrBuffer <> 0 Then
      p_lngRtn = NetApiBufferFree(Buffer:=p_lngPtrBuffer)
   End If

Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetShareGetInfo, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB AddShare
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 11:06:23
' Inputs       : ByVal xi_strServerName:String - Server name (can be blank)
'              : ByVal xi_strShareName:String  - Share Name
'              : ByVal xi_strPath:String       - Path to share
'              : ByVal xi_strRemark:String     - Remark (can be blank)
' Outputs      : N/A
' Description  : Shares a server resource.
' Security     : Only members of the Administrators or Account
'              :     Operators local group or those with Communication,
'              :     Print, or Server operator group membership can
'              :     successfully execute the NetShareAdd FUNCTION.
'              : The Print operator can add only Printer queues.
'              : The Communication operator can add only
'              :     communication-device queues.
' Called By    : cNetCalls.AddShare
' *******************************************************
Public Sub AddShare(ByVal xi_strServerName As String, _
                    ByVal xi_strShareName As String, _
                    ByVal xi_strPath As String, _
                    ByVal xi_strRemark As String)
   Dim p_lngRtn                        As Long
   Dim p_lngPtrToType                  As Long
   Dim p_lngParmErr                    As Long
   Dim p_abytServerName()              As Byte
   Dim p_strErr                        As String
   Dim p_strPassword                   As String
   Dim p_typShareInfo_2                As SHARE_INFO_2
   Const cnstProcName                  As String = "AddShare"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   p_abytServerName = xi_strServerName & vbNullChar
   p_strPassword = vbNullString
   
   With p_typShareInfo_2
      .shi2_netname = StrPtr(xi_strShareName)
      .shi2_type = enmShareType.STYPE_DISKTREE
      .shi2_remark = StrPtr(xi_strRemark)
      .shi2_permissions = enmPermissions.ACCESS_READ
      .shi2_max_uses = -1
      .shi2_current_uses = 0
      .shi2_path = StrPtr(xi_strPath)
      .shi2_passwd = StrPtr(p_strPassword)
   End With
   
   p_lngPtrToType = VarPtr(p_typShareInfo_2)
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetShareAdd(ServerName:=p_abytServerName(0), _
                          level:=2, _
                          Buffer:=p_lngPtrToType, _
                          parm_err:=p_lngParmErr)

   If p_lngRtn <> NERR_SUCCESS Then
      GoTo Err_Handler
   End If
   
Exit Sub
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetShareAdd, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB DeleteShare
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 11:26:17
' Inputs       : ByVal xi_strServerName:String - Server Name (can be blank)
'              : ByVal xi_strShareName:String  - Share Name
' Outputs      : N/A
' Description  : Deletes a share name from a server's list of
'              :     shared resources, disconnecting all
'              :     connections to the shared resource.
' Security     : Only members of the Administrators or Account
'              :     Operators local group or those with
'              :     Communication, Print, or Server operator
'              :     group membership can successfully
'              :     execute the NetShareDel FUNCTION.
'              : The Print operator can delete only
'              :     Printer queues.
'              : The Communication operator can delete
'              :     only communication-device queues.
' Called By    : cNetCalls.DeleteShare
' *******************************************************
Public Sub DeleteShare(ByVal xi_strServerName As String, _
                       ByVal xi_strShareName As String)
   Dim p_lngRtn                        As Long
   Dim p_abytServerName()              As Byte
   Dim p_abytShareName()               As Byte
   Const cnstProcName                  As String = "DeleteShare"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   p_abytServerName = xi_strServerName & vbNullChar
   p_abytShareName = xi_strShareName & vbNullChar
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetShareDel(ServerName:=p_abytServerName(0), _
                          Netname:=p_abytShareName(0), _
                          Reserved:=0&)

   If p_lngRtn <> NERR_SUCCESS Then
      GoTo Err_Handler
   End If
   
Exit Sub
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetShareDel, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB CloseFile
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 11:30:14
' Inputs       : ByVal xi_lngFilePtr:Long      - Pointer to a file
'              : ByVal xi_strServerName:String - Server Name (can be blank)
'              : ByVal xi_strFileName:String   - File name (used only for error msg)
' Outputs      : N/A
' Description  : Passed the pointer to the file, and the
'              :     name of the server (can be blank),
'              :     close this network-opened file
'              : Note: The filename passed only for the
'              :       error message
' Security     : Only members of the Administrators or
'              :     Account Operators local group can
'              :     successfully execute the NetFileClose
'              :     FUNCTION.
' Called By    : cNetCalls.CloseFiles
' *******************************************************
Public Sub CloseFile(ByVal xi_lngFilePtr As Long, _
                     ByVal xi_strServerName As String, _
                     ByVal xi_strFileName As String)
   Dim p_lngRtn                        As Long
   Dim p_abytServerName()              As Byte
   Const cnstProcName                  As String = "CloseFile"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   p_abytServerName = xi_strServerName & vbNullChar
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetFileClose(ServerName:=p_abytServerName(0), _
                           PtrFile:=xi_lngFilePtr)
   If p_lngRtn <> NERR_SUCCESS Then
      GoTo Err_Handler
   End If

Exit Sub
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetFileClose (for the file, " & _
                          xi_strFileName & "), got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Sub DeleteSession
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/22/2001 -- 16:32:36
' Inputs       : ByVal xi_strUserName:String    - Name of the user whose session is to be terminated (can be blank)
'              : ByVal xi_strServerName:String  - Server Name (can be blank)
'              : Optional ByVal xi_strMachineName:String = "" - Computer name of the client to disconnect
' Outputs      : N/A
' Description  : Passed the name of the user and the machine
'              :     this session is on, delete this
'              :     session.
'              : Ends a network session between a server
'              :     and a workstation.
' Security     : Only members of the Administrators
'              :     or Account Operators local group
'              :     can successfully execute the NetSessionDel
'              :     FUNCTION.
' Called By    : cNetCalls.DeleteSession
' *******************************************************
Public Sub DeleteSession(ByVal xi_strUserName As String, _
                         ByVal xi_strServerName As String, _
                         Optional ByVal xi_strMachineName As String = "")
   Dim p_lngRtn                        As Long
   Dim p_abytServerName()              As Byte
   Dim p_abytMachineName()             As Byte
   Dim p_abytUserName()                As Byte
   Const cnstProcName                  As String = "DeleteSession"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   p_abytServerName = xi_strServerName & vbNullChar
   
   If Len(Trim$(xi_strMachineName)) > 0 Then
      If Left$(xi_strMachineName, 2) <> "\\" Then
         xi_strMachineName = "\\" & xi_strMachineName
      End If
      p_abytMachineName = xi_strMachineName & vbNullChar
   Else
      p_abytMachineName = vbNullChar
   End If
   
   p_abytUserName = xi_strUserName & vbNullChar
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetSessionDel(ServerName:=p_abytServerName(0), _
                            UncClientName:=p_abytMachineName(0), _
                            UserName:=p_abytUserName(0))
   If p_lngRtn <> NERR_SUCCESS Then
      GoTo Err_Handler
   End If
   
Exit Sub
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetSessionDel, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB SetShareInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 12:31:05
' Inputs       : ByVal xi_strServerName:String - Server Name (can be blank)
'              : ByVal xi_strShareName:String  - Name of the share
'              : ByVal xi_strRemark:String     - Remark (change)
' Outputs      : N/A
' Description  : Sets the parameters of a shared resource
' Security     : Only the Administrators local group or
'              :     Communication, Print, or Server
'              :     operator group membership is
'              :     required to successfully execute
'              :     the NetShareSetInfo FUNCTION.
'              : The Print operator can set information
'              :     only about Printer queues.
'              : The Communication operator can set
'              :     information only about
'              :     communication-device queues.
' Called By    : cNetCalls.SetShareInfo
' *******************************************************
Public Sub SetShareInfo(ByVal xi_strServerName As String, _
                        ByVal xi_strShareName As String, _
                        ByVal xi_strRemark As String)
   Dim p_lngRtn                        As Long
   Dim p_lngPtrToType                  As Long
   Dim p_lngParmErr                    As Long
   Dim p_abytServerName()              As Byte
   Dim p_abytShareName()               As Byte
   Dim p_typShareInfo_2                As SHARE_INFO_2
   Const cnstProcName                  As String = "SetShareInfo"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   xi_strServerName = PrepareServerName(xi_strServerName)
   If IsRemoteWin9x(xi_strServerName) = True Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:=CNST_CANNOT_CALL_WIN9X
   End If
   
   p_abytServerName = xi_strServerName & vbNullChar
   p_abytShareName = xi_strShareName & vbNullChar
   
   With p_typShareInfo_2
      .shi2_remark = StrPtr(xi_strRemark)
   End With
   
   p_lngPtrToType = VarPtr(p_typShareInfo_2)
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetShareSetInfo(ServerName:=p_abytServerName(0), _
                              Netname:=p_abytShareName(0), _
                              level:=2, _
                              Buffer:=p_lngPtrToType, _
                              parm_err:=p_lngParmErr)
                              
   If p_lngRtn <> NERR_SUCCESS Then
      GoTo Err_Handler
   End If
   
Exit Sub
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetShareSetInfo, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn) & "'"
End Sub

Private Function IsRemoteWin9x(ByVal xi_strServerName As String) As Boolean
   Dim p_lngWorkstationInfo            As Long
   Dim p_atypWrkStationInfo(0)         As WKSTA_INFO_102
   Dim p_lngRtn                        As Long
   
   p_lngRtn = NetWkstaGetInfo(ServerName:=StrConv(xi_strServerName, vbUnicode), _
                              level:=102, _
                              lpBuf:=p_lngWorkstationInfo)
   
   If p_lngRtn = NERR_SUCCESS Then
      CopyMem p_atypWrkStationInfo(0), _
              ByVal p_lngWorkstationInfo, _
              Len(p_atypWrkStationInfo(0))
      
      If p_atypWrkStationInfo(0).wki100_platform_id = PLATFORM_ID_NT Then
         IsRemoteWin9x = False
      Else
         IsRemoteWin9x = True
      End If
      
   End If

End Function

' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' +++                           CLASS Methods
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub Class_Initialize
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 13:43:01
' Inputs       : N/A
' Outputs      : N/A
' Description  : Already know it's a NT+ machine
'              : Now need to find out if it's pre-NT 4.0
' Called By    : cNetCalls
' *******************************************************
Private Sub Class_Initialize()
   Dim p_objGetOS                      As cOsVersion
   Dim p_enmOsType                     As enmValidOSs
   
   Set p_objGetOS = New cOsVersion
   
   p_enmOsType = p_objGetOS.TypeValidOS
   
   Select Case p_enmOsType
      Case Valid_NT_Pre40
         m_blnNT40_Plus = False
      Case Valid_NT40, _
           Valid_W2K, _
           Valid_XP
         m_blnNT40_Plus = True
      Case Else
         ' Raise error -- invalid OS
   End Select
   
End Sub
