VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cNet_Win9x"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ************************************************************
' Copyright  1995-2001 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the VBPJ site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************

' ---------------------------------------------
' Module    : cNet_Win9x.cls
' By        : L.J. Johnson       Date: 09-23-2001
' Comments  : All calls for Win9x systems for
'           :     the network calls
'           : Abstracted by cNetCalls.cls
' ---------------------------------------------
Option Explicit

' ---------------------------------------------
' Module-level vars
' ---------------------------------------------
Private m_blnIsWin95                   As Boolean
Private Const ERR_WRONG_CALL_LEVEL     As Long = 124&
Private Const CNST_NOT_AVAILABLE       As String = "N/A calling NT"
Private Const CNST_CANNOT_USE1         As String = "Cannot call this function ("
Private Const CNST_CANNOT_USE2         As String = ") with remote NT computer."
Private Const CNST_FAILURE_LEVEL50     As String = "Level 50 call failed"

' ---------------------------------------------
' Net... FUNCTIONs (Obsolete on NT+)
' ---------------------------------------------
'NetAccessAdd           --> SetFileSecurity
'NetAccessCheck         --> AccessCheck
'NetAccessDel           --> SetFileSecurity
'NetAccessEnum          --> GetFileSecurity
'NetAccessGetInfo       --> GetFileSecurity
'NetAccessGetUserPerms  --> GetFileSecurity
'NetAccessSetInfo       --> SetFileSecurity

' ---------------------------------------------
' Used in EnumShares
' The NetShareEnum function retrieves information
'     about each shared resource on a server.
' Win32-based applications can also use the
'     WNetEnumResource function. However,
'     WNetEnumResource does not enumerate hidden
'     shares or users connected to a share.
' ---------------------------------------------
      ' NetShareEnum(
      '  const char FAR * pszServer,
      '  short sLevel,
      '  char FAR * pbBuffer,
      '  unsigned short  cbBuffer,
      '  unsigned short FAR * pcEntriesRead,
      '  unsigned short FAR * pcTotalAvail
' ---------------------------------------------
Private Declare Function NetShareEnum95 _
   Lib "svrapi" Alias "NetShareEnum" _
   (ByVal lpServerName As String, _
    ByVal dwLevel As Integer, _
    lpBuffer As Any, _
    ByVal cbBuffer As Integer, _
    EntriesRead As Integer, _
    TotalEntries As Integer) As Long

' ---------------------------------------------
' Used in EnumConnections
' The NetConnectionEnum function lists all
'     connections made to a shared resource on
'     the server or all connections established
'     from a particular computer. If there is
'     more than one user using this connection,
'     then it is possible to get more than one
'     structure for the same connection, but
'     with a different user name.
' ---------------------------------------------
      ' NetConnectionEnum(
      '  const char FAR *pszServer,
      '  const char FAR *pszQualifier,
      '  short sLevel,
      '  char FAR *pbBuffer,
      '  unsigned short  cbBuffer,
      '  unsigned short FAR *pcEntriesRead,
      '  unsigned short FAR *pcTotalAvail
' ---------------------------------------------
Private Declare Function NetConnectionEnum95 _
   Lib "svrapi" Alias "NetConnectionEnum" _
   (ByVal lpServer As String, _
    ByVal lpQualifier As String, _
    ByVal dwLevel As Integer, _
    lpBuffer As Any, _
    ByVal cbBuffer As Integer, _
    EntriesRead As Integer, _
    TotalAvailable As Integer) As Long

' ---------------------------------------------
' Used in EnumFiles
' The NetFileEnum function returns information
'     about some or all open files on a server,
'     depending on the parameters specified.
' ---------------------------------------------
      ' NetFileEnum(
      '  const char FAR * pszServer,
      '  const char FAR * pszBasePath,
      '  short sLevel,
      '  char FAR * pbBuffer,
      '  unsigned short  cbBuffer,
      '  unsigned short FAR * pcEntriesRead,
      '  unsigned short FAR * pcTotalAvail
' ---------------------------------------------
Private Declare Function NetFileEnum95 _
   Lib "svrapi" Alias "NetFileEnum" _
   (ByVal lpServer As String, _
    ByVal lpBasePath As String, _
    ByVal dwLevel As Integer, _
    lpBuffer As Any, _
    ByVal cbBuffer As Integer, _
    EntriesRead As Integer, _
    TotalAvailable As Integer) As Long
    
' ---------------------------------------------
' Used in EnumSessions
' The NetSessionEnum function provides information
'     about sessions established on a server.
' ---------------------------------------------
      ' NetSessionEnum(
      '  const char FAR * pszServer,
      '  short sLevel,
      '  char FAR * pbBuffer,
      '  unsigned short  cbBuffer,
      '  unsigned short FAR * pcEntriesRead,
      '  unsigned short FAR * pcTotalAvail
' ---------------------------------------------
Private Declare Function NetSessionEnum95 _
   Lib "svrapi" Alias "NetSessionEnum" _
   (ByVal lpServer As String, _
    ByVal dwLevel As Integer, _
    lpBuffer As Any, _
    ByVal cbBuffer As Integer, _
    EntriesRead As Integer, _
    TotalAvailable As Integer) As Long

' ---------------------------------------------
' Used in GetSessionInfo
' The NetSessionGetInfo function retrieves
'     information about a session established
'     between a particular server and workstation.
' ---------------------------------------------
      ' NetSessionGetInfo(
      '  const char FAR * pszServer,
      '  const char FAR * pszClientName,
      '  short sLevel,
      '  char FAR * pbBuffer,
      '  unsigned short  cbBuffer,
      '  unsigned short FAR * pcbTotalAvail
' ---------------------------------------------
Private Declare Function NetSessionGetInfo95 _
   Lib "svrapi" Alias "NetSessionGetInfo" _
   (ByVal lpServer As String, _
    ByVal lpClientName As String, _
    ByVal dwLevel As Integer, _
    lpBuffer As Any, _
    ByVal cbBuffer As Integer, _
    TotalAvailable As Integer) As Long

' ---------------------------------------------
' Used in GetServerInfo
' The NetServerGetInfo function retrieves current
'     configuration information for the specified server.
' ---------------------------------------------
      ' NetServerGetInfo(
      '  const char FAR * pszServer,
      '  short sLevel,
      '  char FAR * pbBuffer,
      '  unsigned short cbBuffer,
      '  unsigned short FAR * pcbTotalAvail
' ---------------------------------------------
Private Declare Function NetServerGetInfo95 _
   Lib "svrapi" Alias "NetServerGetInfo" _
   (ByVal lpServer As String, _
    ByVal dwLevel As Integer, _
    lpBuffer As Any, _
    ByVal cbBuffer As Integer, _
    TotalAvailable As Integer) As Long

' ---------------------------------------------
' Used in GetNetShareInfo
' The NetShareGetInfo function retrieves
'     information about a particular shared
'     resource on a server.
' ---------------------------------------------
      ' NetShareGetInfo(
      '  const char FAR * pszServer,
      '  const char FAR * pszNetName,
      '  short sLevel,
      '  char FAR * pbBuffer,
      '  unsigned short  cbBuffer,
      '  unsigned short FAR * pcbTotalAvail
' ---------------------------------------------
Private Declare Function NetShareGetInfo95 _
   Lib "svrapi" Alias "NetShareGetInfo" _
   (ByVal lpServer As String, _
    ByVal lpNetname As String, _
    ByVal dwLevel As Integer, _
    lpBuffer As Any, _
    ByVal cbBuffer As Integer, _
    TotalAvailable As Integer) As Long

' ---------------------------------------------
' Used in AddShare
' The NetShareAdd function shares a server resource.
' ---------------------------------------------
      ' NetShareAdd(
      '  const char FAR * pszServer,
      '  short sLevel,
      '  const char FAR * pbBuffer,
      '  unsigned short  cbBuffer
' ---------------------------------------------
Private Declare Function NetShareAdd95 _
   Lib "svrapi.dll" Alias "NetShareAdd" _
   (ByVal lpServer As String, _
    ByVal dwLevel As Integer, _
    lpBuffer As Any, _
    ByVal cbBuffer As Integer) As Long

' ---------------------------------------------
' Used in DeleteShare
' The NetShareDel function deletes a share name
'     from a server's list of shared resources,
'     disconnecting all connections to the
'     shared resource.
' ---------------------------------------------
      ' NetShareDel(
      '  const char FAR * pszServer,
      '  const char FAR * pszNetName,
      '  unsigned short  Reserved
' ---------------------------------------------
Private Declare Function NetShareDel95 _
   Lib "svrapi.dll" Alias "NetShareDel" _
   (ByVal lpServer As String, _
    ByVal lpNetname As String, _
    ByVal Reserved As Integer) As Long

' ---------------------------------------------
' Used in SetShareInfo
' The NetShareSetInfo function sets the
'     parameters of a shared resource.
' ---------------------------------------------
      ' NetShareSetInfo(
      '  const char FAR * pszServer,
      '  const char FAR * pszNetName,
      '  short sLevel,
      '  char FAR * pbBuffer,
      '  unsigned short cbBuffer,
      '  Short sParmNum
' ---------------------------------------------
Private Declare Function NetShareSetInfo95 _
   Lib "svrapi" Alias "NetShareSetInfo" _
   (ByVal lpServer As String, _
    ByVal lpNetname As String, _
    ByVal dwLevel As Integer, _
    lpBuffer As Any, _
    ByVal cbBuffer As Integer, _
    ByVal sParmNum As Integer) As Long

' ---------------------------------------------
' Used in CloseFile
' NetFileClose2 (FileClose is NT only, FileClose2
'     is Win9x only)
' Forces a resource to close. This function can
'     be used when an error prevents closure by
'     any other means.
' ---------------------------------------------
      ' NetFileClose2(
      '  const char FAR * pszServer,
      '  unsigned long ulFileId
' ---------------------------------------------
Private Declare Function NetFileClose2 _
   Lib "svrapi" _
   (ByVal lpServer As String, _
    ByVal ulFileID As Long) As Long

' ---------------------------------------------
' Used in DeleteSession
' The NetSessionDel function ends a network
'     session between a server and a workstation.
' ---------------------------------------------
      ' NetSessionDel(
      '  const char FAR *pszServer,
      '  const char FAR *pszClientName,
      '  Short Reserved
' ---------------------------------------------
Private Declare Function NetSessionDel95 _
   Lib "svrapi.dll" Alias "NetSessionDel" _
   (ByVal lpServer As String, _
    ByVal lpClientName As String, _
    ByVal sReserved As Integer) As Long

' ---------------------------------------------
' Types for Win9x
' ---------------------------------------------
Private Type Connection_Info_50_9x
  coni50_type                          As Integer  ' unsigned short  coni50_type                   /* Specifies an unsigned SHORT variable that indicates the type of connection made from the local device to the shared resource.
  coni50_num_opens                     As Integer  ' unsigned short  coni50_num_opens              /* Specifies an unsigned SHORT variable that indicates the number of files currently open as a result of the connection.
  coni50_time                          As Long     ' unsigned long   coni50_time                   /* Specifies an unsigned LONG variable that indicates the length of the established connection, in seconds.
  coni50_netname                       As Long     ' char FAR *      coni50_netname                /* Pointer to a string specifying either the share name of the server's shared resource or the computername of the client.
  coni50_username                      As Long     ' char FAR *      coni50_username               /* Pointer to a string. If the server sharing the resource is running with user-level security, the coni50_username member describes which user made the connection. If the server is running with share-level security, coni50_username describes which computer (computername) made the connection.
End Type

Private Type File_Info_50_9x
  fi50_id                              As Long     ' unsigned long   fi50_id                       /* Specifies the identification number assigned to the resource when it is opened.
  fi50_permissions                     As Integer  ' unsigned short  fi50_permissions              /* Specifies the access permissions associated with the opening application.
  fi50_num_locks                       As Integer  ' unsigned short  fi50_num_locks                /* Specifies the number of locks on the resource.
  fi50_pathname                        As Long     ' char FAR *      fi50_pathname                 /* Pointer to a string that contains the path of the opened resource.
  fi50_username                        As Long     ' char FAR *      fi50_username                 /* Pointer to a string that specifies which user opened the resource.
  fi50_sharename                       As Long     ' char FAR *      fi50_sharename                /* Pointer to a string that specifies the share name associated with the open resource.
End Type

Private Type Share_Info_50_9x
   Netname(0 To LM20_NNLEN)            As Byte     ' char            shi50_netname[LM20_NNLEN+1]   /* Specifies a string containing the share name of the resource.
   ShareType                           As Byte     ' unsigned char   shi50_type                    /* Specifies an unsigned SHORT integer that contains the type of the shared resource.
   Flags                               As Integer  ' unsigned short  shi50_flags                   /* These flags are relevant for share-level security on VSERVER * When operating with user-level security, use SHI50F_FULL - the actual * access rights are determined by the NetAccess APIs.
   lpRemark                            As Long     ' char FAR *      shi50_remark                  /* Pointer to a ANSI string containing an optional comment about the shared resource.
   lpPath                              As Long     ' char FAR *      shi50_path                    /* Pointer to a string specifying the local path for the shared resource.
   PasswordRW(0 To SHPWLEN)            As Byte     ' char            shi50_rw_password[SHPWLEN+1]  /* Specifies a string containing the password (when the server is running with share-level security)
   PasswordRO(0 To SHPWLEN)            As Byte     ' char            shi50_ro_password[SHPWLEN+1]  /* Specifies a string containing the password (when the server is running with share-level security)
End Type
Private Type Share_Info_1_9x
   shi1_netname(0 To LM20_NNLEN)       As Byte     ' char            shi1_netname[LM20_NNLEN+1]    /* Specifies a string containing the share name of the resource.
   shi1_pad1                           As Byte     ' char            shi1_pad1                     /* Specifies padding inserted to align the next member.
   shi1_type                           As Integer  ' unsigned short  shi1_type                     /* Specifies an unsigned SHORT integer that contains the type of the shared resource.
   shi1_remark                         As Long     ' char FAR *      shi1_remark                   /* Pointer to a ANSI string containing an optional comment about the shared resource.
End Type

Private Type Session_Info_0_9x
   sesi0_cname                         As Long     ' char FAR *      sesi0_cname                   /* Pointer to a string specifying the name of the computer that established the session.
End Type
Private Type Session_Info_1_9x
  sesi1_cname                          As Long     ' char FAR *      sesi1_cname                   /* Pointer to a string specifying the name of the computer that established the session.
  sesi1_username                       As Long     ' char FAR *      sesi1_username                /* Pointer to a string specifying the name of the user who established the session.
  sesi1_num_conns                      As Integer  ' unsigned short  sesi1_num_conns               /* Specifies the number of connections made during the session.
  sesi1_num_opens                      As Integer  ' unsigned short  sesi1_num_opens               /* Specifies the number of files opened during the session.
  sesi1_num_users                      As Integer  ' unsigned short  sesi1_num_users               /* Specifies the number of users that have made a connection during the session.
  sesi1_time                           As Long     ' unsigned long   sesi1_time                    /* Specifies the number of seconds the session has been active.
  sesi1_idle_time                      As Long     ' unsigned long   sesi1_idle_time               /* Specifies the number of seconds the session has been idle.
  sesi1_user_flags                     As Long     ' unsigned long   sesi1_user_flags              /* Specifies a variable that describes how the user established the session.
End Type
Private Type Session_Info_2_9x
  sesi2_cname                          As Long     ' char FAR *      sesi2_cname                   /* Pointer to a string specifying the name of the computer that established the session.
  sesi2_username                       As Long     ' char FAR *      sesi2_username                /* Pointer to a string specifying the name of the user who established the session.
  sesi2_num_conns                      As Integer  ' unsigned short  sesi2_num_conns               /* Specifies the number of connections made during the session.
  sesi2_num_opens                      As Integer  ' unsigned short  sesi2_num_opens               /* Specifies the number of files opened during the session.
  sesi2_num_users                      As Integer  ' unsigned short  sesi2_num_users               /* Specifies the number of users that have made a connection during the session.
  sesi2_time                           As Long     ' unsigned long   sesi2_time                    /* Specifies the number of seconds the session has been active.
  sesi2_idle_time                      As Long     ' unsigned long   sesi2_idle_time               /* Specifies the number of seconds the session has been idle.
  sesi2_user_flags                     As Long     ' unsigned long   sesi2_user_flags              /* Specifies a variable that describes how the user established the session.
  sesi2_cltype_name                    As Long     ' char FAR *      sesi2_cltype_name             /* Pointer to a string that specifies the type of client that established the session.
End Type
Private Type Session_Info_10_9x
  sesi10_cname                         As Long     ' char FAR *      sesi10_cname                  /* Pointer to a string specifying the name of the computer that established the session.
  sesi10_username                      As Long     ' char FAR *      sesi10_username               /* Pointer to a string specifying the name of the user who established the session.
  sesi10_time                          As Long     ' unsigned long   sesi10_time                   /* Specifies the number of seconds the session has been active.
  sesi10_idle_time                     As Long     ' unsigned long   sesi10_idle_time              /* Specifies the number of seconds the session has been idle.
End Type
Private Type Session_Info_50_9x
  sesi50_cname                         As Long     ' char FAR *      sesi50_cname                  /* Pointer to a string specifying the name of the computer that established the session.
  sesi50_username                      As Long     ' char FAR *      sesi50_username               /* Pointer to a string specifying the name of the user who established the session.
  sesi50_key                           As Long     ' unsigned long   sesi50_key                    /* Specifies a long integer returned by the NetSessionEnum function or the NetSessionGetInfo function. This value is required to delete a session.
  sesi50_num_conns                     As Integer  ' unsigned short  sesi50_num_conns              /* Specifies the number of connections made during the session.
  sesi50_num_opens                     As Integer  ' unsigned short  sesi50_num_opens              /* Specifies the number of files opened during the session.
  sesi50_time                          As Long     ' unsigned long   sesi50_time                   /* Specifies the number of seconds the session has been active.
  sesi50_idle_time                     As Long     ' unsigned long   sesi50_idle_time              /* Specifies the number of seconds the session has been idle.
  sesi50_protocol                      As Byte     ' unsigned char   sesi50_protocol               /* Specifies the name of the transport that the client is using to communicate with the server.
  pad1                                 As Byte     ' unsigned char   pad1                          /* Specifies padding inserted to align the next structure.
End Type

Private Type Server_Info_1_9x
  sv1_name(0 To CNLEN)                 As Byte     ' char             sv1_name[CNLEN + 1]          /* Pointer to a string specifying the name of the server of interest.
  sv1_version_major                    As Byte     ' unsigned char    sv1_version_major            /* Specifies the major release version number of the networking software the server is running.
  sv1_version_minor                    As Byte     ' unsigned char    sv1_version_minor            /* Specifies the minor release version number of the networking software the server is running.
  sv1_type                             As Long     ' unsigned long    sv1_type                     /* Specifies the type of networking software the server is running. This member can be one of the following values.
  sv1_comment                          As Long     ' char FAR *       sv1_comment                  /* Pointer to a string containing a comment that describes the server. This member can be null.
End Type
Private Type Server_Info_50_9x
  sv50_name(0 To CNLEN)                As Byte     ' char             sv50_name[CNLEN + 1]         /* Pointer to a string specifying the name of the server of interest.
  sv50_version_major                   As Byte     ' unsigned char    sv50_version_major           /* Specifies the major release version number of the networking software the server is running.
  sv50_version_minor                   As Byte     ' unsigned char    sv50_version_minor           /* Specifies the minor release version number of the networking software the server is running.
  sv50_type                            As Long     ' unsigned long    sv50_type                    /* Specifies the type of networking software the server is running. This member can be one of the following values.
  sv50_comment                         As Long     ' char FAR *       sv50_comment                 /* Pointer to a string containing a comment that describes the server. This member can be null.
  sv50_security                        As Integer  ' unsigned short   sv50_security                /* Specifies the security type of the server. This member can be one of the following values.
  sv50_auditing                        As Integer  ' unsigned short   sv50_auditing                /* Specifies a variable that indicates whether auditing is enabled on the server. If this member is zero, auditing is disabled. If this member is any other value, auditing is enabled.
  sv50_container                       As Long     ' char FAR *       sv50_container               /* Pointer to a string that specifies the security server or domain.
  sv50_ab_server                       As Long     ' char FAR *       sv50_ab_server               /* Pointer to a string that specifies the address book server.
  sv50_ab_dll                          As Long     ' char FAR *       sv50_ab_dll                  /* Pointer to a string that specifies the name of the address book service provider DLL.
End Type

' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' +++                          WNet... FUNCTIONs
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB AddConnection2
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:32:53
' Inputs       : ByVal xi_strPassword:String    - Password (can be blank)
'              : ByVal xi_strUserName:String    - UserID (can be blank)
'              : ByVal xi_strLocalName:String   - The local name of resource
'              : ByVal xi_strRemoteName:String  - The remote name of resource
'              : Optional ByVal xi_blnPersistent:Boolean = False - Do you make this a persistent connection?
' Outputs      : N/A
' Description  : Makes a connection to a network resource.
'              : The FUNCTION can redirect a local device
'              :     to the network resource.
' Called By    : cNetCalls.AddConnection2
' *******************************************************
Public Sub AddConnection2(ByVal xi_strPassword As String, _
                          ByVal xi_strUserName As String, _
                          ByVal xi_strLocalName As String, _
                          ByVal xi_strRemoteName As String, _
                          Optional ByVal xi_blnPersistent As Boolean = False)
   Const cnstProcName                  As String = "AddConnection2"
   
   modWNetCalls.AddConnection2 xi_strPassword:=xi_strPassword, _
                               xi_strUserName:=xi_strUserName, _
                               xi_strLocalName:=xi_strLocalName, _
                               xi_strRemoteName:=xi_strRemoteName, _
                               xi_blnIsWin9x:=True, _
                               xi_blnPersistent:=xi_blnPersistent
                              
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB AddConnection3
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:35:26
' Inputs       : ByVal xi_strPassword:String    - Password (can be blank)
'              : ByVal xi_strUserName:String    - UserID (can be blank)
'              : ByVal xi_strLocalName:String   - The local name of resource
'              : ByVal xi_strRemoteName:String  - The remote name of resource
'              : ByVal xi_lngHwndOwner:Long     - Window which will own the dialog
'              : Optional ByVal xi_blnPersistent:Boolean = False - Do you make this a persistent connection?
' Outputs      : N/A
' Description  : Makes a connection to a network resource. The
'              :     FUNCTION can redirect a local device to
'              :     the network resource.
'              : The main difference is that WNetAddConnection3
'              :     has an additional parameter, a handle to a
'              :     window that the provider of network resources
'              :     can use as an owner window for dialog boxes.
' Called By    : cNetCalls.AddConnection3
' *******************************************************
Public Sub AddConnection3(ByVal xi_strPassword As String, _
                          ByVal xi_strUserName As String, _
                          ByVal xi_strLocalName As String, _
                          ByVal xi_strRemoteName As String, _
                          ByVal xi_lngHwndOwner As Long, _
                          Optional ByVal xi_blnPersistent As Boolean = False)
   Const cnstProcName                  As String = "AddConnection3"
   
   modWNetCalls.AddConnection3 xi_strPassword:=xi_strPassword, _
                               xi_strUserName:=xi_strUserName, _
                               xi_strLocalName:=xi_strLocalName, _
                               xi_strRemoteName:=xi_strRemoteName, _
                               xi_lngHwndOwner:=xi_lngHwndOwner, _
                               xi_blnIsWin9x:=True, _
                               xi_blnPersistent:=xi_blnPersistent
                               
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB CancelConnection
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:40:54
' Inputs       : ByVal xi_strLocalName:String        - Either a mapped drive or the remote name
'              : ByVal xi_blnForceDisconnect:Boolean - Whether or not to force the disconnection if there are open files
' Outputs      : N/A
' Description  : Cancels an existing network connection.
'              : The WNetCancelConnection FUNCTION is provided
'              :     for compatibility with 16-bit versions of
'              :     Windows.
'              : Win32-based applications should call the
'              :     WNetCancelConnection2 FUNCTION
' Called By    : cNetCalls.CancelConnection
' *******************************************************
Public Sub CancelConnection(ByVal xi_strLocalName As String, _
                            ByVal xi_blnForceDisconnect As Boolean)
   Const cnstProcName                  As String = "CancelConnection"
   
   modWNetCalls.CancelConnection xi_strLocalName:=xi_strLocalName, _
                                 xi_blnForceDisconnect:=xi_blnForceDisconnect, _
                                 xi_blnIsWin9x:=True
                                 
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB CancelConnection2
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:43:09
' Inputs       : ByVal xi_strLocalName:String        - Either a mapped drive or the remote name
'              : ByVal xi_blnForceDisconnect:Boolean - Whether or not to force the disconnection if there are open files
' Outputs      : N/A
' Description  : Cancels an existing network connection.
'              : You can also call the FUNCTION to remove
'              :     remembered network connections that
'              :     are not currently connected.
' Called By    : cNetCalls.CancelConnection2
' *******************************************************
Public Sub CancelConnection2(ByVal xi_strLocalName As String, _
                             ByVal xi_blnForceDisconnect As Boolean)
   Const cnstProcName                  As String = "CancelConnection2"
   
   modWNetCalls.CancelConnection2 xi_strLocalName:=xi_strLocalName, _
                                  xi_blnForceDisconnect:=xi_blnForceDisconnect, _
                                  xi_blnIsWin9x:=True
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB ConnectDialog
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:47:24
' Inputs       : ByVal xi_lngHwnd:Long - Handle to a form which acts as parent for dialog
' Outputs      : N/A
' Description  : Starts a general browsing dialog box for
'              :     connecting to network resources.
'              : The FUNCTION requires a handle to the
'              :     owner window for the dialog box.
' Called By    : cNetCalls.ConnectDialog
' *******************************************************
Public Sub ConnectDialog(ByVal xi_lngHwnd As Long)
   Const cnstProcName                  As String = "ConnectDialog"
   
   modWNetCalls.ConnectDialog xi_lngHwnd:=xi_lngHwnd, _
                              xi_blnIsWin9x:=True
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB DisconnectDialog
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:50:19
' Inputs       : ByVal xi_lngHwnd:Long - Handle to a form which acts as parent for dialog
' Outputs      : N/A
' Description  : Starts a general browsing dialog box for
'              :     disconnecting from network resources.
'              : The FUNCTION requires a handle to the
'              :     owner window for the dialog box.
' Called By    : cNetCalls
' *******************************************************
Public Sub DisconnectDialog(ByVal xi_lngHwnd As Long)
   Const cnstProcName                  As String = "DisconnectDialog"
   
   modWNetCalls.DisconnectDialog xi_lngHwnd:=xi_lngHwnd, _
                                 xi_blnIsWin9x:=True
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetUniversalName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:51:41
' Inputs       : ByVal xi_strLocalPath:String - Pointer to a constant null-terminated string that is a drive-based path for a network resource.
'              :                                For example, if drive H has been mapped to a network drive
'              :                                share, and the network resource of interest is a file named
'              :                                SAMPLE.DOC in the directory \WIN32\EXAMPLES on that share,
'              :                                the drive-based path is H:\WIN32\EXAMPLES\SAMPLE.DOC.
'              : ByVal xi_enmNameInfoLevel:enmNameInfoLevel - Either UNIVERSAL_NAME_INFO_LEVEL or REMOTE_NAME_INFO_LEVEL
' Outputs      : Variant:
' Description  : Takes a drive-based path for a network resource
'              :     and returns an information structure that
'              :     contains a more universal form of the name.
' Called By    : cNetCalls.GetUniversalName
' *******************************************************
Public Function GetUniversalName(ByVal xi_strLocalPath As String, _
                                 ByVal xi_enmNameInfoLevel As enmNameInfoLevel) As Variant
   Const cnstProcName                  As String = "GetUniversalName"

   GetUniversalName = modWNetCalls.GetUniversalName(xi_strLocalPath:=xi_strLocalPath, _
                                                    xi_enmNameInfoLevel:=xi_enmNameInfoLevel, _
                                                    xi_blnIsWin95:=m_blnIsWin95, _
                                                    xi_blnIsWin9x:=True)
                                 
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetUserName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:53:32
' Inputs       : ByVal xi_strDeviceName:String - Can be a drive letter or blank
' Outputs      : String --
' Description  : Retrieves the current default user name, or
'              :     the user name used to establish a
'              :     network connection.
'              : If this the xi_strDeviceName is NULL, the
'              :     system returns the name of the
'              :     current user for the process
' Called By    : cNetCalls.GetUserName
' *******************************************************
Public Function GetUserName(ByVal xi_strDeviceName As String) As String
   Const cnstProcName                  As String = "GetUserName"
   
   GetUserName = modWNetCalls.GetUserName(xi_strDeviceName:=xi_strDeviceName, _
                                          xi_blnIsWin9x:=True)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetResourceName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:57:08
' Inputs       : ByVal xi_strDriveLetter:String - A valid drive letter
' Outputs      : String --
' Description  : Retrieves the name of the network resource
'              :     associated with a local device.
' Called By    : cNetCalls.GetResourceName
' *******************************************************
Public Function GetResourceName(ByVal xi_strDriveLetter As String) As String
   Const cnstProcName                  As String = "GetResourceName"
   
   GetResourceName = modWNetCalls.GetResourceName(xi_strDriveLetter:=xi_strDriveLetter, _
                                                  xi_blnIsWin9x:=True)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumResources
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:58:35
' Inputs       : ByVal xi_enmResourceType:enmResourceType - Type of resource to filter for
' Outputs      : Variant --
' Description  : Enumerates the network resources or
'              :     existing connections.
' Called By    : cNetCalls.EnumResources
' *******************************************************
Public Function EnumResources(ByVal xi_enmResourceType As enmResourceType) As Variant
   Const cnstProcName                  As String = "EnumResources"
   
   EnumResources = modWNetCalls.EnumResources(xi_enmResourceType:=xi_enmResourceType, _
                                              xi_blnIsWin9x:=True)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB MapDrive
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:14:43
' Inputs       : ByVal xi_lngHwnd:Long                       - Handle to a form to act a parent for dialog
'              : Optional ByVal xi_strLocalName:String = ""  - Local name of resource (i.e., "H:")
'              : Optional ByVal xi_strRemoteName:String = "" - Remote name of resource (i.e., "\\MyServer\MyShare")
' Outputs      : N/A
' Description  : Brings up a general browsing dialog for
'              :     connecting to network resources.
'              : The FUNCTION requires a CONNECTDLGSTRUCT
'              :     to establish the dialog box parameters.
' Called By    : cNetCalls.MapDrive
' *******************************************************
Public Sub MapDrive(ByVal xi_lngHwnd As Long, _
                    Optional ByVal xi_strLocalName As String = "", _
                    Optional ByVal xi_strRemoteName As String = "")
   Const cnstProcName                  As String = "MapDrive"
   
   modWNetCalls.MapDrive xi_lngHwnd:=xi_lngHwnd, _
                         xi_blnIsWin9x:=True, _
                         xi_strLocalName:=xi_strLocalName, _
                         xi_strRemoteName:=xi_strRemoteName
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB UnmapDrive
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:16:29
' Inputs       : ByVal xi_lngHwnd:Long        - Handle to a form to act a parent for dialog
'              : ByVal xi_strLocalName:String - Local name of mapped drive (i.e., "H:")
' Outputs      : N/A
' Description  : Attempts to disconnect a network resource.
'              : If the underlying network returns ERROR_OPEN_FILES,
'              :     the FUNCTION prompts the user for confirmation.
'              : If there is any error, the FUNCTION informs
'              :     the user.
'              : The FUNCTION requires a DISCDLGSTRUCT to specify
'              :     the parameters for the disconnect attempt.
' Called By    : cNetCalls.UnmapDrive
' *******************************************************
Public Sub UnmapDrive(ByVal xi_lngHwnd As Long, _
                      ByVal xi_strLocalName As String)
   Const cnstProcName                  As String = "UnmapDrive"
   
   modWNetCalls.UnmapDrive xi_lngHwnd:=xi_lngHwnd, _
                           xi_strLocalName:=xi_strLocalName, _
                           xi_blnIsWin9x:=True
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetNetInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:19:40
' Inputs       : N/A
' Outputs      : Variant:
' Description  : Obtains the provider name for a specific
'              :     type of network.
' Called By    : cNetCalls.GetNetInfo
' *******************************************************
Public Function GetNetInfo() As Variant
   Const cnstProcName                  As String = "GetNetInfo"
   
   GetNetInfo = modWNetCalls.GetNetInfo(xi_blnIsWin9x:=True)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetResInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:20:54
' Inputs       : ByVal xi_strRemoteName:String - The Remote Name (i.e., "\\MyServer\MyShare")
' Outputs      : N/A
' Description  : When provided with a remote path to a network
'              :     resource, the WNetGetResourceInformation
'              :     FUNCTION identifies the network provider
'              :     that owns the resource and obtains
'              :     information about the type of the resource.
'              : The FUNCTION is typically used in conjunction
'              :     with the WNetGetResourceParent FUNCTION
'              :     to parse and interpret a network path
'              :     typed in by a user.
' Called By    : cNetCalls.GetResInfo
' *******************************************************
Public Function GetResInfo(ByVal xi_strRemoteName As String) As Variant
   Const cnstProcName                  As String = "GetResInfo"
   
   GetResInfo = modWNetCalls.GetResInfo(xi_strRemoteName:=xi_strRemoteName, _
                                        xi_blnIsWin9x:=True)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB GetResParent
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:23:36
' Inputs       : ByVal xi_strRemoteName:String - The Remote Name (i.e., "\\MyServer\MyShare")
' Outputs      : Variant:
' Description  : The WNetGetResourceParent FUNCTION returns
'              :     the parent of a network resource in
'              :     the network browse hierarchy.
'              : Browsing begins at the location of the
'              :     specified network resource.
'              : Call the WNetGetResourceInformation and
'              :     WNetGetResourceParent FUNCTIONs to
'              :     move up the network hierarchy.
'              : Call the WNetOpenEnum FUNCTION to move
'              :     down the hierarchy.
' Called By    : cNetCalls.GetResParent
' *******************************************************
Public Function GetResParent(ByVal xi_strRemoteName As String) As Variant
   Const cnstProcName                  As String = "GetResParent"

   GetResParent = modWNetCalls.GetResParent(xi_strRemoteName:=xi_strRemoteName, _
                                            xi_blnIsWin9x:=True)
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION UseConnection
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:26:23
' Inputs       : ByVal xi_lngHwnd:Long         - Handle for window that will be parent for any dialogs
' Inputs       : ByVal xi_strRemoteName:String - The Remote Name (i.e., "\\MyServer\MyShare")
'              : ByVal xi_strUserID:String     - UserID
'              : ByVal xi_strPW:String         - Password for this userID
'              : Optional ByVal xi_strLocalName:String = "" - The Local Name (i.e., "H:")
' Outputs      : String --
' Description  : The WNetUseConnection FUNCTION makes a
'              :     connection to a network resource.
'              : The FUNCTION can redirect a local device
'              :     to a network resource.
'              : The WNetUseConnection FUNCTION is similar to the
'              :     WNetAddConnection3 FUNCTION. The main difference
'              :     is that WNetUseConnection can automatically
'              :     select an unused local device to redirect
'              :     to the network resource.
' Called By    : cNetCalls.UseConnection
' *******************************************************
Public Function UseConnection(ByVal xi_lngHwnd As Long, _
                              ByVal xi_strRemoteName As String, _
                              ByVal xi_strUserID As String, _
                              ByVal xi_strPW As String, _
                              Optional ByVal xi_strLocalName As String = "") As String
   Const cnstProcName                  As String = "UseConnection"

   UseConnection = modWNetCalls.UseConnection(xi_lngHwnd:=xi_lngHwnd, _
                                              xi_strRemoteName:=xi_strRemoteName, _
                                              xi_strUserID:=xi_strUserID, _
                                              xi_strPW:=xi_strPW, _
                                              xi_blnIsWin9x:=True, _
                                              xi_strLocalName:=xi_strLocalName)

End Function


' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' +++                           NET... FUNCTIONs
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumShares
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:56:25
' Inputs       : ByVal xi_strServerName:String - Server name (can be blank)
' Outputs      : Variant:
' Description  : Retrieves information about each shared
'              :     resource on a server.
' Security     : Windows NT: Administrator or Communication,
'              :     Print, or Server operator group membership
'              :     is required to successfully execute the
'              :     NetShareEnum FUNCTION at levels 2 and 502.
'              : No special group membership is required for
'              :     level 0 or level 1 calls.
'              : For W2K+, see MSDN
' Called By    : cNetCalls.EnumShares
' *******************************************************
Public Function EnumShares(ByVal xi_strServerName As String) As Variant
   Dim p_vntRtn                        As Variant
   Dim p_intEntriesRead                As Integer
   Dim p_intTotalEntries               As Integer
   Dim p_lngRtn                        As Long
   Dim p_lngBufferLen                  As Long
   Dim p_lngLoop                       As Long
   Dim p_lngOffset                     As Long
   Dim p_typShareInfo_50               As Share_Info_50_9x
   Dim p_typShareInfo_1                As Share_Info_1_9x
   Dim p_blnIsLevel50                  As Boolean
   Dim p_abytBuffer()                  As Byte
   Dim p_lngNumTries                   As Long
   Const cnstProcName                  As String = "EnumShares"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   p_lngNumTries = 0&
   p_lngBufferLen = 0&
   
TryAgain:

   ' ------------------------------------------
   ' Set a very large (incremental) buffer
   ' ------------------------------------------
   p_lngBufferLen = p_lngBufferLen + 16384&
   ReDim p_abytBuffer(0 To (p_lngBufferLen - 1)) As Byte
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' First try level 50
   ' ------------------------------------------
   p_blnIsLevel50 = False
   p_lngRtn = NetShareEnum95(lpServerName:=xi_strServerName, _
                             dwLevel:=50, _
                             lpBuffer:=p_abytBuffer(0), _
                             cbBuffer:=p_lngBufferLen, _
                             EntriesRead:=p_intEntriesRead, _
                             TotalEntries:=p_intTotalEntries)
   If p_lngRtn = NERR_SUCCESS Then
      p_blnIsLevel50 = True
   Else
      p_lngRtn = NetShareEnum95(lpServerName:=xi_strServerName, _
                                dwLevel:=1, _
                                lpBuffer:=p_abytBuffer(0), _
                                cbBuffer:=p_lngBufferLen, _
                                EntriesRead:=p_intEntriesRead, _
                                TotalEntries:=p_intTotalEntries)
      If p_lngRtn <> NERR_SUCCESS Then
         If ((p_lngRtn = 234) Or (p_lngRtn = 2123)) _
              And (p_lngNumTries < MAX_TRIES) Then
            Err.Clear
            p_lngNumTries = p_lngNumTries + 1
            GoTo TryAgain
         Else
            GoTo Err_Handler
         End If
      End If
   End If
   
   ' ------------------------------------------
   ' Exit if no entries found
   ' ------------------------------------------
   If p_intEntriesRead < 1 Then
      GoTo Clean_Up
   End If
   
   ' ------------------------------------------
   ' Redim the type array to hold this info
   ' ------------------------------------------
   ReDim p_vntRtn(0 To 9, 0 To (p_intEntriesRead - 1)) As Variant

   ' ------------------------------------------
   ' Copy the pointer to the buffer into the
   '     type array
   ' ------------------------------------------
   p_lngOffset = 0
   For p_lngLoop = 0 To (p_intEntriesRead - 1)

      If p_blnIsLevel50 = True Then
         CopyMem pTo:=p_typShareInfo_50, _
                 uFrom:=p_abytBuffer(p_lngOffset), _
                 lSize:=Len(p_typShareInfo_50)
         
         With p_typShareInfo_50
            p_vntRtn(enmShareEnum.Netname, p_lngLoop) = TrimNull(StrConv(.Netname, vbUnicode))
            p_vntRtn(enmShareEnum.Remark, p_lngLoop) = PointerToStringA(.lpRemark)
            p_vntRtn(enmShareEnum.Path, p_lngLoop) = PointerToStringA(.lpPath)
            p_vntRtn(enmShareEnum.Password, p_lngLoop) = vbNullString
            p_vntRtn(enmShareEnum.MaxUses, p_lngLoop) = 0      ' Available on NT+
            p_vntRtn(enmShareEnum.CurrUses, p_lngLoop) = 0     ' Available on NT+
            p_vntRtn(enmShareEnum.ShareType, p_lngLoop) = .ShareType
            p_vntRtn(enmShareEnum.ShareTypeText, p_lngLoop) = TransShareType(.ShareType)
            ' NOTE: Only the share-level security, not the user-level security
            p_vntRtn(enmShareEnum.Permissions, p_lngLoop) = 0  ' Available on NT+
            p_vntRtn(enmShareEnum.PermissionsText, p_lngLoop) = TransPermissions(-1)
         End With
      
         p_lngOffset = p_lngOffset + Len(p_typShareInfo_50)
      
      Else
         CopyMem pTo:=p_typShareInfo_1, _
                 uFrom:=p_abytBuffer(p_lngOffset), _
                 lSize:=Len(p_typShareInfo_1)
         
         With p_typShareInfo_1
            p_vntRtn(enmShareEnum.Netname, p_lngLoop) = TrimNull(StrConv(.shi1_netname, vbUnicode))
            p_vntRtn(enmShareEnum.Remark, p_lngLoop) = PointerToStringA(.shi1_remark)
            If IsRemoteWin9x(xi_strServerName) = True Then
               p_vntRtn(enmShareEnum.Path, p_lngLoop) = CNST_FAILURE_LEVEL50
            Else
               p_vntRtn(enmShareEnum.Path, p_lngLoop) = CNST_NOT_AVAILABLE
            End If
            
            p_vntRtn(enmShareEnum.Password, p_lngLoop) = vbNullString
            p_vntRtn(enmShareEnum.MaxUses, p_lngLoop) = 0      ' Available on NT+
            p_vntRtn(enmShareEnum.CurrUses, p_lngLoop) = 0     ' Available on NT+
            p_vntRtn(enmShareEnum.ShareType, p_lngLoop) = .shi1_type
            p_vntRtn(enmShareEnum.ShareTypeText, p_lngLoop) = TransShareType(.shi1_type)
            ' NOTE: Only the share-level security, not the user-level security
            p_vntRtn(enmShareEnum.Permissions, p_lngLoop) = 0  ' Available on NT+
            p_vntRtn(enmShareEnum.PermissionsText, p_lngLoop) = TransPermissions(-1)
         End With
      
         p_lngOffset = p_lngOffset + Len(p_typShareInfo_1)
      
      End If
      
   Next p_lngLoop
   
   EnumShares = p_vntRtn
      
Clean_Up:
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetShareEnum, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumConnections
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:32:15
' Inputs       : ByVal xi_strServerName:String - Name of server (can be blank)
'              : ByVal xi_strQualifier:String  - A share name or computer name
' Outputs      : Variant:
' Description  : Lists all connections made to a shared resource
'              :     on the server or all connections
'              :     established from a particular computer.
' Security     : Admin or server, print, or comm operator group
'              :     membership is required to successfully
'              :     execute the NetConnectionEnum FUNCTION.
' Called By    : cNetCalls.EnumConnections
' *******************************************************
Public Function EnumConnections(ByVal xi_strServerName As String, _
                                ByVal xi_strQualifier As String) As Variant
   Dim p_lngRtn                        As Long
   Dim p_intEntriesRead                As Integer
   Dim p_intTotalEntries               As Integer
   Dim p_lngBufferLen                  As Long
   Dim p_lngLoop                       As Long
   Dim p_lngOffset                     As Long
   Dim p_vntRtn                        As Variant
   Dim p_strUserName                   As String
   Dim p_strNetName                    As String
   Dim p_typConnInfo_50                As Connection_Info_50_9x
   Dim p_abytBuffer()                  As Byte
   Dim p_lngNumTries                   As Long
   Const cnstProcName                  As String = "EnumConnections"

   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   xi_strQualifier = UCase$(xi_strQualifier)
   
   ' ------------------------------------------
   ' Level 50 is the *ONLY* level supported on
   '     the Win9x platform, and that can't be
   '     used to access NT+ computers
   ' ------------------------------------------
   If IsRemoteWin9x(xi_strServerName) = False Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="Cannot call the NetConnectionEnum function from a Win9x to a NT+ computer."
   End If
   
   p_lngNumTries = 0&
   p_lngBufferLen = 0&
   
TryAgain:

   ' ------------------------------------------
   ' Set a very large (incremental) buffer
   ' ------------------------------------------
   p_lngBufferLen = p_lngBufferLen + 16384&
   ReDim p_abytBuffer(0 To (p_lngBufferLen - 1)) As Byte
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetConnectionEnum95(lpServer:=xi_strServerName, _
                                  lpQualifier:=xi_strQualifier, _
                                  dwLevel:=50, _
                                  lpBuffer:=p_abytBuffer(0), _
                                  cbBuffer:=p_lngBufferLen, _
                                  EntriesRead:=p_intEntriesRead, _
                                  TotalAvailable:=p_intTotalEntries)
   If p_lngRtn <> NERR_SUCCESS Then
      If ((p_lngRtn = 234) Or (p_lngRtn = 2123)) _
           And (p_lngNumTries < MAX_TRIES) Then
         Err.Clear
         p_lngNumTries = p_lngNumTries + 1
         GoTo TryAgain
      Else
         GoTo Err_Handler
      End If
   End If
   
   ' ------------------------------------------
   ' Exit if no entries found
   ' ------------------------------------------
   If p_intEntriesRead < 1 Then
      GoTo Clean_Up
   End If
   
   ' ------------------------------------------
   ' Redim the type array to hold this info
   ' ------------------------------------------
   ReDim p_vntRtn(0 To 7, 0 To (p_intEntriesRead - 1)) As Variant

   ' ------------------------------------------
   ' Copy the pointer to the buffer into the
   '     type array
   ' ------------------------------------------
   p_lngOffset = 0
   
   For p_lngLoop = 0 To (p_intEntriesRead - 1)
      
      CopyMem pTo:=p_typConnInfo_50, _
              uFrom:=p_abytBuffer(p_lngOffset), _
              lSize:=Len(p_typConnInfo_50)
      
      With p_typConnInfo_50
         p_strNetName = PointerToStringA(.coni50_netname)
         p_strUserName = PointerToStringA(.coni50_username)
         
         ' ---------------------------------------
         ' If not a user (remote connection), then
         '     give the net name
         ' ---------------------------------------
         If Len(Trim$(p_strNetName)) = 0 Then
            p_strNetName = xi_strQualifier
         End If
         
         p_vntRtn(enmNetConnections.UserName, p_lngLoop) = p_strUserName
         p_vntRtn(enmNetConnections.Netname, p_lngLoop) = p_strNetName
         p_vntRtn(enmNetConnections.ConnectID, p_lngLoop) = 0        ' Available on NT+
         p_vntRtn(enmNetConnections.ConnectTime, p_lngLoop) = .coni50_time
         p_vntRtn(enmNetConnections.ConnectNumOpens, p_lngLoop) = .coni50_num_opens
         p_vntRtn(enmNetConnections.ConnectNumUses, p_lngLoop) = 0   ' Available on NT+
         p_vntRtn(enmNetConnections.ConnectType, p_lngLoop) = .coni50_type
         p_vntRtn(enmNetConnections.ConnectTypeText, p_lngLoop) = TransShareType(.coni50_type)
      End With
      
      p_lngOffset = p_lngOffset + Len(p_typConnInfo_50)
      
   Next p_lngLoop
   
   EnumConnections = p_vntRtn
      
Clean_Up:

Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetConnectionEnum, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumFiles
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:39:28
' Inputs       : ByVal xi_strServerName:String - Server name (can be blank)
' Outputs      : Variant
' Description  : Returns information about all open files on a server
' Security     : Only members of the Administrators or Account Operators
'              :     local group can successfully execute the
'              :     NetFileEnum FUNCTION.
' Called By    : cNetCalls.EnumFiles
' *******************************************************
Public Function EnumFiles(ByVal xi_strServerName As String) As Variant
   Dim p_typFileInfo_50                As File_Info_50_9x
   Dim p_lngRtn                        As Long
   Dim p_lngBufferLen                  As Long
   Dim p_lngLoop                       As Long
   Dim p_lngOffset                     As Long
   Dim p_intEntriesRead                As Integer
   Dim p_intTotalEntries               As Integer
   Dim p_strBasePath                   As String
   Dim p_vntRtn                        As Variant
   Dim p_abytBuffer()                  As Byte
   Dim p_lngNumTries                   As Long
   Const cnstProcName                  As String = "EnumFiles"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   ' ------------------------------------------
   ' Level 50 is the *ONLY* level supported on
   '     the Win9x platform, and that can't be
   '     used to access NT+ computers
   ' ------------------------------------------
   If IsRemoteWin9x(xi_strServerName) = False Then
      Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="Cannot call the NetFileEnum function from a Win9x to a NT+ computer."
   End If
   
   ' ------------------------------------------
   ' If this parameter is NULL, all open resources
   '     are enumerated.
   ' If this parameter is not NULL, the function
   '     enumerates only resources that have
   '     basepath as a prefix.
   ' (A prefix is the path component up to a backslash.)
   ' ------------------------------------------
   p_strBasePath = vbNullString
   
   p_lngNumTries = 0&
   p_lngBufferLen = 0&
   
TryAgain:

   ' ------------------------------------------
   ' Set a very large (incremental) buffer
   ' ------------------------------------------
   p_lngBufferLen = p_lngBufferLen + 16384&
   ReDim p_abytBuffer(0 To (p_lngBufferLen - 1)) As Byte
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetFileEnum95(lpServer:=xi_strServerName, _
                            lpBasePath:=p_strBasePath, _
                            dwLevel:=50, _
                            lpBuffer:=p_abytBuffer(0), _
                            cbBuffer:=p_lngBufferLen, _
                            EntriesRead:=p_intEntriesRead, _
                            TotalAvailable:=p_intTotalEntries)
                           
   If p_lngRtn <> NERR_SUCCESS Then
      If ((p_lngRtn = 234) Or (p_lngRtn = 2123)) _
           And (p_lngNumTries < MAX_TRIES) Then
         Err.Clear
         p_lngNumTries = p_lngNumTries + 1
         GoTo TryAgain
      Else
         GoTo Err_Handler
      End If
   End If
   
   ' ------------------------------------------
   ' Exit if no entries found
   ' ------------------------------------------
   If p_intEntriesRead < 1 Then
      GoTo Clean_Up
   End If
   
   ' ------------------------------------------
   ' Redim the type array to hold this info
   ' ------------------------------------------
   ReDim p_vntRtn(0 To 6, 0 To (p_intEntriesRead - 1)) As Variant

   ' ------------------------------------------
   ' Copy the pointer to the buffer into the
   '     type array
   ' ------------------------------------------
   p_lngOffset = 0
   For p_lngLoop = 0 To (p_intEntriesRead - 1)
      
      CopyMem pTo:=p_typFileInfo_50, _
              uFrom:=p_abytBuffer(p_lngOffset), _
              lSize:=Len(p_typFileInfo_50)
      
      With p_typFileInfo_50
         p_vntRtn(enmFileEnum.PathName, p_lngLoop) = PointerToStringA(.fi50_pathname)
         p_vntRtn(enmFileEnum.UserName, p_lngLoop) = PointerToStringA(.fi50_username)
         p_vntRtn(enmFileEnum.ShareName, p_lngLoop) = PointerToStringA(.fi50_sharename)
         p_vntRtn(enmFileEnum.ID, p_lngLoop) = .fi50_id
         p_vntRtn(enmFileEnum.NumLocks, p_lngLoop) = .fi50_num_locks
         p_vntRtn(enmFileEnum.Permissions, p_lngLoop) = .fi50_permissions
         p_vntRtn(enmFileEnum.PermissionsText, p_lngLoop) = TransPermissions(.fi50_permissions)
      End With
      
      p_lngOffset = p_lngOffset + Len(p_typFileInfo_50)

   Next p_lngLoop
   
   EnumFiles = p_vntRtn
      
Clean_Up:

Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetFileEnum, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumSessions
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:50:54
' Inputs       : ByVal xi_strServerName:String - Server Name (can be blank)
' Outputs      : Variant:
' Description  : Provides information about sessions established
'              :     on a server
' Security     : Only members of the Administrators or Account
'              :     Operators local group can successfully
'              :     execute the NetSessionEnum FUNCTION at
'              :     level 1 or level 2.
'              : No special group membership is required
'              :     for level 0 or level 10 calls.
' Called By    : cNetCalls.EnumSessions
' *******************************************************
Public Function EnumSessions(ByVal xi_strServerName As String) As Variant
   Dim p_lngRtn                        As Long
   Dim p_lngOffset                     As Long
   Dim p_lngBufferLen                  As Long
   Dim p_lngLoop                       As Long
   Dim p_intEntriesRead                As Integer
   Dim p_intTotalEntries               As Integer
   Dim p_vntRnt                        As Variant
   Dim p_blnIsLevel50                  As Boolean
   Dim p_typSessionInfo_50             As Session_Info_50_9x
   Dim p_typSessionInfo_1              As Session_Info_1_9x
   Dim p_abytBuffer()                  As Byte
   Dim p_lngNumTries                   As Long
   Const cnstProcName                  As String = "EnumSessions"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   p_lngNumTries = 0&
   p_lngBufferLen = 0&
   
TryAgain:

   ' ------------------------------------------
   ' Set a very large (incremental) buffer
   ' ------------------------------------------
   p_lngBufferLen = p_lngBufferLen + 16384&
   ReDim p_abytBuffer(0 To (p_lngBufferLen - 1)) As Byte
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_blnIsLevel50 = False
   p_lngRtn = NetSessionEnum95(lpServer:=xi_strServerName, _
                               dwLevel:=50, _
                               lpBuffer:=p_abytBuffer(0), _
                               cbBuffer:=4096, _
                               EntriesRead:=p_intEntriesRead, _
                               TotalAvailable:=p_intTotalEntries)
   If p_lngRtn = NERR_SUCCESS Then
      p_blnIsLevel50 = True
   Else
      p_lngRtn = NetSessionEnum95(lpServer:=xi_strServerName, _
                                  dwLevel:=1, _
                                  lpBuffer:=p_abytBuffer(0), _
                                  cbBuffer:=4096, _
                                  EntriesRead:=p_intEntriesRead, _
                                  TotalAvailable:=p_intTotalEntries)
                              
      If p_lngRtn <> NERR_SUCCESS Then
         If ((p_lngRtn = 234) Or (p_lngRtn = 2123)) _
              And (p_lngNumTries < MAX_TRIES) Then
            Err.Clear
            p_lngNumTries = p_lngNumTries + 1
            GoTo TryAgain
         Else
            GoTo Err_Handler
         End If
      End If
   End If
   
   ' ------------------------------------------
   ' Exit if no entries found
   ' ------------------------------------------
   If p_intEntriesRead < 1 Then
      GoTo Clean_Up
   End If
   
   ' ------------------------------------------
   ' Redim the type array to hold this info
   ' ------------------------------------------
   ReDim p_vntRtn(0 To 9, 0 To (p_intEntriesRead - 1)) As Variant

   ' ------------------------------------------
   ' Copy the pointer to the buffer into the
   '     type array
   ' ------------------------------------------
   p_lngOffset = 0
   
   For p_lngLoop = 0 To (p_intEntriesRead - 1)
      
      If p_blnIsLevel50 = True Then
         CopyMem pTo:=p_typSessionInfo_50, _
                 uFrom:=p_abytBuffer(p_lngOffset), _
                 lSize:=Len(p_typSessionInfo_50)
         
         With p_typSessionInfo_50
            p_vntRtn(enmEnumSessions.ClientForSession, p_lngLoop) = PointerToStringA(.sesi50_username)
            p_vntRtn(enmEnumSessions.UserName, p_lngLoop) = PointerToStringA(.sesi50_username)
            p_vntRtn(enmEnumSessions.ComputerForSession, p_lngLoop) = PointerToStringA(.sesi50_cname)
            p_vntRtn(enmEnumSessions.Transport, p_lngLoop) = vbNullString
            p_vntRtn(enmEnumSessions.IdleTime, p_lngLoop) = .sesi50_idle_time
            p_vntRtn(enmEnumSessions.NumConnections, p_lngLoop) = .sesi50_num_conns
            p_vntRtn(enmEnumSessions.NumOpens, p_lngLoop) = .sesi50_num_opens
            p_vntRtn(enmEnumSessions.TimeOpen, p_lngLoop) = .sesi50_idle_time
            p_vntRtn(enmEnumSessions.UserFlags, p_lngLoop) = 0             ' Available on NT+
            p_vntRtn(enmEnumSessions.UserFlagsText, p_lngLoop) = TransUserFlags(0)
         End With
         
         p_lngOffset = p_lngOffset + Len(p_typSessionInfo_1)
         
      ElseIf p_blnIsLevel50 = False Then
         CopyMem pTo:=p_typSessionInfo_1, _
                 uFrom:=p_abytBuffer(p_lngOffset), _
                 lSize:=Len(p_typSessionInfo_1)
         
         With p_typSessionInfo_1
            p_vntRtn(enmEnumSessions.ClientForSession, p_lngLoop) = PointerToStringA(.sesi1_username)
            p_vntRtn(enmEnumSessions.UserName, p_lngLoop) = PointerToStringA(.sesi1_username)
            p_vntRtn(enmEnumSessions.ComputerForSession, p_lngLoop) = PointerToStringA(.sesi1_cname)
            p_vntRtn(enmEnumSessions.Transport, p_lngLoop) = vbNullString
            p_vntRtn(enmEnumSessions.IdleTime, p_lngLoop) = .sesi1_idle_time
            p_vntRtn(enmEnumSessions.NumConnections, p_lngLoop) = .sesi1_num_conns
            p_vntRtn(enmEnumSessions.NumOpens, p_lngLoop) = .sesi1_num_opens
            p_vntRtn(enmEnumSessions.TimeOpen, p_lngLoop) = .sesi1_idle_time
            p_vntRtn(enmEnumSessions.UserFlags, p_lngLoop) = 0             ' Available on NT+
            p_vntRtn(enmEnumSessions.UserFlagsText, p_lngLoop) = TransUserFlags(0)
         End With
         
         p_lngOffset = p_lngOffset + Len(p_typSessionInfo_1)
         
      End If
   Next p_lngLoop
   
   EnumSessions = p_vntRtn
      
Clean_Up:

Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetSessionEnum, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetSessionInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:58:01
' Inputs       : ByVal xi_strServerName:String  - Name of server (can be blank)
'              : ByVal xi_strSessionName:String - Name of session (required)
'              : ByVal xi_strUserName:String    - Name of user of session (required)
' Outputs      : Variant:
' Description  : Retrieves information about a session established
'              :     between a particular server and workstation.
' Security     : Windows NT: Only members of the Administrators or
'              :     Account Operators local group can successfully
'              :     execute the NetSessionGetInfo FUNCTION
'              :     at level 1 or level 2.
'              : No special group membership is required
'              :     for level 0 or level 10 calls.
'              : W2K+: See MSDN
' Called By    : cNetCalls.GetSessionInfo
' *******************************************************
Public Function GetSessionInfo(ByVal xi_strServerName As String, _
                               ByVal xi_strSessionName As String, _
                               ByVal xi_strUserName As String) As Variant
   Dim p_lngRtn                        As Long
   Dim p_intTotalAvail                 As Integer
   Dim p_lngBufferLen                  As Long
   Dim p_vntRtn                        As Variant
   Dim p_blnIsLevel2                   As Boolean
   Dim p_typShareInfo_1                As Session_Info_1_9x
   Dim p_typShareInfo_2                As Session_Info_2_9x
   Dim p_abytBuffer()                  As Byte
   Dim p_lngNumTries                   As Long
   Const cnstProcName                  As String = "GetSessionInfo"

   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   If Len(Trim$(xi_strSessionName)) > 0 Then
      If Left$(xi_strSessionName, 2) <> "\\" Then
         xi_strSessionName = "\\" & xi_strSessionName
      End If
   End If
   
   ' ------------------------------------------
   '                *** NOTE ****
   ' UserName is not used in Win9x version of call
   ' ------------------------------------------
   
   p_lngNumTries = 0&
   p_lngBufferLen = 0&
   
TryAgain:

   ' ------------------------------------------
   ' Set a very large (incremental) buffer
   ' ------------------------------------------
   p_lngBufferLen = p_lngBufferLen + 16384&
   ReDim p_abytBuffer(0 To (p_lngBufferLen - 1)) As Byte
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_blnIsLevel2 = False
   p_lngRtn = NetSessionGetInfo95(lpServer:=xi_strServerName, _
                                  lpClientName:=xi_strSessionName, _
                                  dwLevel:=2, _
                                  lpBuffer:=p_abytBuffer(0), _
                                  cbBuffer:=p_lngBufferLen, _
                                  TotalAvailable:=p_intTotalAvail)
   If p_lngRtn = NERR_SUCCESS Then
      p_blnIsLevel2 = True
   Else
      p_lngRtn = NetSessionGetInfo95(lpServer:=xi_strServerName, _
                                     lpClientName:=xi_strSessionName, _
                                     dwLevel:=1, _
                                     lpBuffer:=p_abytBuffer(0), _
                                     cbBuffer:=p_lngBufferLen, _
                                     TotalAvailable:=p_intTotalAvail)
                              
      If p_lngRtn <> NERR_SUCCESS Then
         If ((p_lngRtn = 234) Or (p_lngRtn = 2123)) _
              And (p_lngNumTries < MAX_TRIES) Then
            Err.Clear
            p_lngNumTries = p_lngNumTries + 1
            GoTo TryAgain
         Else
            GoTo Err_Handler
         End If
      End If
   End If
   
   ReDim p_vntRtn(0 To 8) As Variant

   If p_blnIsLevel2 = True Then
      CopyMem p_typShareInfo_2, _
              p_abytBuffer(0), _
              Len(p_typShareInfo_2)
   
      With p_typShareInfo_2
         p_vntRtn(enmSessionInfo.ClientForSession) = PointerToStringA(.sesi2_cltype_name)
         p_vntRtn(enmSessionInfo.UserName) = PointerToStringA(.sesi2_username)
         p_vntRtn(enmSessionInfo.ComputerForSession) = PointerToStringA(.sesi2_cname)
         p_vntRtn(enmSessionInfo.IdleTime) = .sesi2_idle_time
         p_vntRtn(enmSessionInfo.NumOpens) = .sesi2_num_opens
         p_vntRtn(enmSessionInfo.NumConnects) = .sesi2_num_conns
         p_vntRtn(enmSessionInfo.TimeOpen) = .sesi2_time
         p_vntRtn(enmSessionInfo.UserFlags) = .sesi2_user_flags
         p_vntRtn(enmSessionInfo.UserFlagsText) = TransUserFlags(.sesi2_user_flags)
      End With
   
   ElseIf p_blnIsLevel2 = False Then
      CopyMem p_typShareInfo_1, _
              p_abytBuffer(0), _
              Len(p_typShareInfo_1)

      With p_typShareInfo_1
         p_vntRtn(enmSessionInfo.ClientForSession) = vbNullString
         p_vntRtn(enmSessionInfo.UserName) = PointerToStringA(.sesi1_username)
         p_vntRtn(enmSessionInfo.ComputerForSession) = PointerToStringA(.sesi1_cname)
         p_vntRtn(enmSessionInfo.IdleTime) = .sesi1_idle_time
         p_vntRtn(enmSessionInfo.NumOpens) = .sesi1_num_opens
         p_vntRtn(enmSessionInfo.NumConnects) = .sesi1_num_conns
         p_vntRtn(enmSessionInfo.TimeOpen) = .sesi1_time
         p_vntRtn(enmSessionInfo.UserFlags) = .sesi1_user_flags
         p_vntRtn(enmSessionInfo.UserFlagsText) = TransUserFlags(.sesi1_user_flags)
      End With
   
   End If

   GetSessionInfo = p_vntRtn
   
Clean_Up:
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetSessionGetInfo, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetServerInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:42:10
' Inputs       : ByVal xi_strServerName:String - Name of server (can be blank)
' Outputs      : Variant:
' Description  : Retrieves current configuration
'              :     information for the specified server.
' Security     : Only the Administrators or Accounts
'              :     Operators local group, or those
'              :     with Communication, Print, or
'              :     Server operator group membership
'              :     can successfully execute the
'              :     NetServerGetInfo FUNCTION at level 102.
'              : No special group membership is required for
'              :     level 100 or level 101 calls.
' Called By    : cNetCalls.GetServerInfo
' *******************************************************
Public Function GetServerInfo(ByVal xi_strServerName As String) As Variant
   Dim p_abytServerName()              As Byte
   Dim p_vntRtn                        As Variant
   Dim p_strServerName                 As String
   Dim p_lngRtn                        As Long
   Dim p_intTotalAvail                 As Integer
   Dim p_lngBufferLen                  As Long
   Dim p_blnIsLevel50                  As Boolean
   Dim p_typServerInfo_1               As Server_Info_1_9x
   Dim p_typServerInfo_50              As Server_Info_50_9x
   Dim p_abytBuffer()                  As Byte
   Dim p_lngNumTries                   As Long
   Const cnstProcName                  As String = "GetServerInfo"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   p_lngNumTries = 0&
   p_lngBufferLen = 0&
   
TryAgain:

   ' ------------------------------------------
   ' Set a very large (incremental) buffer
   ' ------------------------------------------
   p_lngBufferLen = p_lngBufferLen + 16384&
   ReDim p_abytBuffer(0 To (p_lngBufferLen - 1)) As Byte
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_blnIsLevel50 = False
   p_lngRtn = NetServerGetInfo95(lpServer:=ByVal xi_strServerName, _
                                 dwLevel:=50, _
                                 lpBuffer:=p_abytBuffer(0), _
                                 cbBuffer:=p_lngBufferLen, _
                                 TotalAvailable:=p_intTotalAvail)
   If p_lngRtn = NERR_SUCCESS Then
      p_blnIsLevel50 = True
   Else
      p_lngRtn = NetServerGetInfo95(lpServer:=ByVal xi_strServerName, _
                                    dwLevel:=1, _
                                    lpBuffer:=p_abytBuffer(0), _
                                    cbBuffer:=p_lngBufferLen, _
                                    TotalAvailable:=p_intTotalAvail)
                              
      If p_lngRtn <> NERR_SUCCESS Then
         If ((p_lngRtn = 234) Or (p_lngRtn = 2123)) _
              And (p_lngNumTries < MAX_TRIES) Then
            Err.Clear
            p_lngNumTries = p_lngNumTries + 1
            GoTo TryAgain
         Else
            GoTo Err_Handler
         End If
      End If
   End If
   
   ReDim p_vntRtn(0 To 6) As Variant
   
   If p_blnIsLevel50 = True Then
   
      CopyMem p_typServerInfo_50, _
              p_abytBuffer(0), _
              Len(p_typServerInfo_50)
            
      With p_typServerInfo_50
         p_strServerName = TrimNull(StrConv(.sv50_name, vbUnicode))
         If Len(p_strServerName) = 0 Then
            p_strServerName = xi_strServerName
         End If
         If Len(p_strServerName) = 0 Then
            p_strServerName = "[Local]"
         End If
         
         p_vntRtn(enmServerInfo.ServerName) = p_strServerName
         p_vntRtn(enmServerInfo.Comment) = PointerToStringA(.sv50_comment)
         p_vntRtn(enmServerInfo.ID) = 0
         p_vntRtn(enmServerInfo.MajorVer) = .sv50_version_major
         p_vntRtn(enmServerInfo.MinorVer) = .sv50_version_minor
         p_vntRtn(enmServerInfo.ServerType) = .sv50_type
         p_vntRtn(enmServerInfo.ServerTypeText) = TransServerType(.sv50_type)
         
         Debug.Print PointerToStringA(.sv50_ab_dll)
         Debug.Print PointerToStringA(.sv50_ab_server)
         Debug.Print .sv50_auditing
         Debug.Print PointerToStringA(.sv50_security)
         
      End With
   
   ElseIf p_blnIsLevel50 = False Then
   
      CopyMem p_typServerInfo_1, _
              p_abytBuffer(0), _
              Len(p_typServerInfo_1)
            
      With p_typServerInfo_1
         p_strServerName = TrimNull(StrConv(.sv1_name, vbUnicode))
         If Len(p_strServerName) = 0 Then
            p_strServerName = xi_strServerName
         End If
         If Len(p_strServerName) = 0 Then
            p_strServerName = "[Local]"
         End If
         
         p_vntRtn(enmServerInfo.ServerName) = p_strServerName
         p_vntRtn(enmServerInfo.Comment) = PointerToStringA(.sv1_comment)
         p_vntRtn(enmServerInfo.ID) = 0
         p_vntRtn(enmServerInfo.MajorVer) = .sv1_version_major
         p_vntRtn(enmServerInfo.MinorVer) = .sv1_version_minor
         p_vntRtn(enmServerInfo.ServerType) = .sv1_type
         p_vntRtn(enmServerInfo.ServerTypeText) = TransServerType(.sv1_type)
         
         ' Only on Win9x side
         '.sv50_ab_dll
         '.sv50_ab_server
         '.sv50_auditing
         '.sv50_security
      End With

   End If
   GetServerInfo = p_vntRtn
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetServerGetInfo, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetNetShareInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 10:59:55
' Inputs       : ByVal xi_strServerName:String - The server name (can be blank)
'              : ByVal xi_strShareName:String  - The share name to get info on
' Outputs      : Variant:
' Description  : Retrieves information about a particular
'              :     shared resource on a server.
' Security     : Only members of the Administrators or Account
'              :     Operators local group or those with
'              :     Communication, Print, or Server operator
'              :     group membership can successfully execute
'              :     the NetShareGetInfo FUNCTION at level 2.
'              : No special group membership is required for
'              :     level 0 or level 1 calls.
' Called By    : cNetCalls.GetNetShareInfo
' *******************************************************
Public Function GetNetShareInfo(ByVal xi_strServerName As String, _
                                ByVal xi_strShareName As String) As Variant
   Dim p_vntRtn                        As Variant
   Dim p_lngRtn                        As Long
   Dim p_intTotalAvail                 As Integer
   Dim p_lngBufferLen                  As Long
   Dim p_blnIsLevel50                  As Boolean
   Dim p_typShareInfo_1                As Share_Info_1_9x
   Dim p_typShareInfo_50               As Share_Info_50_9x
   Dim p_abytBuffer()                  As Byte
   Dim p_lngNumTries                   As Long
   Const cnstProcName                  As String = "GetNetShareInfo"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   ' ------------------------------------------
   ' Sharename needs to be upper-cased on Win9x
   ' ------------------------------------------
   xi_strShareName = UCase$(Trim$(xi_strShareName))
   
   p_lngNumTries = 0&
   p_lngBufferLen = 0&
   
TryAgain:

   ' ------------------------------------------
   ' Set a very large (incremental) buffer
   ' ------------------------------------------
   p_lngBufferLen = p_lngBufferLen + 16384&
   ReDim p_abytBuffer(0 To (p_lngBufferLen - 1)) As Byte
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_blnIsLevel50 = False
   p_lngRtn = NetShareGetInfo95(lpServer:=xi_strServerName, _
                                lpNetname:=xi_strShareName, _
                                dwLevel:=50, _
                                lpBuffer:=p_abytBuffer(0), _
                                cbBuffer:=p_lngBufferLen, _
                                TotalAvailable:=p_intTotalAvail)
   If p_lngRtn = NERR_SUCCESS Then
      p_blnIsLevel50 = True
   Else
      p_lngRtn = NetShareGetInfo95(lpServer:=xi_strServerName, _
                                   lpNetname:=xi_strShareName, _
                                   dwLevel:=1, _
                                   lpBuffer:=p_abytBuffer(0), _
                                   cbBuffer:=p_lngBufferLen, _
                                   TotalAvailable:=p_intTotalAvail)
                              
      If p_lngRtn <> NERR_SUCCESS Then
         If ((p_lngRtn = 234) Or (p_lngRtn = 2123)) _
              And (p_lngNumTries < MAX_TRIES) Then
            Err.Clear
            p_lngNumTries = p_lngNumTries + 1
            GoTo TryAgain
         Else
            GoTo Err_Handler
         End If
      End If
   End If
   
   ReDim p_vntRtn(0 To 9) As Variant
   
   If p_blnIsLevel50 = True Then
      CopyMem pTo:=p_typShareInfo_50, _
              uFrom:=p_abytBuffer(0), _
              lSize:=Len(p_typShareInfo_50)
      
      With p_typShareInfo_50
         p_vntRtn(enmShareEnum.Netname) = TrimNull(StrConv(.Netname, vbUnicode))
         p_vntRtn(enmShareEnum.Remark) = PointerToStringA(.lpRemark)
         p_vntRtn(enmShareEnum.Path) = PointerToStringA(.lpPath)
         p_vntRtn(enmShareEnum.Password) = vbNullString
         p_vntRtn(enmShareEnum.MaxUses) = 0      ' Available on NT+
         p_vntRtn(enmShareEnum.CurrUses) = 0     ' Available on NT+
         p_vntRtn(enmShareEnum.ShareType) = .ShareType
         p_vntRtn(enmShareEnum.ShareTypeText) = TransShareType(.ShareType)
         ' NOTE: Only the share-level security, not the user-level security
         p_vntRtn(enmShareEnum.Permissions) = 0  ' Available on NT+
         p_vntRtn(enmShareEnum.PermissionsText) = TransPermissions(-1)
      End With
   
   ElseIf p_blnIsLevel50 = False Then
      CopyMem pTo:=p_typShareInfo_1, _
              uFrom:=p_abytBuffer(0), _
              lSize:=Len(p_typShareInfo_1)
      
      With p_typShareInfo_1
         p_vntRtn(enmShareEnum.Netname) = TrimNull(StrConv(.shi1_netname, vbUnicode))
         p_vntRtn(enmShareEnum.Remark) = PointerToStringA(.shi1_remark)
         p_vntRtn(enmShareEnum.Path) = vbNullString  'PointerToStringA(.lpPath)
         p_vntRtn(enmShareEnum.Password) = vbNullString
         p_vntRtn(enmShareEnum.MaxUses) = 0      ' Available on NT+
         p_vntRtn(enmShareEnum.CurrUses) = 0     ' Available on NT+
         p_vntRtn(enmShareEnum.ShareType) = .shi1_type
         p_vntRtn(enmShareEnum.ShareTypeText) = TransShareType(.shi1_type)
         ' NOTE: Only the share-level security, not the user-level security
         p_vntRtn(enmShareEnum.Permissions) = 0  ' Available on NT+
         p_vntRtn(enmShareEnum.PermissionsText) = TransPermissions(-1)
      End With
   
   End If
   
   GetNetShareInfo = p_vntRtn
   
Clean_Up:

Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetShareGetInfo, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB AddShare
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 11:06:23
' Inputs       : ByVal xi_strServerName:String - Server name (can be blank)
'              : ByVal xi_strShareName:String  - Share Name
'              : ByVal xi_strPath:String       - Path to share
'              : ByVal xi_strRemark:String     - Remark (can be blank)
' Outputs      : N/A
' Description  : Shares a server resource.
' Security     : Only members of the Administrators or Account
'              :     Operators local group or those with Communication,
'              :     Print, or Server operator group membership can
'              :     successfully execute the NetShareAdd FUNCTION.
'              : The Print operator can add only Printer queues.
'              : The Communication operator can add only
'              :     communication-device queues.
' Called By    : cNetCalls.AddShare
' *******************************************************
Public Sub AddShare(ByVal xi_strServerName As String, _
                    ByVal xi_strShareName As String, _
                    ByVal xi_strPath As String, _
                    ByVal xi_strRemark As String)
   Dim p_lngRtn                        As Long
   Dim p_intTotalAvail                 As Integer
   Dim p_lngBufferLen                  As Long
   Dim p_lngLoop                       As Long
   Dim p_abytBuffer()                  As Byte
   Dim p_abytPath()                    As Byte
   Dim p_abytRemark()                  As Byte
   Dim p_abytPwRO()                    As Byte
   Dim p_abytPwRW()                    As Byte
   Dim p_typShareInfo_50               As Share_Info_50_9x
   Const cnstProcName                  As String = "AddShare"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   ' ------------------------------------------
   ' Sharename & path needs to be upper-cased on Win9x
   ' ------------------------------------------
   xi_strShareName = UCase$(Trim$(xi_strShareName))
   xi_strPath = UCase$(Trim$(xi_strPath))
   
   ' ------------------------------------------
   ' Fail if the share name is too long on Win9x
   ' ------------------------------------------
   If Len(xi_strShareName) > LM20_NNLEN Then
      Err.Raise Number:=enmCustErrors.Error_NameTooLog + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="The share name on Win9x can be a max of " & _
                             CStr(LM20_NNLEN) & " charaters."
   End If
   
   p_abytPath = StrConv(xi_strPath, vbFromUnicode) & vbNullChar
   p_abytRemark = StrConv(xi_strRemark, vbFromUnicode) & vbNullChar
   
   With p_typShareInfo_50
      For p_lngLoop = 0 To Len(xi_strShareName) - 1
         .Netname(p_lngLoop) = Asc(Mid$(xi_strShareName, (p_lngLoop + 1), 1))
      Next p_lngLoop
      
      .lpPath = VarPtr(p_abytPath(0))
      .lpRemark = VarPtr(p_abytRemark(0))
      .Flags = SHI50F_FULL + SHI50F_PERSIST
      .ShareType = enmShareType.STYPE_DISKTREE
   End With
   
   p_lngBufferLen = Len(p_typShareInfo_50)
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetShareAdd95(lpServer:=xi_strServerName, _
                            dwLevel:=50, _
                            lpBuffer:=ByVal p_typShareInfo_50, _
                            cbBuffer:=p_lngBufferLen)

   If p_lngRtn <> NERR_SUCCESS Then
      GoTo Err_Handler
   End If

Exit Sub
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetShareAdd, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB DeleteShare
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 11:26:17
' Inputs       : ByVal xi_strServerName:String - Server Name (can be blank)
'              : ByVal xi_strShareName:String  - Share Name
' Outputs      : N/A
' Description  : Deletes a share name from a server's list of
'              :     shared resources, disconnecting all
'              :     connections to the shared resource.
' Security     : Only members of the Administrators or Account
'              :     Operators local group or those with
'              :     Communication, Print, or Server operator
'              :     group membership can successfully
'              :     execute the NetShareDel FUNCTION.
'              : The Print operator can delete only
'              :     Printer queues.
'              : The Communication operator can delete
'              :     only communication-device queues.
' Called By    : cNetCalls.DeleteShare
' *******************************************************
Public Sub DeleteShare(ByVal xi_strServerName As String, _
                       ByVal xi_strShareName As String)
   Dim p_lngRtn                        As Long
   Dim p_abytServerName()              As Byte
   Dim p_abytShareName()               As Byte
   Const cnstProcName                  As String = "DeleteShare"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   ' ------------------------------------------
   ' Sharename needs to be upper-cased on Win9x
   ' ------------------------------------------
   xi_strShareName = UCase$(Trim$(xi_strShareName))

   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetShareDel95(lpServer:=xi_strServerName, _
                            lpNetname:=xi_strShareName, _
                            Reserved:=0)

   If p_lngRtn <> NERR_SUCCESS Then
      If p_lngRtn = ERR_WRONG_CALL_LEVEL Then
         Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                   Source:=cnstProcName, _
                   Description:=CNST_CANNOT_USE1 & "NetShareDel" & _
                                CNST_CANNOT_USE2
      Else
         GoTo Err_Handler
      End If
   End If

Exit Sub
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetShareDel, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB SetShareInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 12:31:05
' Inputs       : ByVal xi_strServerName:String - Server Name (can be blank)
'              : ByVal xi_strShareName:String  - Name of the share
'              : ByVal xi_strRemark:String     - Remark (change)
' Outputs      : N/A
' Description  : Sets the parameters of a shared resource
' Security     : Only the Administrators local group or
'              :     Communication, Print, or Server
'              :     operator group membership is
'              :     required to successfully execute
'              :     the NetShareSetInfo FUNCTION.
'              : The Print operator can set information
'              :     only about Printer queues.
'              : The Communication operator can set
'              :     information only about
'              :     communication-device queues.
' Called By    : cNetCalls.SetShareInfo
' *******************************************************
Public Sub SetShareInfo(ByVal xi_strServerName As String, _
                        ByVal xi_strShareName As String, _
                        ByVal xi_strRemark As String)
   Dim p_lngRtn                        As Long
   Dim p_lngBufferLen_1                As Long
   Dim p_lngBufferLen_50               As Long
   Dim p_intTotalAvail                 As Integer
   Dim p_vntRtn                        As Variant
   Dim p_blnIsLevel50                  As Boolean
   Dim p_afbytNetname(0 To LM20_NNLEN) As Byte
   Dim p_abytRemark()                  As Byte
   Dim p_abytNetName()                 As Byte
   Dim p_typShareInfo_1                As Share_Info_1_9x
   Dim p_typShareInfo_50               As Share_Info_50_9x
   Const cnstProcName                  As String = "SetShareInfo"

   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Sharename needs to be upper-cased on Win9x
   ' ------------------------------------------
   xi_strShareName = UCase$(Trim$(xi_strShareName))
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_vntRtn = GetNetShareInfo(xi_strServerName, _
                              xi_strShareName)
   
   ' ------------------------------------------
   ' Set the remark
   ' ------------------------------------------
   p_abytRemark = StrConv(xi_strRemark & vbNullChar, vbFromUnicode)
   
   With p_typShareInfo_1
      .shi1_remark = VarPtr(p_abytRemark(0))
   End With
   
   With p_typShareInfo_50
      .lpRemark = VarPtr(p_abytRemark(0))
   End With
   
   p_lngBufferLen_1 = Len(p_typShareInfo_1)
   p_lngBufferLen_50 = Len(p_typShareInfo_50)
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_blnIsLevel50 = False
   p_lngRtn = NetShareSetInfo95(lpServer:=xi_strServerName, _
                                lpNetname:=xi_strShareName, _
                                dwLevel:=50, _
                                lpBuffer:=ByVal p_typShareInfo_50, _
                                cbBuffer:=p_lngBufferLen_50, _
                                sParmNum:=PARMNUM_ALL)
   If p_lngRtn = NERR_SUCCESS Then
      p_blnIsLevel50 = True
   Else
      p_lngRtn = NetShareSetInfo95(lpServer:=xi_strServerName, _
                                   lpNetname:=xi_strShareName, _
                                   dwLevel:=1, _
                                   lpBuffer:=ByVal p_typShareInfo_1, _
                                   cbBuffer:=p_lngBufferLen_1, _
                                   sParmNum:=PARMNUM_ALL)
                              
      If p_lngRtn <> NERR_SUCCESS Then
         GoTo Err_Handler
      End If
   End If
                              
Exit Sub
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetShareSetInfo, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB CloseFile
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 11:30:14
' Inputs       : ByVal xi_lngFilePtr:Long      - Pointer to a file
'              : ByVal xi_strServerName:String - Server Name (can be blank)
'              : ByVal xi_strFileName:String   - File name (used only for error msg)
' Outputs      : N/A
' Description  : Passed the pointer to the file, and the
'              :     name of the server (can be blank),
'              :     close this network-opened file
'              : Note: The filename passed only for the
'              :       error message
' Security     : Only members of the Administrators or
'              :     Account Operators local group can
'              :     successfully execute the NetFileClose
'              :     FUNCTION.
' Called By    : cNetCalls.CloseFiles
' *******************************************************
Public Sub CloseFile(ByVal xi_lngFilePtr As Long, _
                     ByVal xi_strServerName As String, _
                     ByVal xi_strFileName As String)
   Dim p_lngRtn                        As Long
   Const cnstProcName                  As String = "CloseFile"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetFileClose2(lpServer:=xi_strFileName, _
                            ulFileID:=xi_lngFilePtr)
   If p_lngRtn <> NERR_SUCCESS Then
      GoTo Err_Handler
   End If

Exit Sub
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetFileClose (for the file, " & _
                          xi_strFileName & "), got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Sub DeleteSession
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/22/2001 -- 16:34:11
' Inputs       : ByVal xi_strUserName:String    - Name of the user whose session is to be terminated (can be blank)
'              : ByVal xi_strServerName:String  - Server Name (can be blank)
'              : Optional ByVal xi_strMachineName:String = "" - Computer name of the client to disconnect
'              :                    NOTE: This parm isn't used on Win9x version
' Outputs      : N/A
' Description  : Passed the name of the user
'              :     this session is on, delete this
'              :     session.
'              : Ends a network session between a server
'              :     and a workstation.
' Security     : Only members of the Administrators
'              :     or Account Operators local group
'              :     can successfully execute the NetSessionDel
'              :     FUNCTION.
' Called By    : cNetCalls.DeleteSession
' *******************************************************
Public Sub DeleteSession(ByVal xi_strUserName As String, _
                         ByVal xi_strServerName As String, _
                         Optional ByVal xi_strMachineName As String = "")
   Dim p_lngRtn                        As Long
   Const cnstProcName                  As String = "DeleteSession"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' Set servername to upper-case
   ' ------------------------------------------
   xi_strServerName = UCase$(PrepareServerName(xi_strServerName))
   
   ' ------------------------------------------
   ' NOTE: xi_strMachineName isn't used in Win9x
   ' UserName needs to be upper-cased on Win9x
   ' ------------------------------------------
   xi_strUserName = UCase$(Trim$(xi_strUserName))
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = NetSessionDel95(lpServer:=xi_strServerName, _
                              lpClientName:=xi_strUserName, _
                              sReserved:=0)
   If p_lngRtn <> NERR_SUCCESS Then
      If p_lngRtn = ERR_WRONG_CALL_LEVEL Then
         Err.Raise Number:=ERR_WRONG_CALL_LEVEL + cnstErrBase, _
                   Source:=cnstProcName, _
                   Description:=CNST_CANNOT_USE1 & "NetSessionDel" & _
                                CNST_CANNOT_USE2
      Else
         GoTo Err_Handler
      End If
   End If

Exit Sub
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling NetSessionDel, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, True) & "'"
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) Function TrimNull
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 10/13/2001 -- 21:04:53
' Inputs       : ByVal xi_strPassed:String -
' Outputs      : String --
' Description  : Trim anything after the NULL character,
'              :     and also do a regular trim
' Called By    : *****
' *******************************************************
Public Function TrimNull(ByVal xi_strPassed As String) As String
   Dim p_lngPos                        As Long
   
   p_lngPos = InStr(xi_strPassed, vbNullChar)
   
   Select Case p_lngPos
      Case Is > 1
         TrimNull = Left$(xi_strPassed, p_lngPos - 1)
      Case 1
         TrimNull = vbNullString
      Case 0
         TrimNull = Trim$(xi_strPassed)
   End Select
   
End Function

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Function IsRemoteWin9x
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 10/13/2001 -- 21:07:01
' Inputs       : ByVal xi_strServerName:String -
' Outputs      : Boolean --
' Description  : Check to see if the remote machine is
'              :     Win9x (as opposed to NT+)
' Called By    : *****
' *******************************************************
Private Function IsRemoteWin9x(ByVal xi_strServerName As String) As Boolean
   Dim p_vntRtn                        As Variant
   
   p_vntRtn = GetServerInfo(xi_strServerName)
   
   If p_vntRtn(3) = 4 Then
      IsRemoteWin9x = True
   Else
      IsRemoteWin9x = False
   End If

End Function

' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' +++                           CLASS Methods
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

' *******************************************************
' Routine Name : (PRIVATE in CLASS) Sub Class_Initialize
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 13:42:03
' Inputs       : N/A
' Outputs      : N/A
' Description  : Already know it's a Win9x call
'              : Need to find out if it's Win95 or a
'              :     later version
' Called By    : cNetCalls
' *******************************************************
Private Sub Class_Initialize()
   Dim p_objGetOS                      As cOsVersion
   Dim p_enmOsType                     As enmValidOSs
   Const cnstProcName                  As String = "Class_Initialize"
   
   Set p_objGetOS = New cOsVersion
   
   p_enmOsType = p_objGetOS.TypeValidOS
   
   Select Case p_enmOsType
      Case Valid_Win95
         m_blnIsWin95 = True
      Case Valid_Win98, _
           Valid_WinME
         m_blnIsWin95 = False
      Case Else
         ' Raise error -- invalid OS
         Err.Raise Number:=enmCustErrors.Error_Invalid_OS + cnstErrBase, _
                   Source:=cnstProcName, _
                   Description:="Invalid OS"
   End Select
   
End Sub
