Attribute VB_Name = "modWNetCalls"
' ************************************************************
' Copyright  1995-2001 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the VBPJ site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************

' ---------------------------------------------
' Module    : modWNetCalls.BAS
' By        : L.J. Johnson       Date: 09-23-2001
' Comments  : Used by both NT+ and Win9x systems
' ---------------------------------------------
Option Explicit

' ---------------------------------------------
' Types used by the WNet* calls
' ---------------------------------------------
Private Type UNIVERSAL_NAME_INFO
   lpUniversalName                     As Long
End Type

Private Type REMOTE_NAME_INFO
   lpUniversalName                     As Long
   lpConnectionName                    As Long
   lpRemainingPath                     As Long
End Type

Private Type NETRESOURCE_LONG
   dwScope                             As Long
   dwType                              As Long
   dwDisplayType                       As Long
   dwUsage                             As Long
   lpLocalName                         As Long
   lpRemoteName                        As Long
   lpComment                           As Long
   lpProvider                          As Long
End Type

Private Type NETRESOURCE_STRING
   dwScope                             As Long
   dwType                              As Long
   dwDisplayType                       As Long
   dwUsage                             As Long
   lpLocalName                         As String
   lpRemoteName                        As String
   lpComment                           As String
   lpProvider                          As String
End Type

Private Type NETINFOSTRUCT
   cbStructure                         As Long
   dwProviderVersion                   As Long
   dwStatus                            As Long
   dwCharacteristics                   As Long
   dwHandle                            As Long
   wNetType                            As Long
   dwPrinters                          As Long
   dwDrives                            As Long
End Type

Private Type DISCDLGSTRUCT
   cbStructure                         As Long
   HwndOwner                           As Long
   lpLocalName                         As String
   lpRemoteName                        As String
   dwFlags                             As Long
End Type

Private Type CONNECTDLGSTRUCT
  cbStructure                          As Long
  HwndOwner                            As Long
  lpConnRes                            As Long
  dwFlags                              As Long
  dwDevNum                             As Long
End Type

' ---------------------------------------------
' WNet... FUNCTIONs
' ---------------------------------------------

' Used in AddConnection2
Private Declare Function WNetAddConnection2 _
   Lib "mpr.dll" Alias "WNetAddConnection2A" _
   (lpNetResource As NETRESOURCE_STRING, _
    ByVal lpPassword As String, _
    ByVal lpUserName As String, _
    ByVal dwFlags As Long) As Long
' Used in AddConnection3
Private Declare Function WNetAddConnection3 _
   Lib "mpr.dll" Alias "WNetAddConnection3A" _
   (HwndOwner As Long, _
    lpNetResource As NETRESOURCE_STRING, _
    ByVal lpPassword As String, _
    ByVal lpUserName As String, _
    ByVal dwFlags As Long) As Long
' Used in CancelConnection
Private Declare Function WNetCancelConnection _
   Lib "mpr.dll" Alias "WNetCancelConnectionA" _
   (ByVal lpName As String, _
    ByVal fForce As Long) As Long
' Used in CancelConnection2
Private Declare Function WNetCancelConnection2 _
   Lib "mpr.dll" Alias "WNetCancelConnection2A" _
   (ByVal lpName As String, _
    ByVal dwFlags As Long, _
    ByVal fForce As Long) As Long
' Used in ConnectDialog
Private Declare Function WNetConnectionDialog _
   Lib "mpr.dll" _
   (ByVal hWnd As Long, _
    ByVal dwType As Long) As Long
' Used in DisconnectDialog
Private Declare Function WNetDisconnectDialog _
   Lib "mpr.dll" _
   (ByVal hWnd As Long, _
    ByVal dwType As Long) As Long
' Used in GetUniversalName
' Fails under Win95 (Q131416) -- use WNetOpenEnum and WNetEnumResource
Private Declare Function WNetGetUniversalName _
   Lib "mpr.dll" Alias "WNetGetUniversalNameA" _
   (ByVal lpLocalPath As String, _
    ByVal dwInfoLevel As Long, _
    lpBuffer As Any, _
    lpBufferSize As Long) As Long
' Used in GetUserName
Private Declare Function WNetGetUser _
   Lib "mpr.dll" Alias "WNetGetUserA" _
   (ByVal lpDeviceName As String, _
    ByVal lpUserName As String, _
    lpnLength As Long) As Long
' Used in GetResourceName
Private Declare Function WNetGetConnection _
   Lib "mpr.dll" Alias "WNetGetConnectionA" _
   (ByVal lpszLocalName As String, _
    ByVal lpszRemoteName As String, _
    cbRemoteName As Long) As Long
' Used in EnumResources
Private Declare Function WNetOpenEnum _
   Lib "mpr.dll" Alias "WNetOpenEnumA" _
   (ByVal dwScope As Long, _
    ByVal dwType As Long, _
    ByVal dwUsage As Long, _
    lpNetResource As Any, _
    lphEnum As Long) As Long
' Used in EnumResources
Private Declare Function WNetEnumResource _
   Lib "mpr.dll" Alias "WNetEnumResourceA" _
   (ByVal hEnum As Long, _
    lpcCount As Long, _
    lpBuffer As Any, _
    lpBufferSize As Long) As Long
' Used in EnumResources
Private Declare Function WNetCloseEnum _
   Lib "mpr.dll" _
   (ByVal hEnum As Long) As Long
Private Declare Function WNetGetLastError _
   Lib "mpr.dll" Alias "WNetGetLastErrorA" _
   (lpError As Long, _
    ByVal lpErrorBuf As String, _
    ByVal nErrorBufSize As Long, _
    ByVal lpNameBuf As String, _
    ByVal nNameBufSize As Long) As Long

' ---------------------------------------------
' Following WNet... FUNCTIONs will run on
'     Win9x and NT 4.0+
' ---------------------------------------------

' Used in MapDrive
Private Declare Function WNetConnectionDialog1 _
   Lib "mpr.dll" Alias "WNetConnectionDialog1A" _
   (lpConnDlgStruct As CONNECTDLGSTRUCT) As Long
' Used in UnmapDrive
Private Declare Function WNetDisconnectDialog1 _
   Lib "mpr.dll" Alias "WNetDisconnectDialog1A" _
   (lpConnDlgStruct As DISCDLGSTRUCT) As Long
' Used in GetNetInfo
Private Declare Function WNetGetNetworkInformation _
   Lib "mpr.dll" Alias "WNetGetNetworkInformationA" _
   (ByVal lpProvider As String, _
    lpNetInfoStruct As NETINFOSTRUCT) As Long
' Used in GetNetInfo
Private Declare Function WNetGetProviderName _
   Lib "mpr.dll" Alias "WNetGetProviderNameA" _
   (ByVal dwNetType As Long, _
    ByVal lpProviderName As String, _
    lpBufferSize As Long) As Long
' Used in GetResInfo
Private Declare Function WNetGetResourceInformation _
   Lib "mpr.dll" Alias "WNetGetResourceInformationA" _
   (lpNetResource As NETRESOURCE_STRING, _
    lpBuffer As Any, _
    cbBuffer As Long, _
    lplpSystem As Long) As Long
' Used in GetResParent
Private Declare Function WNetGetResourceParent _
   Lib "mpr.dll" Alias "WNetGetResourceParentA" _
   (lpNetResource As NETRESOURCE_STRING, _
    lpBuffer As Any, _
    lpBufferSize As Long) As Long
' Used in UseConnection
Private Declare Function WNetUseConnection _
   Lib "mpr.dll" Alias "WNetUseConnectionA" _
   (ByVal HwndOwner As Long, _
    lpNetResource As NETRESOURCE_STRING, _
    ByVal lpUserID As Any, _
    ByVal lpPassword As Any, _
    ByVal dwFlags As Long, _
    ByVal lpAccessname As String, _
    lpBufferSize As Long, _
    lpResult As Long) As Long

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB AddConnection2
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:32:53
' Inputs       : ByVal xi_strPassword:String    - Password (can be blank)
'              : ByVal xi_strUserName:String    - UserID (can be blank)
'              : ByVal xi_strLocalName:String   - The local name of resource
'              : ByVal xi_strRemoteName:String  - The remote name of resource
'              : ByVal xi_blnIsWin9x:Boolean    - Is this on a Win9x machine?
'              : Optional ByVal xi_blnPersistent:Boolean = False - Do you make this a persistent connection?
' Outputs      : N/A
' Description  : Makes a connection to a network resource.
'              : The FUNCTION can redirect a local device
'              :     to the network resource.
' Called By    : cNetCalls.AddConnection2
' *******************************************************
Public Sub AddConnection2(ByVal xi_strPassword As String, _
                          ByVal xi_strUserName As String, _
                          ByVal xi_strLocalName As String, _
                          ByVal xi_strRemoteName As String, _
                          ByVal xi_blnIsWin9x As Boolean, _
                          Optional ByVal xi_blnPersistent As Boolean = False)
   Dim p_lngRtn                        As Long
   Dim p_lngFlags                      As Long
   Dim p_typNetRes                     As NETRESOURCE_STRING
   Const cnstProcName                  As String = "AddConnection2"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   p_typNetRes.dwType = enmResType.RESOURCETYPE_DISK
   p_typNetRes.lpLocalName = xi_strLocalName
   p_typNetRes.lpRemoteName = xi_strRemoteName
   
   If xi_blnPersistent = True Then
      p_lngFlags = CONNECT_UPDATE_PROFILE Or CONNECT_INTERACTIVE
   Else
      p_lngFlags = CONNECT_INTERACTIVE
   End If
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' Password and username must be null on Win9x
   ' ------------------------------------------
   If xi_blnIsWin9x = True Then
      p_lngRtn = WNetAddConnection2(lpNetResource:=p_typNetRes, _
                                    lpPassword:=vbNullString, _
                                    lpUserName:=vbNullString, _
                                    dwFlags:=p_lngFlags)
   ElseIf xi_blnIsWin9x = False Then
      p_lngRtn = WNetAddConnection2(lpNetResource:=p_typNetRes, _
                                    lpPassword:=xi_strPassword, _
                                    lpUserName:=xi_strUserName, _
                                    dwFlags:=p_lngFlags)
   End If
   
   If p_lngRtn = NO_ERROR Then
      ' Success
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetAddConnection2, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB AddConnection3
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:35:26
' Inputs       : ByVal xi_strPassword:String    - Password (can be blank)
'              : ByVal xi_strUserName:String    - UserID (can be blank)
'              : ByVal xi_strLocalName:String   - The local name of resource
'              : ByVal xi_strRemoteName:String  - The remote name of resource
'              : ByVal xi_lngHwndOwner:Long     - Window which will own the dialog
'              : ByVal xi_blnIsWin9x:Boolean    - Is this on a Win9x machine?
'              : Optional ByVal xi_blnPersistent:Boolean = False - Do you make this a persistent connection?
' Outputs      : N/A
' Description  : Makes a connection to a network resource. The
'              :     FUNCTION can redirect a local device to
'              :     the network resource.
'              : The main difference is that WNetAddConnection3
'              :     has an additional parameter, a handle to a
'              :     window that the provider of network resources
'              :     can use as an owner window for dialog boxes.
' Called By    : cNetCalls.AddConnection3
' *******************************************************
Public Sub AddConnection3(ByVal xi_strPassword As String, _
                          ByVal xi_strUserName As String, _
                          ByVal xi_strLocalName As String, _
                          ByVal xi_strRemoteName As String, _
                          ByVal xi_lngHwndOwner As Long, _
                          ByVal xi_blnIsWin9x As Boolean, _
                          Optional ByVal xi_blnPersistent As Boolean = False)
   Dim p_lngRtn                        As Long
   Dim p_lngFlags                      As Long
   Dim p_typNetRes                     As NETRESOURCE_STRING
   Const cnstProcName                  As String = "AddConnection3"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   p_typNetRes.dwType = enmResType.RESOURCETYPE_DISK
   p_typNetRes.lpLocalName = xi_strLocalName
   p_typNetRes.lpRemoteName = xi_strRemoteName
   
   If xi_blnPersistent = True Then
      p_lngFlags = CONNECT_UPDATE_PROFILE Or CONNECT_INTERACTIVE
   Else
      p_lngFlags = CONNECT_INTERACTIVE
   End If

   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' Password and UserID must be blank in Win9x
   ' ------------------------------------------
   If xi_blnIsWin9x = True Then
      p_lngRtn = WNetAddConnection3(HwndOwner:=xi_lngHwndOwner, _
                                    lpNetResource:=p_typNetRes, _
                                    lpPassword:=vbNullString, _
                                    lpUserName:=vbNullString, _
                                    dwFlags:=p_lngFlags)
   ElseIf xi_blnIsWin9x = False Then
      p_lngRtn = WNetAddConnection3(HwndOwner:=xi_lngHwndOwner, _
                                    lpNetResource:=p_typNetRes, _
                                    lpPassword:=vbNullString, _
                                    lpUserName:=vbNullString, _
                                    dwFlags:=p_lngFlags)
   End If
   
   If p_lngRtn = NO_ERROR Then
      ' Success
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetAddConnection3, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB CancelConnection
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:40:54
' Inputs       : ByVal xi_strLocalName:String        - Either a mapped drive or the remote name
'              : ByVal xi_blnForceDisconnect:Boolean - Whether or not to force the disconnection if there are open files
'              : ByVal xi_blnIsWin9x:Boolean         - Is this on a Win9x machine?
' Outputs      : N/A
' Description  : Cancels an existing network connection.
'              : The WNetCancelConnection FUNCTION is provided
'              :     for compatibility with 16-bit versions of
'              :     Windows.
'              : Win32-based applications should call the
'              :     WNetCancelConnection2 FUNCTION
' Called By    : cNetCalls.CancelConnection
' *******************************************************
Public Sub CancelConnection(ByVal xi_strLocalName As String, _
                            ByVal xi_blnForceDisconnect As Boolean, _
                            ByVal xi_blnIsWin9x As Boolean)
   Dim p_lngRtn                        As Long
   Const cnstProcName                  As String = "CancelConnection"
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = WNetCancelConnection(lpName:=xi_strLocalName, _
                                   fForce:=xi_blnForceDisconnect)
                                  
   If p_lngRtn = NO_ERROR Then
      ' Success
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetCancelConnection, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB CancelConnection2
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:43:09
' Inputs       : ByVal xi_strLocalName:String        - Either a mapped drive or the remote name
'              : ByVal xi_blnForceDisconnect:Boolean - Whether or not to force the disconnection if there are open files
'              : ByVal xi_blnIsWin9x:Boolean         - Is this on a Win9x machine?
' Outputs      : N/A
' Description  : Cancels an existing network connection.
'              : You can also call the FUNCTION to remove
'              :     remembered network connections that
'              :     are not currently connected.
' Called By    : cNetCalls.CancelConnection2
' *******************************************************
Public Sub CancelConnection2(ByVal xi_strLocalName As String, _
                             ByVal xi_blnForceDisconnect As Boolean, _
                             ByVal xi_blnIsWin9x As Boolean)
   Dim p_lngRtn                        As Long
   Dim p_lngFlags                      As Long
   Const cnstProcName                  As String = "CancelConnection2"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   p_lngFlags = CONNECT_UPDATE_PROFILE
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = WNetCancelConnection2(lpName:=xi_strLocalName, _
                                    dwFlags:=p_lngFlags, _
                                    fForce:=xi_blnForceDisconnect)
                                  
   If p_lngRtn = NO_ERROR Then
      ' Success
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetCancelConnection2, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB ConnectDialog
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:47:24
' Inputs       : ByVal xi_lngHwnd:Long         - Handle to a form which acts as parent for dialog
'              : ByVal xi_blnIsWin9x:Boolean   - Is this on a Win9x machine?
' Outputs      : N/A
' Description  : Starts a general browsing dialog box for
'              :     connecting to network resources.
'              : The FUNCTION requires a handle to the
'              :     owner window for the dialog box.
' Called By    : cNetCalls.ConnectDialog
' *******************************************************
Public Sub ConnectDialog(ByVal xi_lngHwnd As Long, _
                         ByVal xi_blnIsWin9x As Boolean)
   Dim p_lngRtn                        As Long
   Const cnstProcName                  As String = "ConnectDialog"
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = WNetConnectionDialog(hWnd:=xi_lngHwnd, _
                                   dwType:=enmResType.RESOURCETYPE_DISK)
   
   If p_lngRtn = NO_ERROR Then
      ' Success
   Else
      If p_lngRtn = -1 Then
         ' User cancelled
         Err.Raise Number:=enmCustErrors.User_Cancelled + cnstErrBase, _
                   Source:=cnstProcName, _
                   Description:="User cancelled"
      Else
         Err.Raise Number:=p_lngRtn + cnstErrBase, _
                   Source:=cnstProcName, _
                   Description:="When calling WNetConnectionDialog, got the error, " & vbCrLf & _
                                vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
      End If
   End If
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB DisconnectDialog
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:50:19
' Inputs       : ByVal xi_lngHwnd:Long         - Handle to a form which acts as parent for dialog
'              : ByVal xi_blnIsWin9x:Boolean   - Is this on a Win9x machine?
' Outputs      : N/A
' Description  : Starts a general browsing dialog box for
'              :     disconnecting from network resources.
'              : The FUNCTION requires a handle to the
'              :     owner window for the dialog box.
' Called By    : cNetCalls
' *******************************************************
Public Sub DisconnectDialog(ByVal xi_lngHwnd As Long, _
                            ByVal xi_blnIsWin9x As Boolean)
   Dim p_lngRtn                        As Long
   Const cnstProcName                  As String = "DisconnectDialog"
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = WNetDisconnectDialog(hWnd:=xi_lngHwnd, _
                                   dwType:=enmResType.RESOURCETYPE_DISK)
   
   If p_lngRtn = NO_ERROR Then
      ' Success
   Else
      If p_lngRtn = -1 Then
         ' User cancelled
         Err.Raise Number:=enmCustErrors.User_Cancelled + cnstErrBase, _
                   Source:=cnstProcName, _
                   Description:="User cancelled"
      Else
         Err.Raise Number:=p_lngRtn + cnstErrBase, _
                   Source:=cnstProcName, _
                   Description:="When calling WNetDisconnectDialog, got the error, " & vbCrLf & _
                                vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
      End If
   End If
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetUniversalName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:51:41
' Inputs       : ByVal xi_strLocalPath:String - Pointer to a constant null-terminated string that is a drive-based path for a network resource.
'              :                                For example, if drive H has been mapped to a network drive
'              :                                share, and the network resource of interest is a file named
'              :                                SAMPLE.DOC in the directory \WIN32\EXAMPLES on that share,
'              :                                the drive-based path is H:\WIN32\EXAMPLES\SAMPLE.DOC.
'              : ByVal xi_enmNameInfoLevel:enmNameInfoLevel - Either UNIVERSAL_NAME_INFO_LEVEL or REMOTE_NAME_INFO_LEVEL
'              : ByVal xi_blnIsWin95:Boolean  - Is this on a Win95 machine?
'              : ByVal xi_blnIsWin9x:Boolean  - Is this on a Win9x machine?
' Outputs      : Variant:
' Description  : Takes a drive-based path for a network resource
'              :     and returns an information structure that
'              :     contains a more universal form of the name.
' Called By    : cNetCalls.GetUniversalName
' *******************************************************
Public Function GetUniversalName(ByVal xi_strLocalPath As String, _
                                 ByVal xi_enmNameInfoLevel As enmNameInfoLevel, _
                                 ByVal xi_blnIsWin95 As Boolean, _
                                 ByVal xi_blnIsWin9x As Boolean) As Variant
   Dim p_lngRtn                        As Long
   Dim p_abytBuffer()                  As Byte
   Dim p_lngLenBuffer                  As Long
   Dim p_vntRtn                        As Variant
   Dim p_typRemoteNameInfo             As REMOTE_NAME_INFO
   Dim p_typUnivNameInfo               As UNIVERSAL_NAME_INFO
   Const cnstProcName                  As String = "GetUniversalName"

   ' Fails under Win95 (Q131416) -- use WNetOpenEnum and WNetEnumResource
   If xi_blnIsWin95 = True Then
      Err.Raise Number:=enmCustErrors.Error_Wrong_Version + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="WNetGetUniversalName doesn't work on Win95 " & _
                             "(see Q131416)." & vbCrLf & _
                             "Use WNetEnumResource instead."
   End If

   ' ------------------------------------------
   ' Set the buffer (too small) and make
   '    appropriate API call and check for error
   ' ------------------------------------------
   p_lngLenBuffer = 1
   ReDim p_abytBuffer(0 To p_lngLenBuffer - 1) As Byte
   p_lngRtn = WNetGetUniversalName(lpLocalPath:=xi_strLocalPath, _
                                   dwInfoLevel:=xi_enmNameInfoLevel, _
                                   lpBuffer:=vbNullString, _
                                   lpBufferSize:=p_lngLenBuffer)
   
   Select Case p_lngRtn
      Case ERROR_MORE_DATA
         ' ------------------------------------
         ' We expect to get this "error"
         ' ------------------------------------
         ReDim p_abytBuffer(0 To p_lngLenBuffer - 1) As Byte
         p_lngRtn = WNetGetUniversalName(xi_strLocalPath, _
                                         xi_enmNameInfoLevel, _
                                         p_abytBuffer(0), _
                                         p_lngLenBuffer)
         
         If p_lngRtn = NO_ERROR Then
            ReDim p_vntRtn(0 To 2) As Variant
            
            If xi_enmNameInfoLevel = REMOTE_NAME_INFO_LEVEL Then
               ' Get the pointers to each of the returned strings
               p_typRemoteNameInfo.lpUniversalName = PointerToLong(VarPtr(p_abytBuffer(0)))
               p_typRemoteNameInfo.lpConnectionName = PointerToLong(VarPtr(p_abytBuffer(4)))
               p_typRemoteNameInfo.lpRemainingPath = PointerToLong(VarPtr(p_abytBuffer(8)))
               ' Now turn the pointers into string
               p_vntRtn(enmUniversalname.UniveralName) = PointerToStringA(p_typRemoteNameInfo.lpUniversalName)
               p_vntRtn(enmUniversalname.ConnectionName) = PointerToStringA(p_typRemoteNameInfo.lpConnectionName)
               p_vntRtn(enmUniversalname.RemainingPath) = PointerToStringA(p_typRemoteNameInfo.lpRemainingPath)
            
            ElseIf xi_enmNameInfoLevel = UNIVERSAL_NAME_INFO_LEVEL Then
               p_vntRtn(enmUniversalname.UniveralName) = PointerToStringA(p_typRemoteNameInfo.lpUniversalName)
               p_vntRtn(enmUniversalname.ConnectionName) = vbNullString
               p_vntRtn(enmUniversalname.RemainingPath) = vbNullString
               
            Else
               ' Nothing to do
            End If
         
            GetUniversalName = p_vntRtn
            
         End If
      
      Case Else
         GoTo Err_Handler
   
   End Select
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling WNetGetUniversalName, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetUserName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:53:32
' Inputs       : ByVal xi_strDeviceName:String - Can be a drive letter or blank
'              : ByVal xi_blnIsWin9x:Boolean   - Is this on a Win9x machine?
' Outputs      : String --
' Description  : Retrieves the current default user name, or
'              :     the user name used to establish a
'              :     network connection.
'              : If this the xi_strDeviceName is NULL, the
'              :     system returns the name of the
'              :     current user for the process
' Called By    : cNetCalls.GetUserName
' *******************************************************
Public Function GetUserName(ByVal xi_strDeviceName As String, _
                            ByVal xi_blnIsWin9x As Boolean) As String
   Dim p_lngNameLen                    As Long
   Dim p_lngRtn                        As Long
   Dim p_lngPos                        As Long
   Dim p_strUserName                   As String
   Const cnstProcName                  As String = "GetUserName"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   p_lngNameLen = 255
   p_strUserName = Space$(p_lngNameLen)
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = WNetGetUser(lpDeviceName:=xi_strDeviceName, _
                          lpUserName:=p_strUserName, _
                          lpnLength:=p_lngNameLen)
   
   If p_lngRtn = NO_ERROR Then
      ' Success
      p_lngPos = InStr(1, p_strUserName, vbNullChar)
      If p_lngPos > 0 Then
         GetUserName = Mid$(p_strUserName, 1, p_lngPos - 1)
      Else
         GetUserName = p_strUserName
      End If
   
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetGetUser, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If

End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetResourceName
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:57:08
' Inputs       : ByVal xi_strDriveLetter:String - A valid drive letter
'              : ByVal xi_blnIsWin9x:Boolean    - Is this on a Win9x machine?
' Outputs      : String --
' Description  : Retrieves the name of the network resource
'              :     associated with a local device.
' Called By    : cNetCalls.GetResourceName
' *******************************************************
Public Function GetResourceName(ByVal xi_strDriveLetter As String, _
                                ByVal xi_blnIsWin9x As Boolean) As String
   Dim p_lngRtn                        As Long
   Dim p_lngBufLen                     As Long
   Dim p_strRemoteName                 As String
   Dim p_strDrvLetter                  As String
   Dim p_lngPos                        As Long
   Const cnstProcName                  As String = "GetResourceName"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   p_strDrvLetter = UCase$(Left$(xi_strDriveLetter, 1)) & ":"
   p_lngBufLen = MAX_PATH
   p_strRemoteName = Space$(p_lngBufLen)
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = WNetGetConnection(lpszLocalName:=p_strDrvLetter, _
                                lpszRemoteName:=p_strRemoteName, _
                                cbRemoteName:=p_lngBufLen)
   
   ' ------------------------------------------
   ' If failed on too small a buffer, try again
   ' ------------------------------------------
   If p_lngRtn = ERROR_MORE_DATA Then
      p_strRemoteName = Space$(p_lngBufLen)
   
      p_lngRtn = WNetGetConnection(lpszLocalName:=p_strDrvLetter, _
                                   lpszRemoteName:=p_strRemoteName, _
                                   cbRemoteName:=p_lngBufLen)
   End If
   
   If p_lngRtn = NO_ERROR Then
      ' Success
      p_lngPos = InStr(1, p_strRemoteName, vbNullChar)
      If p_lngPos > 0 Then
         GetResourceName = Mid$(p_strRemoteName, 1, p_lngPos - 1)
      Else
         GetResourceName = p_strRemoteName
      End If
   
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetGetConnection, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If

End Function

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function GetExtendedErrorStr
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 10/13/2001 -- 23:47:06
' Inputs       : ByVal xi_lngErrNum:Long -
' Outputs      : String --
' Description  : Get the extended error info from a
'              :     WNet* function call
' Called By    : *****
' *******************************************************
Public Function GetExtendedErrorStr(ByVal xi_lngErrNum As Long) As String
   Dim p_strErrProvider                As String
   Dim p_strErrStr                     As String
   Dim p_lngErrProviderLen             As Long
   Dim p_lngErrStrLen                  As Long
   Dim p_lngRtn                        As Long
   Dim p_strTmp1                       As String
   Dim p_strTmp2                       As String
   
   p_lngErrStrLen = 2048&
   p_lngErrProviderLen = 256&
   p_strErrStr = Space$(p_lngErrStrLen)
   p_strErrProvider = Space$(p_lngErrProviderLen)
   
   p_lngRtn = WNetGetLastError(lpError:=xi_lngErrNum, _
                               lpErrorBuf:=p_strErrStr, _
                               nErrorBufSize:=p_lngErrStrLen, _
                               lpNameBuf:=p_strErrProvider, _
                               nNameBufSize:=p_lngErrProviderLen)
   If p_lngRtn = NO_ERROR Then
      p_strTmp1 = TrimNull(p_strErrStr)
      p_strTmp2 = TrimNull(p_strErrProvider)
      GetExtendedErrorStr = "The provider, '" & p_strTmp2 & "'" & vbCrLf & _
                            "returned the extended error info: " & vbCrLf & _
                            p_strTmp1
   Else
      GetExtendedErrorStr = "Invalid Extended Error Retrieval"
   End If
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION EnumResources
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 13:58:35
' Inputs       : ByVal xi_enmResourceType:enmResourceType - Type of resource to filter for
'              : ByVal xi_blnIsWin9x:Boolean              - Is this on a Win9x machine?
' Outputs      : Variant --
' Description  : Enumerates the network resources or
'              :     existing connections.
' Called By    : cNetCalls.EnumResources
' *******************************************************
Public Function EnumResources(ByVal xi_enmResourceType As enmResourceType, _
                              ByVal xi_blnIsWin9x As Boolean) As Variant
   Dim p_blnRootLevel                  As Boolean
   Dim p_lngRtn                        As Long
   Dim p_lngEnumHwnd                   As Long
   Dim p_lngResCount                   As Long
   Dim p_lngTotalCount                 As Long
   Dim p_lngLastIndex                  As Long
   Dim p_lngLen                        As Long
   Dim p_lngBufSize                    As Long
   Dim p_lngLoop                       As Long
   Dim p_strTmp                        As String
   Dim p_strComputerName               As String
   Dim p_atypNetResource_API()         As NETRESOURCE_LONG
   Dim p_atypNetRoots_API()            As NETRESOURCE_LONG
   Dim p_atypNetResource_VB()          As NETRESOURCE_STRING
   Dim p_vntRtn()                      As Variant
   Const cnstProcName                  As String = "EnumResources"

   ' ------------------------------------------
   ' First time thru
   ' ------------------------------------------
   p_blnRootLevel = True

   ReDim p_atypNetResource_API(0 To MAX_RESOURCES) As NETRESOURCE_LONG
   
   ' ------------------------------------------
   ' Loop thru the resources
   ' ------------------------------------------
   Do
      If p_blnRootLevel = True Then
         ' ------------------------------------
         ' First time we set the Resouce type to
         '     a null, and since the p_lngEnumHwnd
         '     hasn't been initialized yet, it's a zero
         ' ------------------------------------
         p_lngRtn = WNetOpenEnum(dwScope:=enmScope.RESOURCE_GLOBALNET, _
                                 dwType:=enmResType.RESOURCETYPE_ANY, _
                                 dwUsage:=enmResourceUsage.RESOURCEUSAGE_ZERO, _
                                 lpNetResource:=0&, _
                                 lphEnum:=p_lngEnumHwnd)
         
         If p_lngRtn <> NO_ERROR Then
            Err.Raise Number:=p_lngRtn + cnstErrBase, _
                      Source:=cnstProcName, _
                      Description:="When calling WNetOpenEnum, got the error, " & vbCrLf & _
                                   vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
            Exit Do
         End If

         p_blnRootLevel = False
      
      Else
         ' ---------------------------------------
         ' Only check containers
         ' ---------------------------------------
         If p_atypNetResource_VB(p_lngLastIndex).dwUsage And _
            enmResourceUsage.RESOURCEUSAGE_CONTAINER Then
            ' ------------------------------------
            ' For all but first time, use the
            '     resource type from the last
            '     call, as well as the handle
            '     from that call
            ' ------------------------------------
            p_lngRtn = WNetOpenEnum(dwScope:=enmScope.RESOURCE_GLOBALNET, _
                                    dwType:=enmResType.RESOURCETYPE_ANY, _
                                    dwUsage:=enmResourceUsage.RESOURCEUSAGE_ZERO, _
                                    lpNetResource:=p_atypNetResource_VB(p_lngLastIndex), _
                                    lphEnum:=p_lngEnumHwnd)
   
            p_strComputerName = vbNullString
            p_strComputerName = p_atypNetResource_VB(p_lngLastIndex).lpRemoteName
            
            If p_lngRtn <> NO_ERROR Then
               If (p_lngRtn = enmCustErrors.ERROR_NOT_AUTHENTICATED) Or _
                  (p_lngRtn = enmCustErrors.ERROR_ACCESS_DENIED) Then
                  Debug.Print "Don't have rights to enumerate " & p_atypNetResource_VB(p_lngLastIndex).lpRemoteName
               ElseIf p_lngRtn = enmCustErrors.ERROR_BAD_NET_NAME Then
                  ' Ignore -- Should only get this error if
                  ' you first get an ERROR_NOT_AUTHENTICATED
               ElseIf (p_lngRtn = enmCustErrors.ERROR_WNET_EXTENDED) Then
                  p_strTmp = GetExtendedErrorStr(p_lngRtn)
                  Debug.Print p_strTmp
                  ' If you raise an error here, it will stop
                  '     you (in same cases) from getting a
                  '     valid list in Win9x
                  'Err.Raise Number:=p_lngRtn + cnstErrBase, _
                  '          Source:=cnstProcName, _
                  '          Description:="When calling WNetOpenEnum, got the extended error, " & vbCrLf & _
                  '                       vbCrLf & p_strTmp
               Else
                  Err.Raise Number:=p_lngRtn + cnstErrBase, _
                            Source:=cnstProcName, _
                            Description:="When calling WNetOpenEnum, got the error, " & vbCrLf & _
                                         vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
                  Exit Do
               End If
            End If
   
         Else
            p_lngRtn = NOT_A_CONTAINER
            p_lngEnumHwnd = 0
         End If
      
         ' ------------------------------------
         ' Increment the index of containers
         ' ------------------------------------
         p_lngLastIndex = p_lngLastIndex + 1
   
      End If
      
      ' ---------------------------------------
      ' No errors, we have a container, so do our thing
      ' ---------------------------------------
      If p_lngRtn = enmCustErrors.ERROR_NOT_AUTHENTICATED Then
         p_lngResCount = p_lngResCount + 1
         ReDim Preserve p_atypNetResource_VB(0 To p_lngTotalCount) As NETRESOURCE_STRING
         p_atypNetResource_VB(p_lngTotalCount).dwScope = enmScope.RESOURCE_UNKNOWN
         p_atypNetResource_VB(p_lngTotalCount).dwType = enmResType.RESOURCETYPE_UNKNOWN
         p_atypNetResource_VB(p_lngTotalCount).dwDisplayType = enmResDisplayType.RESOURCEDISPLAYTYPE_UNKNOWN
         p_atypNetResource_VB(p_lngTotalCount).dwUsage = enmResourceUsage.RESOURCEUSAGE_UNKNOWN
         p_atypNetResource_VB(p_lngTotalCount).lpLocalName = ""
         p_atypNetResource_VB(p_lngTotalCount).lpRemoteName = p_strComputerName & " -- NOT AUTHENTICATED"
         p_atypNetResource_VB(p_lngTotalCount).lpComment = "Don't have rights to enumerate resources on " & p_strComputerName
         p_atypNetResource_VB(p_lngTotalCount).lpProvider = ""
      
         p_lngTotalCount = p_lngTotalCount + 1

      ElseIf p_lngRtn = NO_ERROR Then

         Do
            ' ---------------------------------
            ' If you don't redim here, can have
            '     some "carryover"
            ' ---------------------------------
            ReDim p_atypNetResource_API(0 To MAX_RESOURCES) As NETRESOURCE_LONG
   
            ' ---------------------------------
            ' Set the length of the buffer, then
            '     enumerate the resources
            ' ---------------------------------
            p_lngResCount = RESOURCE_ENUM_ALL
            p_lngBufSize = UBound(p_atypNetResource_API) * Len(p_atypNetResource_API(0))
            p_lngRtn = WNetEnumResource(hEnum:=p_lngEnumHwnd, _
                                        lpcCount:=p_lngResCount, _
                                        lpBuffer:=ByVal p_atypNetResource_API(0), _
                                        lpBufferSize:=p_lngBufSize)

            If p_lngRtn <> NO_ERROR Then

               If p_lngEnumHwnd <> 0 Then
                  p_lngLoop = WNetCloseEnum(p_lngEnumHwnd)
               End If

               Err.Raise Number:=p_lngRtn + cnstErrBase, _
                         Source:=cnstProcName, _
                         Description:="When calling WNetEnumResource, got the error, " & vbCrLf & _
                                      vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
               Exit Do
            End If

            ' ---------------------------------
            ' Found at least one resource
            ' ---------------------------------
            If p_lngResCount > 0 Then
               ReDim Preserve p_atypNetResource_VB(0 To p_lngTotalCount + (p_lngResCount - 1)) As NETRESOURCE_STRING

               For p_lngLoop = 0 To p_lngResCount - 1
                  ' ---------------------------
                  ' Copy the info into the "real"
                  '     array -- ie, strings are
                  '     actually strings
                  ' ---------------------------
                  p_atypNetResource_VB(p_lngTotalCount + p_lngLoop).dwScope = _
                        p_atypNetResource_API(p_lngLoop).dwScope
                  p_atypNetResource_VB(p_lngTotalCount + p_lngLoop).dwType = _
                        p_atypNetResource_API(p_lngLoop).dwType
                  p_atypNetResource_VB(p_lngTotalCount + p_lngLoop).dwDisplayType = _
                        p_atypNetResource_API(p_lngLoop).dwDisplayType
                  p_atypNetResource_VB(p_lngTotalCount + p_lngLoop).dwUsage = _
                        p_atypNetResource_API(p_lngLoop).dwUsage
                  p_atypNetResource_VB(p_lngTotalCount + p_lngLoop).lpLocalName = _
                        PointerToStringA(p_atypNetResource_API(p_lngLoop).lpLocalName)
                  p_atypNetResource_VB(p_lngTotalCount + p_lngLoop).lpRemoteName = _
                        PointerToStringA(p_atypNetResource_API(p_lngLoop).lpRemoteName)
                  p_atypNetResource_VB(p_lngTotalCount + p_lngLoop).lpComment = _
                        PointerToStringA(p_atypNetResource_API(p_lngLoop).lpComment)
                  p_atypNetResource_VB(p_lngTotalCount + p_lngLoop).lpProvider = _
                        PointerToStringA(p_atypNetResource_API(p_lngLoop).lpProvider)

               Next p_lngLoop

            Else
               ' ------------------------------
               ' No resources, do nothing
               ' ------------------------------
            End If

            ' ---------------------------------
            ' Increment the minimum count
            ' ---------------------------------
            p_lngTotalCount = p_lngTotalCount + p_lngResCount

         ' ------------------------------------
         ' Get rest of data
         ' ------------------------------------
         Loop While p_lngRtn = ERROR_MORE_DATA
      
      Else
         ' We just ignore the other errors
      End If

      ' ---------------------------------------
      ' Be nice and close your resouces
      ' ---------------------------------------
      If p_lngEnumHwnd <> 0 Then
         p_lngLoop = WNetCloseEnum(p_lngEnumHwnd)
      End If

   Loop While p_lngLastIndex < p_lngTotalCount

   ' ------------------------------------------
   ' Now we get get **JUST** the passed resource
   '     type and set the return value
   ' ------------------------------------------
   p_lngResCount = 0
   If UBound(p_atypNetResource_VB) > 0 Then
      ReDim Preserve p_vntRtn(0 To 8, 0 To UBound(p_atypNetResource_VB)) As Variant
      For p_lngLoop = 0 To UBound(p_atypNetResource_VB)
         If xi_enmResourceType = enmResourceType.RESOURCEDISPLAYTYPE_ALL Then
            p_lngResCount = p_lngResCount + 1
            With p_atypNetResource_VB(p_lngLoop)
               p_vntRtn(enmResources.RemoteName, p_lngResCount - 1) = .lpRemoteName
               p_vntRtn(enmResources.Comment, p_lngResCount - 1) = .lpComment
               p_vntRtn(enmResources.Provider, p_lngResCount - 1) = .lpProvider
               p_vntRtn(enmResources.DisplayType, p_lngResCount - 1) = .dwDisplayType
               p_vntRtn(enmResources.DisplayTypeText, p_lngResCount - 1) = TransDisplayType(.dwDisplayType)
               p_vntRtn(enmResources.Scope, p_lngResCount - 1) = .dwScope
               p_vntRtn(enmResources.ScopeText, p_lngResCount - 1) = TransScope(.dwScope)
               p_vntRtn(enmResources.ResType, p_lngResCount - 1) = .dwType
               p_vntRtn(enmResources.ResTypeText, p_lngResCount - 1) = TransResType(.dwType)
            End With
         Else
            If p_atypNetResource_VB(p_lngLoop).dwDisplayType = xi_enmResourceType Then
               p_lngResCount = p_lngResCount + 1
               With p_atypNetResource_VB(p_lngLoop)
                  p_vntRtn(enmResources.RemoteName, p_lngResCount - 1) = .lpRemoteName
                  p_vntRtn(enmResources.Comment, p_lngResCount - 1) = .lpComment
                  p_vntRtn(enmResources.Provider, p_lngResCount - 1) = .lpProvider
                  p_vntRtn(enmResources.DisplayType, p_lngResCount - 1) = .dwDisplayType
                  p_vntRtn(enmResources.DisplayTypeText, p_lngResCount - 1) = TransDisplayType(.dwDisplayType)
                  p_vntRtn(enmResources.Scope, p_lngResCount - 1) = .dwScope
                  p_vntRtn(enmResources.ScopeText, p_lngResCount - 1) = TransScope(.dwScope)
                  p_vntRtn(enmResources.ResType, p_lngResCount - 1) = .dwType
                  p_vntRtn(enmResources.ResTypeText, p_lngResCount - 1) = TransResType(.dwType)
               End With
            End If
         End If
      Next p_lngLoop
      
      If p_lngResCount > 0 Then
         ReDim Preserve p_vntRtn(0 To 8, 0 To p_lngResCount - 1)
         EnumResources = p_vntRtn
      Else
         EnumResources = Empty
      End If
      
   Else
      Erase p_vntRtn
      EnumResources = Empty
   End If

End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB MapDrive
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:14:43
' Inputs       : ByVal xi_lngHwnd:Long                       - Handle to a form to act a parent for dialog
'              : ByVal xi_blnIsWin9x:Boolean                 - Is this on a Win9x machine?
'              : Optional ByVal xi_strLocalName:String = ""  - Local name of resource (i.e., "H:")
'              : Optional ByVal xi_strRemoteName:String = "" - Remote name of resource (i.e., "\\MyServer\MyShare")
' Outputs      : N/A
' Description  : Brings up a general browsing dialog for
'              :     connecting to network resources.
'              : The FUNCTION requires a CONNECTDLGSTRUCT
'              :     to establish the dialog box parameters.
' Called By    : cNetCalls.MapDrive
' *******************************************************
Public Sub MapDrive(ByVal xi_lngHwnd As Long, _
                    ByVal xi_blnIsWin9x As Boolean, _
                    Optional ByVal xi_strLocalName As String = "", _
                    Optional ByVal xi_strRemoteName As String = "")
   Dim p_lngRtn                        As Long
   Dim p_typDialogStruct               As CONNECTDLGSTRUCT
   Dim p_typResource                   As NETRESOURCE_STRING
   Const cnstProcName                  As String = "MapDrive"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   With p_typResource
      .lpLocalName = xi_strRemoteName
      .lpRemoteName = xi_strRemoteName
      .dwType = enmResType.RESOURCETYPE_DISK
   End With
   
   With p_typDialogStruct
      .cbStructure = LenB(p_typDialogStruct)
      .HwndOwner = xi_lngHwnd
      .lpConnRes = GlobalAlloc(GPTR, LenB(p_typResource))
      CopyMem ByVal .lpConnRes, _
              p_typResource, _
              LenB(p_typResource)
      .dwFlags = CONNDLG_USE_MRU Or _
                 CONNDLG_HIDE_BOX Or _
                 CONNDLG_NOT_PERSIST
   End With
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = WNetConnectionDialog1(lpConnDlgStruct:=p_typDialogStruct)
   
   ' ------------------------------------------
   ' Free the memory
   ' ------------------------------------------
   GlobalFree p_typDialogStruct.lpConnRes
   
   If p_lngRtn = NO_ERROR Then
      ' Success
   ElseIf p_lngRtn = -1 Then
      ' User cancelled
      Err.Raise Number:=enmCustErrors.User_Cancelled + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="User cancelled"
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetConnectionDialog1, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB UnmapDrive
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:16:29
' Inputs       : ByVal xi_lngHwnd:Long        - Handle to a form to act a parent for dialog
'              : ByVal xi_strLocalName:String - Local name of mapped drive (i.e., "H:")
'              : ByVal xi_blnIsWin9x:Boolean  - Is this on a Win9x machine?
' Outputs      : N/A
' Description  : Attempts to disconnect a network resource.
'              : If the underlying network returns ERROR_OPEN_FILES,
'              :     the FUNCTION prompts the user for confirmation.
'              : If there is any error, the FUNCTION informs
'              :     the user.
'              : The FUNCTION requires a DISCDLGSTRUCT to specify
'              :     the parameters for the disconnect attempt.
' Called By    : cNetCalls.UnmapDrive
' *******************************************************
Public Sub UnmapDrive(ByVal xi_lngHwnd As Long, _
                      ByVal xi_strLocalName As String, _
                      ByVal xi_blnIsWin9x As Boolean)
   Dim p_lngRtn                        As Long
   Dim p_typDialogStruct               As DISCDLGSTRUCT
   Const cnstProcName                  As String = "UnmapDrive"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   With p_typDialogStruct
      .cbStructure = LenB(p_typDialogStruct)
      .HwndOwner = xi_lngHwnd
      .lpLocalName = xi_strLocalName
      .dwFlags = DISC_NO_FORCE Or _
                 DISC_UPDATE_PROFILE
   End With
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = WNetDisconnectDialog1(lpConnDlgStruct:=p_typDialogStruct)
   
   If p_lngRtn = NO_ERROR Then
      ' Success
   ElseIf p_lngRtn = -1 Then
      ' User cancelled
      Err.Raise Number:=enmCustErrors.User_Cancelled + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="User cancelled"
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetDisconnectDialog1, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If
   
End Sub

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetNetInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:19:40
' Inputs       : ByVal xi_blnIsWin9x:Boolean - Is this on a Win9x machine?
' Outputs      : Variant:
' Description  : Obtains the provider name for a specific
'              :     type of network.
' Called By    : cNetCalls.GetNetInfo
' *******************************************************
Public Function GetNetInfo(ByVal xi_blnIsWin9x As Boolean) As Variant
   Dim p_lngRtn                        As Long
   Dim p_lngBufLength                  As Long
   Dim p_lngPos                        As Long
   Dim p_strProviderName               As String
   Dim p_abytProviderName()            As Byte
   Dim p_typDialogStruct               As NETINFOSTRUCT
   Dim p_vntRtn                        As Variant
   Const cnstProcName                  As String = "GetNetInfo"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   p_lngBufLength = MAX_PATH
   p_strProviderName = Space$(p_lngBufLength)
   
   ' ---------------------------------------
   ' Make appropriate API call and check for error
   ' ---------------------------------------
   p_lngRtn = WNetGetProviderName(dwNetType:=enmNetTypeOrig.WNNC_NET_LANMAN, _
                                  lpProviderName:=p_strProviderName, _
                                  lpBufferSize:=p_lngBufLength)
   If p_lngRtn = NO_ERROR Then
      p_lngPos = InStr(1, p_strProviderName, vbNullChar)
      If p_lngPos > 0 Then
         p_strProviderName = Mid$(p_strProviderName, 1, p_lngPos - 1)
      End If
   
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetGetProviderName, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If
   
   With p_typDialogStruct
      .cbStructure = LenB(p_typDialogStruct)
   End With
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = WNetGetNetworkInformation(lpProvider:=p_strProviderName, _
                                        lpNetInfoStruct:=p_typDialogStruct)
   If p_lngRtn = NO_ERROR Then
      ' Success
      With p_typDialogStruct
         ReDim p_vntRtn(0 To 7) As Variant
         
         p_vntRtn(enmNetInfo.Characteristics) = .dwCharacteristics       ' 0 in NT, NETINFO_DLL16, NETINFO_DISKRED, or NETINFO_PRINTERRED in Win9x
         p_vntRtn(enmNetInfo.Drives) = .dwDrives
         p_vntRtn(enmNetInfo.Printers) = .dwPrinters
         p_vntRtn(enmNetInfo.ProviderVersion) = .dwProviderVersion
         p_vntRtn(enmNetInfo.Status) = .dwStatus                         ' NO_ERROR, ERROR_NO_NETWORK, ERROR_BUSY
         p_vntRtn(enmNetInfo.StatusText) = TransNetInfoStatus(.dwStatus)
         p_vntRtn(enmNetInfo.NetType) = .wNetType
         p_vntRtn(enmNetInfo.NetTypeText) = TransNetType(.wNetType)
      End With
      
      GetNetInfo = p_vntRtn
      
   ElseIf p_lngRtn = -1 Then
      ' User cancelled
      Err.Raise Number:=enmCustErrors.User_Cancelled + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="User cancelled"
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetGetNetworkInformation, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If
   
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION GetResInfo
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:20:54
' Inputs       : ByVal xi_strRemoteName:String - The Remote Name (i.e., "\\MyServer\MyShare")
'              : ByVal xi_blnIsWin9x:Boolean   - Is this on a Win9x machine?
' Outputs      : N/A
' Description  : When provided with a remote path to a network
'              :     resource, the WNetGetResourceInformation
'              :     FUNCTION identifies the network provider
'              :     that owns the resource and obtains
'              :     information about the type of the resource.
'              : The FUNCTION is typically used in conjunction
'              :     with the WNetGetResourceParent FUNCTION
'              :     to parse and interpret a network path
'              :     typed in by a user.
' Called By    : cNetCalls.GetResInfo
' *******************************************************
Public Function GetResInfo(ByVal xi_strRemoteName As String, _
                           ByVal xi_blnIsWin9x As Boolean) As Variant
   Dim p_lngRtn                        As Long
   Dim p_lngPos                        As Long
   Dim p_lngSystem                     As Long
   Dim p_abytBuffer()                  As Byte
   Dim p_lngLenBuffer                  As Long
   Dim p_strUsage                      As String
   Dim p_strProviderName               As String
   Dim p_typNetRes_String              As NETRESOURCE_STRING
   Dim p_typNetRes_Long                As NETRESOURCE_LONG
   Dim p_avntRtn                       As Variant
   Const cnstProcName                  As String = "GetResInfo"
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   With p_typNetRes_String
      .lpRemoteName = xi_strRemoteName
      .lpProvider = vbNullString
      .dwType = enmResType.RESOURCETYPE_DISK
   End With
   
   ' ------------------------------------------
   ' Set the buffer (too small) and make
   '    appropriate API call and check for error
   ' ------------------------------------------
   p_lngLenBuffer = LenB(p_typNetRes_String)
   ReDim p_abytBuffer(0 To p_lngLenBuffer - 1) As Byte
   p_lngRtn = WNetGetResourceInformation(lpNetResource:=p_typNetRes_String, _
                                         lpBuffer:=p_abytBuffer(0), _
                                         cbBuffer:=p_lngLenBuffer, _
                                         lplpSystem:=p_lngSystem)

   Select Case p_lngRtn
      ' ---------------------------------------
      ' We expect to get this "error"
      ' ---------------------------------------
      Case ERROR_MORE_DATA
         ReDim p_abytBuffer(0 To p_lngLenBuffer - 1) As Byte
         p_lngRtn = WNetGetResourceInformation(lpNetResource:=p_typNetRes_String, _
                                               lpBuffer:=p_abytBuffer(0), _
                                               cbBuffer:=p_lngLenBuffer, _
                                               lplpSystem:=p_lngSystem)
         
         If p_lngRtn = NO_ERROR Then
            ' Get the pointers to each of the returned strings
            CopyMem pTo:=ByVal p_typNetRes_Long, _
                    uFrom:=p_abytBuffer(0), _
                    lSize:=LenB(p_typNetRes_Long)
                        
            ReDim p_avntRtn(0 To 11) As Variant
            
            With p_typNetRes_Long
               p_avntRtn(enmResourceInfo.Comment) = PointerToStringA(.lpComment)
               p_avntRtn(enmResourceInfo.LocalName) = PointerToStringA(.lpLocalName)
               p_avntRtn(enmResourceInfo.Provider) = PointerToStringA(.lpProvider)
               p_avntRtn(enmResourceInfo.RemoteName) = PointerToStringA(.lpRemoteName)
               
               p_avntRtn(enmResourceInfo.Usage) = .dwUsage
               p_avntRtn(enmResourceInfo.UsageText) = TransResourceUsage(.dwUsage)
               p_avntRtn(enmResourceInfo.Scope) = .dwScope
               p_avntRtn(enmResourceInfo.ScopeText) = TransScope(.dwScope)
               p_avntRtn(enmResourceInfo.ResType) = .dwType
               p_avntRtn(enmResourceInfo.ResTypeText) = TransResType(.dwType)
               p_avntRtn(enmResourceInfo.DisplayType) = .dwDisplayType
               p_avntRtn(enmResourceInfo.DisplayTypeText) = TransDisplayType(.dwDisplayType)
            
            End With
            
            GetResInfo = p_avntRtn
            
         Else
            GoTo Err_Handler
            
         End If
      
      Case Else
         GoTo Err_Handler
   
   End Select
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling WNetGetResourceInformation, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) SUB GetResParent
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:23:36
' Inputs       : ByVal xi_strRemoteName:String - The Remote Name (i.e., "\\MyServer\MyShare")
'              : ByVal xi_blnIsWin9x:Boolean   - Is this on a Win9x machine?
' Outputs      : Variant:
' Description  : The WNetGetResourceParent FUNCTION returns
'              :     the parent of a network resource in
'              :     the network browse hierarchy.
'              : Browsing begins at the location of the
'              :     specified network resource.
'              : Call the WNetGetResourceInformation and
'              :     WNetGetResourceParent FUNCTIONs to
'              :     move up the network hierarchy.
'              : Call the WNetOpenEnum FUNCTION to move
'              :     down the hierarchy.
' Called By    : cNetCalls.GetResParent
' *******************************************************
Public Function GetResParent(ByVal xi_strRemoteName As String, _
                             ByVal xi_blnIsWin9x As Boolean) As Variant
   Dim p_lngRtn                        As Long
   Dim p_lngPos                        As Long
   Dim p_abytBuffer()                  As Byte
   Dim p_lngLenBuffer                  As Long
   Dim p_strProviderName               As String
   Dim p_typNetRes_String              As NETRESOURCE_STRING
   Dim p_typNetRes_Long                As NETRESOURCE_LONG
   Dim p_vntRtn                        As Variant
   Const cnstProcName                  As String = "GetResParent"

   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   p_lngLenBuffer = MAX_PATH
   p_strProviderName = Space$(p_lngLenBuffer)
   
   ' ---------------------------------------
   ' Make appropriate API call and check for error
   ' ---------------------------------------
   p_lngRtn = WNetGetProviderName(dwNetType:=enmNetTypeOrig.WNNC_NET_LANMAN, _
                                  lpProviderName:=p_strProviderName, _
                                  lpBufferSize:=p_lngLenBuffer)
   If p_lngRtn = NO_ERROR Then
      p_lngPos = InStr(1, p_strProviderName, vbNullChar)
      If p_lngPos > 0 Then
         p_strProviderName = Mid$(p_strProviderName, 1, p_lngPos - 1)
      End If
   
   Else
      Err.Raise Number:=p_lngRtn + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="When calling WNetGetProviderName, got the error, " & vbCrLf & _
                             vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
   End If
   
   ' ------------------------------------------
   ' Initialize the variable(s)
   '
   ' lpRemoteName, lpProvider, dwType, dwDisplayType,
   ' and dwUsage members of the structure
   ' all other members are set to NULL.
   ' ------------------------------------------
   With p_typNetRes_String
      .lpRemoteName = xi_strRemoteName
      .lpProvider = p_strProviderName
      .dwType = enmResType.RESOURCETYPE_DISK
   End With
   
   ' ------------------------------------------
   ' Set the buffer (too small) and make
   '    appropriate API call and check for error
   ' ------------------------------------------
   p_lngLenBuffer = 1
   ReDim p_abytBuffer(0 To p_lngLenBuffer - 1) As Byte
   p_lngRtn = WNetGetResourceParent(lpNetResource:=p_typNetRes_String, _
                                    lpBuffer:=p_abytBuffer(0), _
                                    lpBufferSize:=p_lngLenBuffer)
   
   Select Case p_lngRtn
      ' ---------------------------------------
      ' We expect to get this "error"
      ' ---------------------------------------
      Case ERROR_MORE_DATA
         ReDim p_abytBuffer(0 To p_lngLenBuffer - 1) As Byte
         p_lngRtn = WNetGetResourceParent(lpNetResource:=p_typNetRes_String, _
                                          lpBuffer:=p_abytBuffer(0), _
                                          lpBufferSize:=p_lngLenBuffer)
         
         If p_lngRtn = NO_ERROR Then
            CopyMem pTo:=ByVal p_typNetRes_Long, _
                    uFrom:=p_abytBuffer(0), _
                    lSize:=LenB(p_typNetRes_Long)
            
            With p_typNetRes_Long
               ReDim p_vntRtn(0 To 11) As Variant
               
               p_vntRtn(enmResourceInfo.LocalName) = PointerToStringA(.lpLocalName)
               p_vntRtn(enmResourceInfo.RemoteName) = PointerToStringA(.lpRemoteName)
               p_vntRtn(enmResourceInfo.Comment) = PointerToStringA(.lpComment)
               p_vntRtn(enmResourceInfo.Provider) = PointerToStringA(.lpProvider)
               
               p_vntRtn(enmResourceInfo.DisplayType) = .dwDisplayType
               p_vntRtn(enmResourceInfo.DisplayTypeText) = TransResType(.dwDisplayType)
               p_vntRtn(enmResourceInfo.Scope) = .dwScope
               p_vntRtn(enmResourceInfo.ScopeText) = TransScope(.dwScope)
               p_vntRtn(enmResourceInfo.ResType) = .dwType
               p_vntRtn(enmResourceInfo.ResTypeText) = TransResType(.dwType)
               p_vntRtn(enmResourceInfo.Usage) = .dwUsage
               p_vntRtn(enmResourceInfo.UsageText) = TransResourceUsage(.dwUsage)
            End With
            
            GetResParent = p_vntRtn
            
         Else
            GoTo Err_Handler
            
         End If
      
      Case Else
         GoTo Err_Handler
   
   End Select
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling WNetGetResourceParent, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
End Function

' *******************************************************
' Routine Name : (PUBLIC in CLASS) FUNCTION UseConnection
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/14/2001 -- 14:26:23
' Inputs       : ByVal xi_lngHwnd:Long         - Handle for window that will be parent for any dialogs
' Inputs       : ByVal xi_strRemoteName:String - The Remote Name (i.e., "\\MyServer\MyShare")
'              : ByVal xi_strUserID:String     - UserID
'              : ByVal xi_strPW:String         - Password for this userID
'              : ByVal xi_blnIsWin9x:Boolean   - Is this on a Win9x machine?
'              : Optional ByVal xi_strLocalName:String = "" - The Local Name (i.e., "H:")
' Outputs      : String --
' Description  : The WNetUseConnection FUNCTION makes a
'              :     connection to a network resource.
'              : The FUNCTION can redirect a local device
'              :     to a network resource.
'              : The WNetUseConnection FUNCTION is similar to the
'              :     WNetAddConnection3 FUNCTION. The main difference
'              :     is that WNetUseConnection can automatically
'              :     select an unused local device to redirect
'              :     to the network resource.
' Called By    : cNetCalls.UseConnection
' *******************************************************
Public Function UseConnection(ByVal xi_lngHwnd As Long, _
                              ByVal xi_strRemoteName As String, _
                              ByVal xi_strUserID As String, _
                              ByVal xi_strPW As String, _
                              ByVal xi_blnIsWin9x As Boolean, _
                              Optional ByVal xi_strLocalName As String = "") As String
   Dim p_lngRtn                        As Long
   Dim p_lngLenBuffer                  As Long
   Dim p_lngSuccess                    As Long
   Dim p_lngFlags                      As Long
   Dim p_strMappedLetter               As String
   Dim p_abytBuffer()                  As Byte
   Dim p_typNetRes_String              As NETRESOURCE_STRING
   Const cnstProcName                  As String = "UseConnection"

   ' ------------------------------------------
   ' Initialize the variable(s)
   ' ------------------------------------------
   With p_typNetRes_String
      .dwType = enmResType.RESOURCETYPE_DISK ' Optional, but should use
      .lpLocalName = xi_strLocalName         ' Optional
      .lpRemoteName = xi_strRemoteName       ' Required
      .lpProvider = vbNullString             ' Optional
   End With
   
   p_lngLenBuffer = MAX_PATH
   ReDim p_abytBuffer(0 To p_lngLenBuffer - 1) As Byte
   
   p_lngFlags = CONNECT_REDIRECT Or _
                CONNECT_INTERACTIVE Or _
                CONNECT_PROMPT
   
   ' ------------------------------------------
   ' Make appropriate API call and check for error
   ' ------------------------------------------
   p_lngRtn = WNetUseConnection(HwndOwner:=xi_lngHwnd, _
                                lpNetResource:=p_typNetRes_String, _
                                lpUserID:=xi_strUserID, _
                                lpPassword:=xi_strPW, _
                                dwFlags:=CONNECT_REDIRECT, _
                                lpAccessname:=p_abytBuffer(0), _
                                lpBufferSize:=p_lngLenBuffer, _
                                lpResult:=p_lngSuccess)
   
   ' ------------------------------------------
   ' Check if call to API failed. According to
   ' the MSDN help, there are some versions
   ' of the operating system that expect the
   ' userid as the 3rd parameter and the password
   ' as the 4th, while other versions of the
   ' operating system have them in reverse order,
   ' so if first call to API fails, try reversing
   ' these two parameters.
   ' ------------------------------------------
   If p_lngRtn <> NO_ERROR Then
      p_lngRtn = WNetUseConnection(HwndOwner:=xi_lngHwnd, _
                                   lpNetResource:=p_typNetRes_String, _
                                   lpUserID:=xi_strPW, _
                                   lpPassword:=xi_strUserID, _
                                   dwFlags:=CONNECT_REDIRECT, _
                                   lpAccessname:=p_abytBuffer(0), _
                                   lpBufferSize:=p_lngLenBuffer, _
                                   lpResult:=p_lngSuccess)
   End If
   
   If (p_lngRtn = NO_ERROR) And (p_lngSuccess = CONNECT_LOCALDRIVE) Then
      ' Store the mapped drive letter for later usage
      p_strMappedLetter = p_abytBuffer
      p_strMappedLetter = Left$(p_strMappedLetter, InStr(1, p_strMappedLetter, ":"))
   ElseIf p_lngRtn = ERROR_CANCELLED Then
      Err.Raise Number:=enmCustErrors.User_Cancelled + cnstErrBase, _
                Source:=cnstProcName, _
                Description:="User Cancelled"
   Else
      p_strMappedLetter = vbNullString
      GoTo Err_Handler
   End If

   UseConnection = p_strMappedLetter
   
Exit Function
Err_Handler:
   Err.Raise Number:=p_lngRtn + cnstErrBase, _
             Source:=cnstProcName, _
             Description:="When calling WNetUseConnection, got the error, " & vbCrLf & _
                          vbCrLf & "'" & modErrMsgs.ReturnApiErrString(p_lngRtn, xi_blnIsWin9x) & "'"
End Function
