Attribute VB_Name = "modWin9xErrors"
' ************************************************************
' Copyright  1995-2001 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the VBPJ site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************

' ---------------------------------------------
' Module    : modWin9xErrors.BAS
' By        : L.J. Johnson       Date: 09-23-2001
' Comments  : Expose (for Win9x) the error strings
'           :     which are found in NetMsg.dll
'           :     on NT+ systems
' ---------------------------------------------
Option Explicit

Private Const NERR_BASE                As Long = 2100&

Private Const NERR_NetNotStarted       As Long = NERR_BASE + 2
Private Const NERR_UnknownServer       As Long = NERR_BASE + 3
Private Const NERR_ShareMem            As Long = NERR_BASE + 4
Private Const NERR_NoNetworkResource   As Long = NERR_BASE + 5
Private Const NERR_RemoteOnly          As Long = NERR_BASE + 6
Private Const NERR_DevNotRedirected    As Long = NERR_BASE + 7
Private Const NERR_ServerNotStarted    As Long = NERR_BASE + 14
Private Const NERR_ItemNotFound        As Long = NERR_BASE + 15
Private Const NERR_UnknownDevDir       As Long = NERR_BASE + 16
Private Const NERR_RedirectedPath      As Long = NERR_BASE + 17
Private Const NERR_DuplicateShare      As Long = NERR_BASE + 18
Private Const NERR_NoRoom              As Long = NERR_BASE + 19
Private Const NERR_TooManyItems        As Long = NERR_BASE + 21
Private Const NERR_InvalidMaxUsers     As Long = NERR_BASE + 22
Private Const NERR_BufTooSmall         As Long = NERR_BASE + 23
Private Const NERR_RemoteErr           As Long = NERR_BASE + 27
Private Const NERR_LanmanIniError      As Long = NERR_BASE + 31
Private Const NERR_NetworkError        As Long = NERR_BASE + 36
Private Const NERR_WkstaInconsistentState As Long = NERR_BASE + 37
Private Const NERR_WkstaNotStarted     As Long = NERR_BASE + 38
Private Const NERR_BrowserNotStarted   As Long = NERR_BASE + 39
Private Const NERR_InternalError       As Long = NERR_BASE + 40
Private Const NERR_BadTransactConfig   As Long = NERR_BASE + 41
Private Const NERR_InvalidAPI          As Long = NERR_BASE + 42
Private Const NERR_BadEventName        As Long = NERR_BASE + 43
Private Const NERR_DupNameReboot       As Long = NERR_BASE + 44
Private Const NERR_CfgCompNotFound     As Long = NERR_BASE + 46
Private Const NERR_CfgParamNotFound    As Long = NERR_BASE + 47
Private Const NERR_LineTooLong         As Long = NERR_BASE + 49
Private Const NERR_QNotFound           As Long = NERR_BASE + 50
Private Const NERR_JobNotFound         As Long = NERR_BASE + 51
Private Const NERR_DestNotFound        As Long = NERR_BASE + 52
Private Const NERR_DestExists          As Long = NERR_BASE + 53
Private Const NERR_QExists             As Long = NERR_BASE + 54
Private Const NERR_QNoRoom             As Long = NERR_BASE + 55
Private Const NERR_JobNoRoom           As Long = NERR_BASE + 56
Private Const NERR_DestNoRoom          As Long = NERR_BASE + 57
Private Const NERR_DestIdle            As Long = NERR_BASE + 58
Private Const NERR_DestInvalidOp       As Long = NERR_BASE + 59
Private Const NERR_ProcNoRespond       As Long = NERR_BASE + 60
Private Const NERR_SpoolerNotLoaded    As Long = NERR_BASE + 61
Private Const NERR_DestInvalidState    As Long = NERR_BASE + 62
Private Const NERR_QInvalidState       As Long = NERR_BASE + 63
Private Const NERR_JobInvalidState     As Long = NERR_BASE + 64
Private Const NERR_SpoolNoMemory       As Long = NERR_BASE + 65
Private Const NERR_DriverNotFound      As Long = NERR_BASE + 66
Private Const NERR_DataTypeInvalid     As Long = NERR_BASE + 67
Private Const NERR_ProcNotFound        As Long = NERR_BASE + 68
Private Const NERR_ServiceTableLocked  As Long = NERR_BASE + 80
Private Const NERR_ServiceTableFull    As Long = NERR_BASE + 81
Private Const NERR_ServiceInstalled    As Long = NERR_BASE + 82
Private Const NERR_ServiceEntryLocked  As Long = NERR_BASE + 83
Private Const NERR_ServiceNotInstalled As Long = NERR_BASE + 84
Private Const NERR_BadServiceName      As Long = NERR_BASE + 85
Private Const NERR_ServiceCtlTimeout   As Long = NERR_BASE + 86
Private Const NERR_ServiceCtlBusy      As Long = NERR_BASE + 87
Private Const NERR_BadServiceProgName  As Long = NERR_BASE + 88
Private Const NERR_ServiceNotCtrl      As Long = NERR_BASE + 89
Private Const NERR_ServiceKillProc     As Long = NERR_BASE + 90
Private Const NERR_ServiceCtlNotValid  As Long = NERR_BASE + 91
Private Const NERR_NotInDispatchTbl    As Long = NERR_BASE + 92
Private Const NERR_BadControlRecv      As Long = NERR_BASE + 93
Private Const NERR_ServiceNotStarting  As Long = NERR_BASE + 94
Private Const NERR_AlreadyLoggedOn     As Long = NERR_BASE + 100
Private Const NERR_NotLoggedOn         As Long = NERR_BASE + 101
Private Const NERR_BadUsername         As Long = NERR_BASE + 102
Private Const NERR_BadPassword         As Long = NERR_BASE + 103
Private Const NERR_UnableToAddName_W   As Long = NERR_BASE + 104
Private Const NERR_UnableToAddName_F   As Long = NERR_BASE + 105
Private Const NERR_UnableToDelName_W   As Long = NERR_BASE + 106
Private Const NERR_UnableToDelName_F   As Long = NERR_BASE + 107
Private Const NERR_LogonsPaused        As Long = NERR_BASE + 109
Private Const NERR_LogonServerConflict As Long = NERR_BASE + 110
Private Const NERR_LogonNoUserPath     As Long = NERR_BASE + 111
Private Const NERR_LogonScriptError    As Long = NERR_BASE + 112
Private Const NERR_StandaloneLogon     As Long = NERR_BASE + 114
Private Const NERR_LogonServerNotFound As Long = NERR_BASE + 115
Private Const NERR_LogonDomainExists   As Long = NERR_BASE + 116
Private Const NERR_NonValidatedLogon   As Long = NERR_BASE + 117
Private Const NERR_ACFNotFound         As Long = NERR_BASE + 119
Private Const NERR_GroupNotFound       As Long = NERR_BASE + 120
Private Const NERR_UserNotFound        As Long = NERR_BASE + 121
Private Const NERR_ResourceNotFound    As Long = NERR_BASE + 122
Private Const NERR_GroupExists         As Long = NERR_BASE + 123
Private Const NERR_UserExists          As Long = NERR_BASE + 124
Private Const NERR_ResourceExists      As Long = NERR_BASE + 125
Private Const NERR_NotPrimary          As Long = NERR_BASE + 126
Private Const NERR_ACFNotLoaded        As Long = NERR_BASE + 127
Private Const NERR_ACFNoRoom           As Long = NERR_BASE + 128
Private Const NERR_ACFFileIOFail       As Long = NERR_BASE + 129
Private Const NERR_ACFTooManyLists     As Long = NERR_BASE + 130
Private Const NERR_UserLogon           As Long = NERR_BASE + 131
Private Const NERR_ACFNoParent         As Long = NERR_BASE + 132
Private Const NERR_CanNotGrowSegment   As Long = NERR_BASE + 133
Private Const NERR_SpeGroupOp          As Long = NERR_BASE + 134
Private Const NERR_NotInCache          As Long = NERR_BASE + 135
Private Const NERR_UserInGroup         As Long = NERR_BASE + 136
Private Const NERR_UserNotInGroup      As Long = NERR_BASE + 137
Private Const NERR_AccountUndefined    As Long = NERR_BASE + 138
Private Const NERR_AccountExpired      As Long = NERR_BASE + 139
Private Const NERR_InvalidWorkstation  As Long = NERR_BASE + 140
Private Const NERR_InvalidLogonHours   As Long = NERR_BASE + 141
Private Const NERR_PasswordExpired     As Long = NERR_BASE + 142
Private Const NERR_PasswordCantChange  As Long = NERR_BASE + 143
Private Const NERR_PasswordHistConflict   As Long = NERR_BASE + 144
Private Const NERR_PasswordTooShort    As Long = NERR_BASE + 145
Private Const NERR_PasswordTooRecent   As Long = NERR_BASE + 146
Private Const NERR_InvalidDatabase     As Long = NERR_BASE + 147
Private Const NERR_DatabaseUpToDate    As Long = NERR_BASE + 148
Private Const NERR_SyncRequired        As Long = NERR_BASE + 149
Private Const NERR_UseNotFound         As Long = NERR_BASE + 150
Private Const NERR_BadAsgType          As Long = NERR_BASE + 151
Private Const NERR_DeviceIsShared      As Long = NERR_BASE + 152
Private Const NERR_NoComputerName      As Long = NERR_BASE + 170
Private Const NERR_MsgAlreadyStarted   As Long = NERR_BASE + 171
Private Const NERR_MsgInitFailed       As Long = NERR_BASE + 172
Private Const NERR_NameNotFound        As Long = NERR_BASE + 173
Private Const NERR_AlreadyForwarded    As Long = NERR_BASE + 174
Private Const NERR_AddForwarded        As Long = NERR_BASE + 175
Private Const NERR_AlreadyExists       As Long = NERR_BASE + 176
Private Const NERR_TooManyNames        As Long = NERR_BASE + 177
Private Const NERR_DelComputerName     As Long = NERR_BASE + 178
Private Const NERR_LocalForward        As Long = NERR_BASE + 179
Private Const NERR_GrpMsgProcessor     As Long = NERR_BASE + 180
Private Const NERR_PausedRemote        As Long = NERR_BASE + 181
Private Const NERR_BadReceive          As Long = NERR_BASE + 182
Private Const NERR_NameInUse           As Long = NERR_BASE + 183
Private Const NERR_MsgNotStarted       As Long = NERR_BASE + 184
Private Const NERR_NotLocalName        As Long = NERR_BASE + 185
Private Const NERR_NoForwardName       As Long = NERR_BASE + 186
Private Const NERR_RemoteFull          As Long = NERR_BASE + 187
Private Const NERR_NameNotForwarded    As Long = NERR_BASE + 188
Private Const NERR_TruncatedBroadcast  As Long = NERR_BASE + 189
Private Const NERR_InvalidDevice       As Long = NERR_BASE + 194
Private Const NERR_WriteFault          As Long = NERR_BASE + 195
Private Const NERR_DuplicateName       As Long = NERR_BASE + 197
Private Const NERR_DeleteLater         As Long = NERR_BASE + 198
Private Const NERR_IncompleteDel       As Long = NERR_BASE + 199
Private Const NERR_MultipleNets        As Long = NERR_BASE + 200
Private Const NERR_NetNameNotFound     As Long = NERR_BASE + 210
Private Const NERR_DeviceNotShared     As Long = NERR_BASE + 211
Private Const NERR_ClientNameNotFound  As Long = NERR_BASE + 212
Private Const NERR_FileIdNotFound      As Long = NERR_BASE + 214
Private Const NERR_ExecFailure         As Long = NERR_BASE + 215
Private Const NERR_TmpFile             As Long = NERR_BASE + 216
Private Const NERR_TooMuchData         As Long = NERR_BASE + 217
Private Const NERR_DeviceShareConflict As Long = NERR_BASE + 218
Private Const NERR_BrowserTableIncomplete As Long = NERR_BASE + 219
Private Const NERR_NotLocalDomain      As Long = NERR_BASE + 220
Private Const NERR_IsDfsShare          As Long = NERR_BASE + 221
Private Const NERR_DevInvalidOpCode    As Long = NERR_BASE + 231
Private Const NERR_DevNotFound         As Long = NERR_BASE + 232
Private Const NERR_DevNotOpen          As Long = NERR_BASE + 233
Private Const NERR_BadQueueDevString   As Long = NERR_BASE + 234
Private Const NERR_BadQueuePriority    As Long = NERR_BASE + 235
Private Const NERR_NoCommDevs          As Long = NERR_BASE + 237
Private Const NERR_QueueNotFound       As Long = NERR_BASE + 238
Private Const NERR_BadDevString        As Long = NERR_BASE + 240
Private Const NERR_BadDev              As Long = NERR_BASE + 241
Private Const NERR_InUseBySpooler      As Long = NERR_BASE + 242
Private Const NERR_CommDevInUse        As Long = NERR_BASE + 243
Private Const NERR_InvalidComputer     As Long = NERR_BASE + 251
Private Const NERR_MaxLenExceeded      As Long = NERR_BASE + 254
Private Const NERR_BadComponent        As Long = NERR_BASE + 256
Private Const NERR_CantType            As Long = NERR_BASE + 257
Private Const NERR_TooManyEntries      As Long = NERR_BASE + 262
Private Const NERR_ProfileFileTooBig   As Long = NERR_BASE + 270
Private Const NERR_ProfileOffset       As Long = NERR_BASE + 271
Private Const NERR_ProfileCleanup      As Long = NERR_BASE + 272
Private Const NERR_ProfileUnknownCmd   As Long = NERR_BASE + 273
Private Const NERR_ProfileLoadErr      As Long = NERR_BASE + 274
Private Const NERR_ProfileSaveErr      As Long = NERR_BASE + 275
Private Const NERR_LogOverflow         As Long = NERR_BASE + 277
Private Const NERR_LogFileChanged      As Long = NERR_BASE + 278
Private Const NERR_LogFileCorrupt      As Long = NERR_BASE + 279
Private Const NERR_SourceIsDir         As Long = NERR_BASE + 280
Private Const NERR_BadSource           As Long = NERR_BASE + 281
Private Const NERR_BadDest             As Long = NERR_BASE + 282
Private Const NERR_DifferentServers    As Long = NERR_BASE + 283
Private Const NERR_RunSrvPaused        As Long = NERR_BASE + 285
Private Const NERR_ErrCommRunSrv       As Long = NERR_BASE + 289
Private Const NERR_ErrorExecingGhost   As Long = NERR_BASE + 291
Private Const NERR_ShareNotFound       As Long = NERR_BASE + 292
Private Const NERR_InvalidLana         As Long = NERR_BASE + 300
Private Const NERR_OpenFiles           As Long = NERR_BASE + 301
Private Const NERR_ActiveConns         As Long = NERR_BASE + 302
Private Const NERR_BadPasswordCore     As Long = NERR_BASE + 303
Private Const NERR_DevInUse            As Long = NERR_BASE + 304
Private Const NERR_LocalDrive          As Long = NERR_BASE + 305
Private Const NERR_AlertExists         As Long = NERR_BASE + 330
Private Const NERR_TooManyAlerts       As Long = NERR_BASE + 331
Private Const NERR_NoSuchAlert         As Long = NERR_BASE + 332
Private Const NERR_BadRecipient        As Long = NERR_BASE + 333
Private Const NERR_AcctLimitExceeded   As Long = NERR_BASE + 334
Private Const NERR_InvalidLogSeek      As Long = NERR_BASE + 340
Private Const NERR_BadUasConfig        As Long = NERR_BASE + 350
Private Const NERR_InvalidUASOp        As Long = NERR_BASE + 351
Private Const NERR_LastAdmin           As Long = NERR_BASE + 352
Private Const NERR_DCNotFound          As Long = NERR_BASE + 353
Private Const NERR_LogonTrackingError  As Long = NERR_BASE + 354
Private Const NERR_NetlogonNotStarted  As Long = NERR_BASE + 355
Private Const NERR_CanNotGrowUASFile   As Long = NERR_BASE + 356
Private Const NERR_TimeDiffAtDC        As Long = NERR_BASE + 357
Private Const NERR_PasswordMismatch    As Long = NERR_BASE + 358
Private Const NERR_NoSuchServer        As Long = NERR_BASE + 360
Private Const NERR_NoSuchSession       As Long = NERR_BASE + 361
Private Const NERR_NoSuchConnection    As Long = NERR_BASE + 362
Private Const NERR_TooManyServers      As Long = NERR_BASE + 363
Private Const NERR_TooManySessions     As Long = NERR_BASE + 364
Private Const NERR_TooManyConnections  As Long = NERR_BASE + 365
Private Const NERR_TooManyFiles        As Long = NERR_BASE + 366
Private Const NERR_NoAlternateServers  As Long = NERR_BASE + 367
Private Const NERR_UPSDriverNotStarted As Long = NERR_BASE + 380
Private Const NERR_UPSInvalidConfig    As Long = NERR_BASE + 381
Private Const NERR_UPSInvalidCommPort  As Long = NERR_BASE + 382
Private Const NERR_UPSSignalAsserted   As Long = NERR_BASE + 383
Private Const NERR_UPSShutdownFailed   As Long = NERR_BASE + 384
Private Const NERR_BadDosRetCode       As Long = NERR_BASE + 400
Private Const NERR_ProgNeedsExtraMem   As Long = NERR_BASE + 401
Private Const NERR_BadDosFunction      As Long = NERR_BASE + 402
Private Const NERR_RemoteBootFailed    As Long = NERR_BASE + 403
Private Const NERR_BadFileCheckSum     As Long = NERR_BASE + 404
Private Const NERR_NoRplBootSystem     As Long = NERR_BASE + 405
Private Const NERR_RplLoadrNetBiosErr  As Long = NERR_BASE + 406
Private Const NERR_RplLoadrDiskErr     As Long = NERR_BASE + 407
Private Const NERR_ImageParamErr       As Long = NERR_BASE + 408
Private Const NERR_TooManyImageParams  As Long = NERR_BASE + 409
Private Const NERR_NonDosFloppyUsed    As Long = NERR_BASE + 410
Private Const NERR_RplBootRestart      As Long = NERR_BASE + 411
Private Const NERR_RplSrvrCallFailed   As Long = NERR_BASE + 412
Private Const NERR_CantConnectRplSrvr  As Long = NERR_BASE + 413
Private Const NERR_CantOpenImageFile   As Long = NERR_BASE + 414
Private Const NERR_CallingRplSrvr      As Long = NERR_BASE + 415
Private Const NERR_StartingRplBoot     As Long = NERR_BASE + 416
Private Const NERR_RplBootServiceTerm  As Long = NERR_BASE + 417
Private Const NERR_RplBootStartFailed  As Long = NERR_BASE + 418
Private Const NERR_RPL_CONNECTED       As Long = NERR_BASE + 419
Private Const NERR_BrowserConfiguredToNotRun As Long = NERR_BASE + 450
Private Const NERR_RplNoAdaptersStarted      As Long = NERR_BASE + 510
Private Const NERR_RplBadRegistry      As Long = NERR_BASE + 511
Private Const NERR_RplBadDatabase      As Long = NERR_BASE + 512
Private Const NERR_RplRplfilesShare    As Long = NERR_BASE + 513
Private Const NERR_RplNotRplServer     As Long = NERR_BASE + 514
Private Const NERR_RplCannotEnum       As Long = NERR_BASE + 515
Private Const NERR_RplWkstaInfoCorrupted     As Long = NERR_BASE + 516
Private Const NERR_RplWkstaNotFound          As Long = NERR_BASE + 517
Private Const NERR_RplWkstaNameUnavailable   As Long = NERR_BASE + 518
Private Const NERR_RplProfileInfoCorrupted   As Long = NERR_BASE + 519
Private Const NERR_RplProfileNotFound        As Long = NERR_BASE + 520
Private Const NERR_RplProfileNameUnavailable As Long = NERR_BASE + 521
Private Const NERR_RplProfileNotEmpty        As Long = NERR_BASE + 522
Private Const NERR_RplConfigInfoCorrupted    As Long = NERR_BASE + 523
Private Const NERR_RplConfigNotFound         As Long = NERR_BASE + 524
Private Const NERR_RplAdapterInfoCorrupted   As Long = NERR_BASE + 525
Private Const NERR_RplInternal               As Long = NERR_BASE + 526
Private Const NERR_RplVendorInfoCorrupted    As Long = NERR_BASE + 527
Private Const NERR_RplBootInfoCorrupted      As Long = NERR_BASE + 528
Private Const NERR_RplWkstaNeedsUserAcct     As Long = NERR_BASE + 529
Private Const NERR_RplNeedsRPLUSERAcct       As Long = NERR_BASE + 530
Private Const NERR_RplBootNotFound           As Long = NERR_BASE + 531
Private Const NERR_RplIncompatibleProfile    As Long = NERR_BASE + 532
Private Const NERR_RplAdapterNameUnavailable As Long = NERR_BASE + 533
Private Const NERR_RplConfigNotEmpty         As Long = NERR_BASE + 534
Private Const NERR_RplBootInUse              As Long = NERR_BASE + 535
Private Const NERR_RplBackupDatabase         As Long = NERR_BASE + 536
Private Const NERR_RplAdapterNotFound        As Long = NERR_BASE + 537
Private Const NERR_RplVendorNotFound         As Long = NERR_BASE + 538
Private Const NERR_RplVendorNameUnavailable  As Long = NERR_BASE + 539
Private Const NERR_RplBootNameUnavailable    As Long = NERR_BASE + 540
Private Const NERR_RplConfigNameUnavailable  As Long = NERR_BASE + 541
Private Const NERR_DfsInternalCorruption     As Long = NERR_BASE + 560
Private Const NERR_DfsVolumeDataCorrupt      As Long = NERR_BASE + 561
Private Const NERR_DfsNoSuchVolume           As Long = NERR_BASE + 562
Private Const NERR_DfsVolumeAlreadyExists    As Long = NERR_BASE + 563
Private Const NERR_DfsAlreadyShared          As Long = NERR_BASE + 564
Private Const NERR_DfsNoSuchShare            As Long = NERR_BASE + 565
Private Const NERR_DfsNotALeafVolume         As Long = NERR_BASE + 566
Private Const NERR_DfsLeafVolume             As Long = NERR_BASE + 567
Private Const NERR_DfsVolumeHasMultipleServers  As Long = NERR_BASE + 568
Private Const NERR_DfsCantCreateJunctionPoint   As Long = NERR_BASE + 569
Private Const NERR_DfsServerNotDfsAware      As Long = NERR_BASE + 570
Private Const NERR_DfsBadRenamePath          As Long = NERR_BASE + 571
Private Const NERR_DfsVolumeIsOffline        As Long = NERR_BASE + 572
Private Const NERR_DfsNoSuchServer           As Long = NERR_BASE + 573
Private Const NERR_DfsCyclicalName           As Long = NERR_BASE + 574
Private Const NERR_DfsNotSupportedInServerDfs   As Long = NERR_BASE + 575
Private Const NERR_DfsInternalError          As Long = NERR_BASE + 590
Private Const NERR_SetupAlreadyJoined        As Long = NERR_BASE + 591
Private Const NERR_SetupNotJoined            As Long = NERR_BASE + 592
Private Const NERR_SetupDomainController     As Long = NERR_BASE + 593

' *******************************************************
' Routine Name : (PUBLIC in MODULE) Function Win9xNetErr
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Written : 09/23/2001 -- 12:38:01
' Inputs       : ByVal xi_lngErrNum:Long -
' Outputs      : String --
' Description  : Translate a Win9x Network error (2100 to
'              :     2999) into a text string
' Called By    : *****
' *******************************************************
Public Function Win9xNetErr(ByVal xi_lngErrNum As Long) As String

   Select Case xi_lngErrNum
      Case NERR_NetNotStarted
         Win9xNetErr = "The workstation driver is not installed."
      Case NERR_UnknownServer
         Win9xNetErr = "The server could not be located."
      Case NERR_ShareMem
         Win9xNetErr = "An internal error occurred.  The network cannot access a shared memory segment."
      Case NERR_NoNetworkResource
         Win9xNetErr = "A network resource shortage occurred ."
      Case NERR_RemoteOnly
         Win9xNetErr = "This operation is not supported on workstations."
      Case NERR_DevNotRedirected
         Win9xNetErr = "The device is not connected."
      Case NERR_ServerNotStarted
         Win9xNetErr = "The Server service is not started."
      Case NERR_ItemNotFound
         Win9xNetErr = "The queue is empty."
      Case NERR_UnknownDevDir
         Win9xNetErr = "The device or directory does not exist."
      Case NERR_RedirectedPath
         Win9xNetErr = "The operation is invalid on a redirected resource."
      Case NERR_DuplicateShare
         Win9xNetErr = "The name has already been shared."
      Case NERR_NoRoom
         Win9xNetErr = "The server is currently out of the requested resource."
      Case NERR_TooManyItems
         Win9xNetErr = "Requested addition of items exceeds the maximum allowed."
      Case NERR_InvalidMaxUsers
         Win9xNetErr = "The Peer service supports only two simultaneous users."
      Case NERR_BufTooSmall
         Win9xNetErr = "The API return buffer is too small."
      Case NERR_RemoteErr
         Win9xNetErr = "A remote API error occurred. "
      Case NERR_LanmanIniError
         Win9xNetErr = "An error occurred when opening or reading the configuration file."
      Case NERR_NetworkError
         Win9xNetErr = "A general network error occurred."
      Case NERR_WkstaInconsistentState
         Win9xNetErr = "The Workstation service is in an inconsistent state. Restart the computer before restarting the Workstation service."
      Case NERR_WkstaNotStarted
         Win9xNetErr = "The Workstation service has not been started."
      Case NERR_BrowserNotStarted
         Win9xNetErr = "The requested information is not available."
      Case NERR_InternalError
         Win9xNetErr = "An internal Windows NT error occurred."
      Case NERR_BadTransactConfig
         Win9xNetErr = "The server is not configured for transactions."
      Case NERR_InvalidAPI
         Win9xNetErr = "The requested API is not supported on the remote server."
      Case NERR_BadEventName
         Win9xNetErr = "The event name is invalid."
      Case NERR_DupNameReboot
         Win9xNetErr = "The computer name already exists on the network. Change it and restart the computer."
      Case NERR_CfgCompNotFound
         Win9xNetErr = "The specified component could not be found in the configuration information."
      Case NERR_CfgParamNotFound
         Win9xNetErr = "The specified parameter could not be found in the configuration information."
      Case NERR_LineTooLong
         Win9xNetErr = "A line in the configuration file is too long."
      Case NERR_QNotFound
         Win9xNetErr = "The printer does not exist."
      Case NERR_JobNotFound
         Win9xNetErr = "The print job does not exist."
      Case NERR_DestNotFound
         Win9xNetErr = "The printer destination cannot be found."
      Case NERR_DestExists
         Win9xNetErr = "The printer destination already exists."
      Case NERR_QExists
         Win9xNetErr = "The printer queue already exists."
      Case NERR_QNoRoom
         Win9xNetErr = "No more printers can be added."
      Case NERR_JobNoRoom
         Win9xNetErr = "No more print jobs can be added. "
      Case NERR_DestNoRoom
         Win9xNetErr = "No more printer destinations can be added."
      Case NERR_DestIdle
         Win9xNetErr = "This printer destination is idle and cannot accept control operations."
      Case NERR_DestInvalidOp
         Win9xNetErr = "This printer destination request contains an invalid control function."
      Case NERR_ProcNoRespond
         Win9xNetErr = "The print processor is not responding."
      Case NERR_SpoolerNotLoaded
         Win9xNetErr = "The spooler is not running."
      Case NERR_DestInvalidState
         Win9xNetErr = "This operation cannot be performed on the print destination in its current state."
      Case NERR_QInvalidState
         Win9xNetErr = "This operation cannot be performed on the printer queue in its current state."
      Case NERR_JobInvalidState
         Win9xNetErr = "This operation cannot be performed on the print job in its current state."
      Case NERR_SpoolNoMemory
         Win9xNetErr = "A spooler memory allocation failure occurred."
      Case NERR_DriverNotFound
         Win9xNetErr = "The device driver does not exist."
      Case NERR_DataTypeInvalid
         Win9xNetErr = "The data type is not supported by the print processor."
      Case NERR_ProcNotFound
         Win9xNetErr = "The print processor is not installed."
      Case NERR_ServiceTableLocked
         Win9xNetErr = "The service database is locked."
      Case NERR_ServiceTableFull
         Win9xNetErr = "The service table is full."
      Case NERR_ServiceInstalled
         Win9xNetErr = "The requested service has already been started."
      Case NERR_ServiceEntryLocked
         Win9xNetErr = "The service does not respond to control actions."
      Case NERR_ServiceNotInstalled
         Win9xNetErr = "The service has not been started."
      Case NERR_BadServiceName
         Win9xNetErr = "The service name is invalid."
      Case NERR_ServiceCtlTimeout
         Win9xNetErr = "The service is not responding to the control function."
      Case NERR_ServiceCtlBusy
         Win9xNetErr = "The service control is busy."
      Case NERR_BadServiceProgName
         Win9xNetErr = "The configuration file contains an invalid service program name."
      Case NERR_ServiceNotCtrl
         Win9xNetErr = "The service could not be controlled in its present state."
      Case NERR_ServiceKillProc
         Win9xNetErr = "The service ended abnormally."
      Case NERR_ServiceCtlNotValid
         Win9xNetErr = "The requested pause or stop is not valid for this service."
      Case NERR_NotInDispatchTbl
         Win9xNetErr = "The service control dispatcher could not find the service name in the dispatch table."
      Case NERR_BadControlRecv
         Win9xNetErr = "The service control dispatcher pipe read failed."
      Case NERR_ServiceNotStarting
         Win9xNetErr = "A thread for the new service could not be created."
      Case NERR_AlreadyLoggedOn
         Win9xNetErr = "This workstation is already logged on to the local-area network."
      Case NERR_NotLoggedOn
         Win9xNetErr = "The workstation is not logged on to the local-area network."
      Case NERR_BadUsername
         Win9xNetErr = "The user name or group name parameter is invalid. "
      Case NERR_BadPassword
         Win9xNetErr = "The password parameter is invalid."
      Case NERR_UnableToAddName_W
         Win9xNetErr = "@W The logon processor did not add the message alias."
      Case NERR_UnableToAddName_F
         Win9xNetErr = "The logon processor did not add the message alias."
      Case NERR_UnableToDelName_W
         Win9xNetErr = "@W The logoff processor did not delete the message alias."
      Case NERR_UnableToDelName_F
         Win9xNetErr = "The logoff processor did not delete the message alias."
      Case NERR_LogonsPaused
         Win9xNetErr = "Network logons are paused."
      Case NERR_LogonServerConflict
         Win9xNetErr = "A centralized logon-server conflict occurred."
      Case NERR_LogonNoUserPath
         Win9xNetErr = "The server is configured without a valid user path."
      Case NERR_LogonScriptError
         Win9xNetErr = "An error occurred while loading or running the logon script."
      Case NERR_StandaloneLogon
         Win9xNetErr = "The logon server was not specified.  Your computer will be logged on as STANDALONE."
      Case NERR_LogonServerNotFound
         Win9xNetErr = "The logon server could not be found. "
      Case NERR_LogonDomainExists
         Win9xNetErr = "There is already a logon domain for this computer. "
      Case NERR_NonValidatedLogon
         Win9xNetErr = "The logon server could not validate the logon."
      Case NERR_ACFNotFound
         Win9xNetErr = "The security database could not be found."
      Case NERR_GroupNotFound
         Win9xNetErr = "The group name could not be found."
      Case NERR_UserNotFound
         Win9xNetErr = "The user name could not be found."
      Case NERR_ResourceNotFound
         Win9xNetErr = "The resource name could not be found. "
      Case NERR_GroupExists
         Win9xNetErr = "The group already exists."
      Case NERR_UserExists
         Win9xNetErr = "The user account already exists."
      Case NERR_ResourceExists
         Win9xNetErr = "The resource permission list already exists."
      Case NERR_NotPrimary
         Win9xNetErr = "This operation is only allowed on the primary domain controller of the domain."
      Case NERR_ACFNotLoaded
         Win9xNetErr = "The security database has not been started."
      Case NERR_ACFNoRoom
         Win9xNetErr = "There are too many names in the user accounts database."
      Case NERR_ACFFileIOFail
         Win9xNetErr = "A disk I/O failure occurred."
      Case NERR_ACFTooManyLists
         Win9xNetErr = "The limit of 64 entries per resource was exceeded."
      Case NERR_UserLogon
         Win9xNetErr = "Deleting a user with a session is not allowed."
      Case NERR_ACFNoParent
         Win9xNetErr = "The parent directory could not be located."
      Case NERR_CanNotGrowSegment
         Win9xNetErr = "Unable to add to the security database session cache segment."
      Case NERR_SpeGroupOp
         Win9xNetErr = "This operation is not allowed on this special group."
      Case NERR_NotInCache
         Win9xNetErr = "This user is not cached in user accounts database session cache."
      Case NERR_UserInGroup
         Win9xNetErr = "The user already belongs to this group."
      Case NERR_UserNotInGroup
         Win9xNetErr = "The user does not belong to this group."
      Case NERR_AccountUndefined
         Win9xNetErr = "This user account is undefined."
      Case NERR_AccountExpired
         Win9xNetErr = "This user account has expired."
      Case NERR_InvalidWorkstation
         Win9xNetErr = "The user is not allowed to log on from this workstation."
      Case NERR_InvalidLogonHours
         Win9xNetErr = "The user is not allowed to log on at this time. "
      Case NERR_PasswordExpired
         Win9xNetErr = "The password of this user has expired."
      Case NERR_PasswordCantChange
         Win9xNetErr = "The password of this user cannot change."
      Case NERR_PasswordHistConflict
         Win9xNetErr = "This password cannot be used now."
      Case NERR_PasswordTooShort
         Win9xNetErr = "The password is shorter than required."
      Case NERR_PasswordTooRecent
         Win9xNetErr = "The password of this user is too recent to change. "
      Case NERR_InvalidDatabase
         Win9xNetErr = "The security database is corrupted."
      Case NERR_DatabaseUpToDate
         Win9xNetErr = "No updates are necessary to this replicant network/local security database."
      Case NERR_SyncRequired
         Win9xNetErr = "This replicant database is outdated; synchronization is required."
      Case NERR_UseNotFound
         Win9xNetErr = "The network connection could not be found."
      Case NERR_BadAsgType
         Win9xNetErr = "This asg_type is invalid."
      Case NERR_DeviceIsShared
         Win9xNetErr = "This device is currently being shared."
      Case NERR_NoComputerName
         Win9xNetErr = "The computer name could not be added as a message alias.  The name may already exist on the network."
      Case NERR_MsgAlreadyStarted
         Win9xNetErr = "The Messenger service is already started."
      Case NERR_MsgInitFailed
         Win9xNetErr = "The Messenger service failed to start. "
      Case NERR_NameNotFound
         Win9xNetErr = "The message alias could not be found on the network."
      Case NERR_AlreadyForwarded
         Win9xNetErr = "This message alias has already been forwarded."
      Case NERR_AddForwarded
         Win9xNetErr = "This message alias has been added but is still forwarded."
      Case NERR_AlreadyExists
         Win9xNetErr = "This message alias already exists locally."
      Case NERR_TooManyNames
         Win9xNetErr = "The maximum number of added message aliases has been exceeded."
      Case NERR_DelComputerName
         Win9xNetErr = "The computer name could not be deleted."
      Case NERR_LocalForward
         Win9xNetErr = "Messages cannot be forwarded back to the same workstation."
      Case NERR_GrpMsgProcessor
         Win9xNetErr = "An error occurred in the domain message processor."
      Case NERR_PausedRemote
         Win9xNetErr = "The message was sent, but the recipient has paused the Messenger service."
      Case NERR_BadReceive
         Win9xNetErr = "The message was sent but not received."
      Case NERR_NameInUse
         Win9xNetErr = "The message alias is currently in use. Try again later."
      Case NERR_MsgNotStarted
         Win9xNetErr = "The Messenger service has not been started."
      Case NERR_NotLocalName
         Win9xNetErr = "The name is not on the local computer."
      Case NERR_NoForwardName
         Win9xNetErr = "The forwarded message alias could not be found on the network."
      Case NERR_RemoteFull
         Win9xNetErr = "The message alias table on the remote station is full."
      Case NERR_NameNotForwarded
         Win9xNetErr = "Messages for this alias are not currently being forwarded."
      Case NERR_TruncatedBroadcast
         Win9xNetErr = "The broadcast message was truncated."
      Case NERR_InvalidDevice
         Win9xNetErr = "This is an invalid device name."
      Case NERR_WriteFault
         Win9xNetErr = "A write fault occurred."
      Case NERR_DuplicateName
         Win9xNetErr = "A duplicate message alias exists on the network."
      Case NERR_DeleteLater
         Win9xNetErr = "@W This message alias will be deleted later."
      Case NERR_IncompleteDel
         Win9xNetErr = "The message alias was not successfully deleted from all networks."
      Case NERR_MultipleNets
         Win9xNetErr = "This operation is not supported on computers with multiple networks."
      Case NERR_NetNameNotFound
         Win9xNetErr = "This shared resource does not exist."
      Case NERR_DeviceNotShared
         Win9xNetErr = "This device is not shared."
      Case NERR_ClientNameNotFound
         Win9xNetErr = "A session does not exist with that computer name."
      Case NERR_FileIdNotFound
         Win9xNetErr = "There is not an open file with that identification number."
      Case NERR_ExecFailure
         Win9xNetErr = "A failure occurred when executing a remote administration command."
      Case NERR_TmpFile
         Win9xNetErr = "A failure occurred when opening a remote temporary file."
      Case NERR_TooMuchData
         Win9xNetErr = "The data returned from a remote administration command has been truncated to 64K."
      Case NERR_DeviceShareConflict
         Win9xNetErr = "This device cannot be shared as both a spooled and a non-spooled resource."
      Case NERR_BrowserTableIncomplete
         Win9xNetErr = "The information in the list of servers may be incorrect."
      Case NERR_NotLocalDomain
         Win9xNetErr = "The computer is not active in this domain."
      Case NERR_IsDfsShare
         Win9xNetErr = "The share must be removed from the Distributed File System before it can be deleted."
      Case NERR_DevInvalidOpCode
         Win9xNetErr = "The operation is invalid for this device."
      Case NERR_DevNotFound
         Win9xNetErr = "This device cannot be shared."
      Case NERR_DevNotOpen
         Win9xNetErr = "This device was not open."
      Case NERR_BadQueueDevString
         Win9xNetErr = "This device name list is invalid."
      Case NERR_BadQueuePriority
         Win9xNetErr = "The queue priority is invalid."
      Case NERR_NoCommDevs
         Win9xNetErr = "There are no shared communication devices."
      Case NERR_QueueNotFound
         Win9xNetErr = "The queue you specified does not exist."
      Case NERR_BadDevString
         Win9xNetErr = "This list of devices is invalid."
      Case NERR_BadDev
         Win9xNetErr = "The requested device is invalid."
      Case NERR_InUseBySpooler
         Win9xNetErr = "This device is already in use by the spooler."
      Case NERR_CommDevInUse
         Win9xNetErr = "This device is already in use as a communication device."
      Case NERR_InvalidComputer
         Win9xNetErr = "This computer name is invalid."
      Case NERR_MaxLenExceeded
         Win9xNetErr = "The string and prefix specified are too long."
      Case NERR_BadComponent
         Win9xNetErr = "This path component is invalid."
      Case NERR_CantType
         Win9xNetErr = "Could not determine the type of input."
      Case NERR_TooManyEntries
         Win9xNetErr = "The buffer for types is not big enough."
      Case NERR_ProfileFileTooBig
         Win9xNetErr = "Profile files cannot exceed 64K."
      Case NERR_ProfileOffset
         Win9xNetErr = "The start offset is out of range."
      Case NERR_ProfileCleanup
         Win9xNetErr = "The system cannot delete current connections to network resources."
      Case NERR_ProfileUnknownCmd
         Win9xNetErr = "The system was unable to parse the command line in this file."
      Case NERR_ProfileLoadErr
         Win9xNetErr = "An error occurred while loading the profile file."
      Case NERR_ProfileSaveErr
         Win9xNetErr = "@W Errors occurred while saving the profile file.  The profile was partially saved."
      Case NERR_LogOverflow
         Win9xNetErr = "Log file %1 is full."
      Case NERR_LogFileChanged
         Win9xNetErr = "This log file has changed between reads."
      Case NERR_LogFileCorrupt
         Win9xNetErr = "Log file %1 is corrupt."
      Case NERR_SourceIsDir
         Win9xNetErr = "The source path cannot be a directory."
      Case NERR_BadSource
         Win9xNetErr = "The source path is illegal."
      Case NERR_BadDest
         Win9xNetErr = "The destination path is illegal."
      Case NERR_DifferentServers
         Win9xNetErr = "The source and destination paths are on different servers."
      Case NERR_RunSrvPaused
         Win9xNetErr = "The Run server you requested is paused."
      Case NERR_ErrCommRunSrv
         Win9xNetErr = "An error occurred when communicating with a Run server."
      Case NERR_ErrorExecingGhost
         Win9xNetErr = "An error occurred when starting a background process."
      Case NERR_ShareNotFound
         Win9xNetErr = "The shared resource you are connected to could not be found."
      Case NERR_InvalidLana
         Win9xNetErr = "The LAN adapter number is invalid. "
      Case NERR_OpenFiles
         Win9xNetErr = "There are open files on the connection.   "
      Case NERR_ActiveConns
         Win9xNetErr = "Active connections still exist."
      Case NERR_BadPasswordCore
         Win9xNetErr = "This share name or password is invalid."
      Case NERR_DevInUse
         Win9xNetErr = "The device is being accessed by an active process."
      Case NERR_LocalDrive
         Win9xNetErr = "The drive letter is in use locally."
      Case NERR_AlertExists
         Win9xNetErr = "The specified client is already registered for the specified event."
      Case NERR_TooManyAlerts
         Win9xNetErr = "The alert table is full."
      Case NERR_NoSuchAlert
         Win9xNetErr = "An invalid or nonexistent alert name was raised."
      Case NERR_BadRecipient
         Win9xNetErr = "The alert recipient is invalid."
      Case NERR_AcctLimitExceeded
         Win9xNetErr = "A user's session with this server has been deleted because the user's logon hours are no longer valid."
      Case NERR_InvalidLogSeek
         Win9xNetErr = "The log file does not contain the requested record number."
      Case NERR_BadUasConfig
         Win9xNetErr = "The user accounts database is not configured correctly."
      Case NERR_InvalidUASOp
         Win9xNetErr = "This operation is not permitted when the Netlogon service is running."
      Case NERR_LastAdmin
         Win9xNetErr = "This operation is not allowed on the last administrative account."
      Case NERR_DCNotFound
         Win9xNetErr = "Could not find domain controller for this domain."
      Case NERR_LogonTrackingError
         Win9xNetErr = "Could not set logon information for this user."
      Case NERR_NetlogonNotStarted
         Win9xNetErr = "The Netlogon service has not been started."
      Case NERR_CanNotGrowUASFile
         Win9xNetErr = "Unable to add to the user accounts database."
      Case NERR_TimeDiffAtDC
         Win9xNetErr = "This server's clock is not synchronized with the primary domain controller's clock."
      Case NERR_PasswordMismatch
         Win9xNetErr = "A password mismatch has been detected."
      Case NERR_NoSuchServer
         Win9xNetErr = "The server identification does not specify a valid server."
      Case NERR_NoSuchSession
         Win9xNetErr = "The session identification does not specify a valid session."
      Case NERR_NoSuchConnection
         Win9xNetErr = "The connection identification does not specify a valid connection."
      Case NERR_TooManyServers
         Win9xNetErr = "There is no space for another entry in the table of available servers."
      Case NERR_TooManySessions
         Win9xNetErr = "The server has reached the maximum number of sessions it supports."
      Case NERR_TooManyConnections
         Win9xNetErr = "The server has reached the maximum number of connections it supports."
      Case NERR_TooManyFiles
         Win9xNetErr = "The server cannot open more files because it has reached its maximum number."
      Case NERR_NoAlternateServers
         Win9xNetErr = "There are no alternate servers registered on this server."
      Case NERR_UPSDriverNotStarted
         Win9xNetErr = "The UPS driver could not be accessed by the UPS service."
      Case NERR_UPSInvalidConfig
         Win9xNetErr = "The UPS service is not configured correctly."
      Case NERR_UPSInvalidCommPort
         Win9xNetErr = "The UPS service could not access the specified Comm Port."
      Case NERR_UPSSignalAsserted
         Win9xNetErr = "The UPS indicated a line fail or low battery situation. Service not started."
      Case NERR_UPSShutdownFailed
         Win9xNetErr = "The UPS service failed to perform a system shut down."
      Case NERR_BadDosRetCode
         Win9xNetErr = "The program below returned an MS-DOS error code:  "
      Case NERR_ProgNeedsExtraMem
         Win9xNetErr = "The program below needs more memory:  "
      Case NERR_BadDosFunction
         Win9xNetErr = "The program below called an unsupported MS-DOS function:  "
      Case NERR_RemoteBootFailed
         Win9xNetErr = "The workstation failed to boot."
      Case NERR_BadFileCheckSum
         Win9xNetErr = "The file below is corrupt."
      Case NERR_NoRplBootSystem
         Win9xNetErr = "No loader is specified in the boot-block definition file."
      Case NERR_RplLoadrNetBiosErr
         Win9xNetErr = "NetBIOS returned an error: The NCB and SMB are dumped above."
      Case NERR_RplLoadrDiskErr
         Win9xNetErr = "A disk I/O error occurred."
      Case NERR_ImageParamErr
         Win9xNetErr = "Image parameter substitution failed."
      Case NERR_TooManyImageParams
         Win9xNetErr = "Too many image parameters cross disk sector boundaries."
      Case NERR_NonDosFloppyUsed
         Win9xNetErr = "The image was not generated from an MS-DOS diskette formatted with /S."
      Case NERR_RplBootRestart
         Win9xNetErr = "Remote boot will be restarted later."
      Case NERR_RplSrvrCallFailed
         Win9xNetErr = "The call to the Remoteboot server failed."
      Case NERR_CantConnectRplSrvr
         Win9xNetErr = "Cannot connect to the Remoteboot server."
      Case NERR_CantOpenImageFile
         Win9xNetErr = "Cannot open image file on the Remoteboot server."
      Case NERR_CallingRplSrvr
         Win9xNetErr = "Connecting to the Remoteboot server..."
      Case NERR_StartingRplBoot
         Win9xNetErr = "Connecting to the Remoteboot server..."
      Case NERR_RplBootServiceTerm
         Win9xNetErr = "Remote boot service was stopped; check the error log for the cause of the problem."
      Case NERR_RplBootStartFailed
         Win9xNetErr = "Remote boot startup failed; check the error log for the cause of the problem."
      Case NERR_RPL_CONNECTED
         Win9xNetErr = "A second connection to a Remoteboot resource is not allowed."
      Case NERR_BrowserConfiguredToNotRun
         Win9xNetErr = "The browser service was configured with MaintainServerList As Long = No."
      Case NERR_RplNoAdaptersStarted
         Win9xNetErr = "Service failed to start since none of the network adapters started with this service."
      Case NERR_RplBadRegistry
         Win9xNetErr = "Service failed to start due to bad startup information in the registry."
      Case NERR_RplBadDatabase
         Win9xNetErr = "Service failed to start because its database is absent or corrupt."
      Case NERR_RplRplfilesShare
         Win9xNetErr = "Service failed to start because RPLFILES share is absent."
      Case NERR_RplNotRplServer
         Win9xNetErr = "Service failed to start because RPLUSER group is absent."
      Case NERR_RplCannotEnum
         Win9xNetErr = "Cannot enumerate service records."
      Case NERR_RplWkstaInfoCorrupted
         Win9xNetErr = "Workstation record information has been corrupted."
      Case NERR_RplWkstaNotFound
         Win9xNetErr = "Workstation record was not found."
      Case NERR_RplWkstaNameUnavailable
         Win9xNetErr = "Workstation name is in use by some other workstation."
      Case NERR_RplProfileInfoCorrupted
         Win9xNetErr = "Profile record information has been corrupted."
      Case NERR_RplProfileNotFound
         Win9xNetErr = "Profile record was not found."
      Case NERR_RplProfileNameUnavailable
         Win9xNetErr = "Profile name is in use by some other profile."
      Case NERR_RplProfileNotEmpty
         Win9xNetErr = "There are workstations using this profile."
      Case NERR_RplConfigInfoCorrupted
         Win9xNetErr = "Configuration record information has been corrupted."
      Case NERR_RplConfigNotFound
         Win9xNetErr = "Configuration record was not found."
      Case NERR_RplAdapterInfoCorrupted
         Win9xNetErr = "Adapter id record information has been corrupted."
      Case NERR_RplInternal
         Win9xNetErr = "An internal service error has occurred."
      Case NERR_RplVendorInfoCorrupted
         Win9xNetErr = "Vendor id record information has been corrupted."
      Case NERR_RplBootInfoCorrupted
         Win9xNetErr = "Boot block record information has been corrupted."
      Case NERR_RplWkstaNeedsUserAcct
         Win9xNetErr = "The user account for this workstation record is missing."
      Case NERR_RplNeedsRPLUSERAcct
         Win9xNetErr = "The RPLUSER local group could not be found."
      Case NERR_RplBootNotFound
         Win9xNetErr = "Boot block record was not found."
      Case NERR_RplIncompatibleProfile
         Win9xNetErr = "Chosen profile is incompatible with this workstation."
      Case NERR_RplAdapterNameUnavailable
         Win9xNetErr = "Chosen network adapter id is in use by some other workstation."
      Case NERR_RplConfigNotEmpty
         Win9xNetErr = "There are profiles using this configuration."
      Case NERR_RplBootInUse
         Win9xNetErr = "There are workstations, profiles or configurations using this boot block."
      Case NERR_RplBackupDatabase
         Win9xNetErr = "Service failed to backup Remoteboot database."
      Case NERR_RplAdapterNotFound
         Win9xNetErr = "Adapter record was not found."
      Case NERR_RplVendorNotFound
         Win9xNetErr = "Vendor record was not found."
      Case NERR_RplVendorNameUnavailable
         Win9xNetErr = "Vendor name is in use by some other vendor record."
      Case NERR_RplBootNameUnavailable
         Win9xNetErr = "(boot name, vendor id) is in use by some other boot block record."
      Case NERR_RplConfigNameUnavailable
         Win9xNetErr = "Configuration name is in use by some other configuration."
      Case NERR_DfsInternalCorruption
         Win9xNetErr = "The internal database maintained by the Dfs service is corrupt  "
      Case NERR_DfsVolumeDataCorrupt
         Win9xNetErr = "One of the records in the internal Dfs database is corrupt  "
      Case NERR_DfsNoSuchVolume
         Win9xNetErr = "There is no volume whose entry path matches the input Entry Path  "
      Case NERR_DfsVolumeAlreadyExists
         Win9xNetErr = "A volume with the given name already exists  "
      Case NERR_DfsAlreadyShared
         Win9xNetErr = "The server share specified is already shared in the Dfs  "
      Case NERR_DfsNoSuchShare
         Win9xNetErr = "The indicated server share does not support the indicated Dfs volume  "
      Case NERR_DfsNotALeafVolume
         Win9xNetErr = "The operation is not valid on a non-leaf volume  "
      Case NERR_DfsLeafVolume
         Win9xNetErr = "The operation is not valid on a leaf volume  "
      Case NERR_DfsVolumeHasMultipleServers
         Win9xNetErr = "The operation is ambiguous because the volume has multiple servers  "
      Case NERR_DfsCantCreateJunctionPoint
         Win9xNetErr = "Unable to create a junction point  "
      Case NERR_DfsServerNotDfsAware
         Win9xNetErr = "The server is not Dfs Aware  "
      Case NERR_DfsBadRenamePath
         Win9xNetErr = "The specified rename target path is invalid  "
      Case NERR_DfsVolumeIsOffline
         Win9xNetErr = "The specified Dfs volume is offline  "
      Case NERR_DfsNoSuchServer
         Win9xNetErr = "The specified server is not a server for this volume  "
      Case NERR_DfsCyclicalName
         Win9xNetErr = "A cycle in the Dfs name was detected  "
      Case NERR_DfsNotSupportedInServerDfs
         Win9xNetErr = "The operation is not supported on a server-based Dfs  "
      Case NERR_DfsInternalError
         Win9xNetErr = "Dfs internal error  "
      Case NERR_SetupAlreadyJoined
         Win9xNetErr = "This machine is already joined to a domain."
      Case NERR_SetupNotJoined
         Win9xNetErr = "This machine is not currently joined to a domain."
      Case NERR_SetupDomainController
         Win9xNetErr = "This machine is a domain controller and cannot be unjoined from a domain."
   
      Case Else
         Win9xNetErr = "UNKNOWN Win9x Network error"
         
   End Select
   
End Function
